#!/bin/bash
PATH=/bin:/usr/bin:/sbin:/usr/sbin:$PATH
export LOGIN_ID="root"
export ROLE_ID="root"
export TERMINFO="/usr/share/terminfo"
export CURRENT_AD="0"
export SWLOGNAME="root"
export AUTH_TYPE="0"


cfgfile=/etc/fabos/jitc.conf
[ -n $1 -a -f $1 ] && setfile=$1
op=$2

setcfg()
{
	case $1 in
	dadaccept)
		if [ $[`cat /proc/sys/net/ipv6/conf/eth0/accept_dad`] -ne $[$2] ]; then
			echo $2 > /proc/sys/net/ipv6/conf/eth0/accept_dad
		fi
		;;		
	dadretransmit)
		if [ $[`cat /proc/sys/net/ipv6/conf/eth0/dad_transmits`] -ne $[$2] ]; then
			echo $2 > /proc/sys/net/ipv6/conf/eth0/dad_transmits
		fi
		;;
	dadns)
		if [ $[`cat /proc/sys/net/ipv6/neigh/eth0/app_solicit`] -ne $[$2] ]; then
			echo $2 > /proc/sys/net/ipv6/neigh/eth0/app_solicit
		fi
		;;
	ipv6)
		if [ $[`cat /proc/sys/net/ipv6/conf/eth0/disable_ipv6`] -ne $[$2] ]; then
			echo $2 > /proc/sys/net/ipv6/conf/eth0/disable_ipv6
		fi
		;;
	ipv6mtu)
		mtu=$[`cat /proc/sys/net/ipv6/conf/eth0/mtu`]
		[ $mtu -ne $[$2] ] && echo $2 > /proc/sys/net/ipv6/conf/eth0/mtu
		;;
	removejitcconfig)
		rm -fr $cfgfile /mnt$cfgfile $setfile /mnt$setfile
		sync; /fabos/cliexec/reboot -f -s -r ChassisReboot
		;;
	*)
		echo key $1 is not found
	esac
}

parser1()
{
	[ ${adata[0]} -ne 1 ] && return
	if [ -f $cfgfile ]; then
		data=(`cat $cfgfile`)
	else
		data=(1 dadaccept 1 dadretransmit 1 dadns 0 firewall 1 ipv6mtu 1500) 
	fi

	dirty=0
	for ((i=1; i<${#adata[@]}; i+=2)); do
		[ -z "$op" -o "$op" != "no-op" ] && setcfg ${adata[$i]} ${adata[$i+1]}
		for ((j=1; j<${#data[@]}; j+=2)); do
			if [ ${adata[$i]} = ${data[$j]} ]; then
				if [ ! ${adata[$i+1]} = ${data[$j+1]} ]; then
					data[$j+1]=${adata[$i+1]}
					dirty=1
				fi
				break
			fi
		done
	done

	# update $cfgfile when modified or first created
	if [ $dirty -eq 1 -o ! -f $cfgfile ]; then
		echo ${data[@]} > $cfgfile && cp $cfgfile /mnt$cfgfile
	fi
}

if [ -z $setfile ]; then
	if [ -f $cfgfile ]; then
		setfile=$cfgfile
	else
		exit 0
	fi
fi
adata=(`cat $setfile`)
case ${adata[0]} in
	1)
	parser1
	;;
	*)
	echo jitc config file $setfile veriosn = ${adata[0]}, not supported!
esac
exit 0
