#!/bin/sh
#
#    Copyright (c) 2010 Brocade Communications Systems, Inc.
#    All rights reserved.
#
#    File name:   ssave_fwdSS.sh.in
#    Module name: utils/support
#
#    This file expected to be invoked by supportsave infrastructure to collect FOS/NOS fwd
#    related data for switch post failure analysis
#
#
PATH=/bin:/usr/bin:/usr/sbin:/fabos/bin:/fabos/link_bin:
ssaveutil="/fabos/cliexec/ssave_util.sh"

#
#include ssave utility
#
if [ -e "$ssaveutil" ]
then
    . $ssaveutil
#    echo "exe $ssaveutil"
    rc=$?
    if [ $rc -ne 0 ]
    then
      echo "exe:$ssaveutil err=$rc"
      exit 3
    fi

else
    echo "Error -- could not locate ssave common library $ssaveutil"
    exit 3
fi

# *******************************************
# Collect fw data
# *******************************************
# *******************************************
# Collect FW
# *******************************************
#FWSWITCH,/fabos/bin/fwshow --dumpall, , ,Y,Y,N,Y,Y,2,
# *******************************************
start_fw()
{
    #cmd_title "fwshow --dumpall"
    #$CHASSISCMD /fabos/bin/fwshow --dumpall

    $SWITCHCMD /fabos/cliexec/fwshow

    for i in `seq 0 7`
    do
        if [ -f /tmp/fwShowDebug.$i ]; then
            $CHASSISCMD /bin/cat /tmp/fwShowDebug.$i
            /bin/rm -f /tmp/fwShowDebug.$i
        else
            $ECHO "FWSHOW Debug file /tmp/fwShowDebug.$i is empty or does not exist."
        fi
    done

    if [ -f /etc/mail/sendmail.cf ]; then
        $CHASSISCMD /bin/cat /etc/mail/sendmail.cf | grep DS
    else
    $ECHO "sendmail.cf file is empty or does not exist."
    fi

    if [ -f /etc/resolv.conf ]; then
        $CHASSISCMD /bin/cat /etc/resolv.conf
    else
    $ECHO "Domain Name Server not configured."
    fi
}



############## main

  $EXEC_GROUP start_fw

  exit $RETVAL

