#!/bin/sh
PATH=/bin:/usr/bin:/usr/sbin:/fabos/bin:/fabos/link_bin:

#set ROLE to root pass remaining RBAC checks. Don't do it before rbac_check
export ROLE_ID=root

CHASSISCMD=""
#TTY="/dev/null"
TTY=$(tty)
if [ "$TTY" = "not a tty" ]
then
	TTY="/dev/null"
fi
newline=0
cliidx=0
log=/var/log/ssave.sh.log
retval=0
ECHO="echo"

ssavecomm="/fabos/cliexec/ssave_util.sh"
#
#include ssave utility
#
if [ -e "$ssavecomm" ]
then
    . $ssavecomm
    rc=$?
    if [ $rc -ne 0 ]
    then
      echo "Error -- $ssavecomm err=$rc"
    fi
else
    echo "Error -- could not locate $ssavecomm"
    exit 3
fi

#
# copied from /fabos/src/setup/profile
#
setcontext()
{
    if [ "$1" != "chassis" ]
    then
		export FABOS_SWITCHNO=$2
		export CURRENT_VF=$1
		export CHASSIS_ROLEID=0
    else
		export FABOS_SWITCHNO=-1
		export CURRENT_VF=255
		export CHASSIS_ROLEID=0
    fi
	export ROLE_ID=root
}

#
# debug routine to show time for each CLI
#
#
cmd_nonvf() {
	   
     $ECHO "********************************************************"
     clicmd=${1##*/}
     $ECHO -e "$clicmd $2 $3 $4 $5 $6 $7 $8 $9:"
     $ECHO "********************************************************"
#     $ECHO -n . > $TTY
     #$ECHO  "$i@:" > $TTY
     let cliidx++
     $ECHO "$cliidx $@"  >> $log
     $ECHO -e "$@:"	 
     time $@
     rc=$?
     if [ $rc -ne 0 ] 
     then
	$ECHO "** $@: Command:$rc **" >> $log
     fi
     $ECHO ""
}

cmd_chassis()
{
  setcontext chassis
     $ECHO "********************************************************"
     clicmd=${1##*/}
     $ECHO -e "$clicmd $2 $3 $4 $5 $6 $7 $8 $9:"
     $ECHO "********************************************************"
    $ECHO -n . > $TTY
	newline=1
    #$ECHO  "$@:" > $TTY
    let cliidx++
    $ECHO "$cliidx $@" >> $log
    $ECHO -e "$@:"	
    time $@
    rc=$?
    if [ $rc -ne 0 ]
    then
      $ECHO "** $@: Command:$rc **" >> $log
    fi
    $ECHO ""
}

#
# cmd to iterate through all switch instances
#
#
cmd_iterate_all()
{
	$SSCMD $@ "--sscommand=3" -l$log -a -i$TTY
	newline=1
}

cmd_title()
{
/bin/echo "********************************************************"
/bin/echo $1
/bin/echo "********************************************************"
}

group_show() {
    $ECHO "********************************************************"
    $ECHO $1
    $ECHO "********************************************************"
    $ECHO "********************************************************" >> $log
    $ECHO $1 >> $log
    $ECHO "********************************************************" >> $log
    date  >> $log
    cliidx=0
    time $1
    date  >> $log
	$ECHO "********************************************************"
	$ECHO "loadavg"
	$ECHO "********************************************************"
	/bin/cat /proc/loadavg
	$ECHO "********************************************************"
	$ECHO "vmstat"
	$ECHO "********************************************************"
	vmstat
	$ECHO "********************************************************"
	$ECHO "/tmp usage"
	$ECHO "********************************************************"
	du -h /tmp
    $ECHO "**** End $1 group ****" >> $log
}


# *******************************************
# Collect  FCIP blade port info supportsave data
# *******************************************
function get_fcip_port_info()
{
    if [ -d /proc/fabos/blade/0 ]
    then
    	$ECHO "Mini-chassis system"
	
    	cmd_title "info :"
	$CHASSISCMD /bin/cat /proc/fabos/blade/0/info
    	/bin/echo ""

	
    	cmd_title "pt_prop :"
	$CHASSISCMD /bin/cat /proc/fabos/blade/0/pt_prop
    	/bin/echo ""
     else 
     	$ECHO "chassis"
	/fabos/link_bin/slotshow | grep "75" | cut -d ' ' -f3 >> /tmp/tmp_file
	for slot in `cat /tmp/tmp_file`
	do
    	    $ECHO "slot-$slot-info :"
	    $CHASSISCMD /bin/cat /proc/fabos/blade/$slot/info 
    	    $EHCO "slot-$slot-pt_prop :"
	    $CHASSISCMD /bin/cat /proc/fabos/blade/$slot/pt_prop 
	done
     fi		
     
     if [ -f /tmp/tmp_file ]
     then
         rm -f /tmp/tmp_file
     else
         $ECHO "/tmp/tmp_file do not exit"
    	$ECHO ""
     fi 
	 
     
}


# *******************************************
# Collect fabric service
# *******************************************
# ZONE_LOG,/fabos/cliexec/zone evlogshow, , ,Y,Y,Y,Y,Y,1,
# RCS_LOG,/fabos/cliexec/rcscmd logshow, , ,Y,Y,Y,Y,N,1,
# NS_EVLOG,/fabos/cliexec/ns allevlog, , ,Y,Y,Y,Y,Y,1,
# FSPF_LOG,/fabos/bin/fspfstateshow , , ,Y,Y,N,Y,Y,1,
# MSDUMP,/fabos/cliexec/ms dump, , ,Y,N,N,Y,Y,1,
# *******************************************
start_fabric_service()
{
    $SWITCHCMD /fabos/cliexec/zone evlogshow

    $SWITCHCMD /fabos/cliexec/rcscmd logshow

    $SWITCHCMD /fabos/cliexec/ns allevlog

    $CHASSISCMD /fabos/bin/fspfstateshow

    if [ $standby = no ]
      then
	  $CHASSISCMD  /fabos/cliexec/ms dump
    fi
}


# *******************************************
# Collect diag
# *******************************************
#DIAGLOG,/bin/cat /tmp/post* /var/log/verify* /var/log/burnin*, , ,Y,Y,N,N,Y,2,
#BURNINSTAT,/fabos/link_sbin/burninstatus, , ,N,N,N,Y,Y,2,
#BURNINERR,/fabos/link_bin/burninerrshow, , ,Y,N,N,Y,Y,2,
# *******************************************
start_diag()
{
    $CHASSISCMD /bin/cat /tmp/post*

    $CHASSISCMD  /bin/cat /var/log/verify*

    $CHASSISCMD  /bin/cat /var/log/burnin*
    
    if [ $standby = no ]
    then
      $CHASSISCMD /fabos/sbin/burninstatus

      $CHASSISCMD  /fabos/bin/burninerrshow
    fi
}

# *******************************************
# Collect VF
# *******************************************
#VFCHASSISCMD,/fabos/bin/vfchassis_port_map, , ,Y,Y,N,Y,Y,2,
#VFSWITCH,/fabos/bin/vfswitch_port_info, , ,Y,Y,N,Y,Y,2,
# *******************************************
start_vf()
{
    $CHASSISCMD /fabos/bin/vfchassis_port_map

    $CHASSISCMD  /fabos/bin/vfswitch_port_info
}

start_asic_db_cmd() {

	# Do not dump database on standby CP.
	if [ $standby = yes ]
	then
		return
	fi

  # Capture the error counters across two polling interval.
##	sloterrshow -c2 -r


  # If db script not present, can't dump database
	if [ ! -e /fabos/link_sbin/db ]; then
		return 
	fi

  export DB_SILENT_ERR=1
  cd /proc/fabos/blade
  regdumpcount=0
  c3regdumpcount=0
  c1regdmpcnt=0
  for i in `ls -d [0-9]* | sort -n` ; do
	#
	# no shell cmd should intervene between asic_db_blade_type and 
	# check for return status stored in $?.
	# Note: "db" work on proc path slot#/mini#/chip#
	# This script assumes the following for ALL blade type.
	# The script has to be modified if the assumption becomes false.
    # 1) The following chip assigment per miniswitch
		# chip# = 0 => condor
		# chip# = 1 => pinball
		# chip# = 2 => flipper
	# 2) each mini has only 1 instance of a certain asic.

	# Capture bladeportmap for each blade to aid debugging backend links.
##	$ECHO  +++++++++++++++++ Bladeportmap "$i" ++++++++++++++++++++++++
##	$CHASSISCMD bladeportmap $i

	asic_db_blade_type_ $i
		
		# Skipping ASIC-DB when slotshow does not work.
	  	# Dont skip in pizzabox as slotshow not supported.
		slotShow_op_pizza=(`slotshow | tr -s " " | cut -d " " -f 2,3 | tr -d " " | grep -c Notsupported`)
		if [ $slotShow_op_pizza -ne 1 ]
		then
			slotShow_op=(`slotshow | grep Slot | tr -d " " | grep -c SlotBladeTypeIDStatus`)
			if [ $slotShow_op -ne 1 ]
			then
				continue
			fi
		fi
		# Skipping ASIC-DB when individual DIAG is running on the blade.
		is_DIAG_running=(`diagstatus -slot $i |grep -c NONE`)
		# if [ $is_DIAG_running -ne 1 ]
		# then
		#  	echo "DIAG RUNNING ON slot $i, Skipping the ASIC-operations during SS"
		#    	continue
		# fi
		
		# Skipping ASIC-DB when systemverification DIAG is running on the blade.
		systemver_running_op=(`ps -aef |grep system`)
		is_systemver_running_flag=0
		systemver_run_op_count=${#systemver_running_op[*]}
		systemver_run_op_counter=0
		
		while [ $systemver_run_op_counter -lt $systemver_run_op_count ]
			do
				is_sysver_running=(`echo ${systemver_running_op[$systemver_run_op_counter]} | grep -c "systemverification"`)
				# if [ $is_sysver_running -eq 1 ]
				# then
				 # is_systemver_running_flag=1
				 # break
				#fi
				systemver_run_op_counter=`expr $systemver_run_op_counter + 1`
			done

		# if [ $is_systemver_running_flag -eq 1 ]
		# then
		#  	echo "System Verification RUNNING ON slot $i, Skipping the ASIC-operations during SS"
		#    	continue
		# fi

		# Finding Faluty Blades with PCIE_ERROR_CODE(90) and skipping asic operations during SS.
	        faulty_blade_list_db=(`slotshow | grep -n -e "FAULTY (90)" -e "FAULTY (51)" -e "FAULTY (77)" | tr -s " " | cut -d ":" -f1`)
	        faulty_blade_count_db=${#faulty_blade_list_db[*]}
		#echo $faulty_blades_count
		faulty_blade_counter_db=0
		is_this_slot_faulty_db=0
		
		while [ $faulty_blade_counter_db -lt $faulty_blade_count_db ]
			do
				#Subtracting 3 because slotshow's first 3 lines dont contain
			  	#any useful info.
			  	#Logical mapping of slots is just read them in sequential manner
			  	#in slotshow. So 3 needs to be subtracted.
				if [ $i -eq `expr ${faulty_blade_list_db[$faulty_blade_counter_db]} - 3` ]
				then
					is_this_slot_faulty_db=1
				fi
				
				faulty_blade_counter_db=`expr $faulty_blade_counter_db + 1`
			done
		# if [ $is_this_slot_faulty_db -eq 1 ]
		# then
			# /bin/echo "$i is faulty in start_asic_db"
		#	continue		# If blade is faulty with PCIE_ERROR_CODE then skip asic dumps.
		# fi
	
	if [ "$?" -eq 0 ]; then
		#uncomment me if Asic DB time out issue is fixed
		count=0
		while [ $count -lt $num_c3s ] 
		do 
			$ECHO  +++++++++++++++++ Asic Chip "$i"/$count/0 Regdump ++++++++++++++++++++++++
			$CHASSISCMD /fabos/sbin/c3regdump "$i"/$count/0
			$CHASSISCMD mv /var/regdump.dmp /var/c3regdump.dmp."$i".$count
			$CHASSISCMD gzip -f /var/c3regdump.dmp."$i".$count
			(( c3regdumpcount += 1 ))
			(( count += 1 ))
		done

		count=0
		while [ $count -lt $num_c2s ] 
		do 
			$ECHO  +++++++++++++++++ Asic Chip "$i"/$count/0 Regdump ++++++++++++++++++++++++
			$CHASSISCMD /fabos/sbin/c2regdump "$i"/$count/0
			$CHASSISCMD mv /var/regdump.dmp /var/c2regdump.dmp."$i".$count
			$CHASSISCMD gzip -f /var/c2regdump.dmp."$i".$count
			(( regdumpcount += 1 ))
			(( count += 1 ))
		done

		count=0
		while [ $count -lt $num_condors ] 
		do 
			$ECHO " "
			$ECHO  +++++++++++++++++ Asic Chip "$i"/$count/0 RTE database ++++++++++++++++++++++++
			$CHASSISCMD /fabos/link_bin/asicswdump -s $i -m $count -g 0
			$ECHO " "
			$ECHO  +++++++++++++++++ Asic Chip "$i"/$count/0 Regdump ++++++++++++++++++++++++
			$CHASSISCMD /fabos/sbin/c1regdump "$i"/$count/0
			$CHASSISCMD mv /var/regdump.dmp /var/c1regdump.dmp."$i".$count
			$CHASSISCMD gzip -f /var/c1regdump.dmp."$i".$count
			            (( c1regdmpcnt += 1 ))
				    (( count += 1 ))
		done
	fi
  done
  unset DB_SILENT_ERR

  if [ $c3regdumpcount -gt 0 ]	
  then
  	#
	# Move all C3 reg dumps into a tar ball
	#
	/bin/cp /fabos/cliexec/c3hregdecode /var/ 
	/bin/cp /fabos/cliexec/c3hregdecode_be /var/ 
	/bin/cp /fabos/cliexec/c3hregcmp /var/ 
  
	tar -cvPf /tmp/c3regdump.tar /var/c3regdump*gz /var/c3hregdecode /var/c3hregdecode_be /var/c3hregcmp 2> /dev/null

	/bin/rm /var/c3regdump*gz
	/bin/rm /var/c3hregdecode
	/bin/rm /var/c3hregdecode_be
	/bin/rm /var/c3hregcmp
	sync
	else
	$ECHO "No condor3 chips on this switch" > /var/c3emptyregdump.txt
	tar -cvf /tmp/c3regdump.tar /var/c2emptyregdump.txt 2> /dev/null
	/bin/rm /var/c3emptyregdump.txt
	sync
  fi
  if [ $regdumpcount -gt 0 ]	
  then
  	#
	# Move all C2 reg dumps into a tar ball
	#
	/bin/cp /fabos/cliexec/c2hregdecode /var/ 
	/bin/cp /fabos/cliexec/c2hregcmp /var/ 
  
	tar -cvPf /tmp/c2regdump.tar /var/c2regdump*gz /var/c2hregdecode /var/c2hregcmp 2> /dev/null

	/bin/rm /var/c2regdump*gz
	/bin/rm /var/c2hregdecode
	/bin/rm /var/c2hregcmp
	sync
	else
	$ECHO "No condor2 chips on this switch" > /var/c2emptyregdump.txt
	tar -cvf /tmp/c2regdump.tar /var/c2emptyregdump.txt 2> /dev/null
	/bin/rm /var/c2emptyregdump.txt
	sync
  fi

  if [ $c1regdmpcnt -gt 0 ]
  then
    #
    # Move all C1 reg dumps into a tar ball
    #
    /bin/cp /fabos/cliexec/c1hregdecode /var/
    /bin/cp /fabos/cliexec/c1hregcmp /var/

    tar -cvPf /tmp/c1regdump.tar /var/c1regdump*gz /var/c1hregdecode /var/c1hregcmp 2> /dev/null

    /bin/rm /var/c1regdump*gz
    /bin/rm /var/c1hregdecode
    /bin/rm /var/c1hregcmp
	sync
	else
    $ECHO "No condor chips on this switch" > /var/c1emptyregdump.txt
    tar -cvf /tmp/c1regdump.tar /var/c1emptyregdump.txt 2> /dev/null
    /bin/rm /var/c1emptyregdump.txt
	sync
  fi

  if [ $sw_platform = 1000 ]; then
    $ECHO "E2E CP"
    $ECHO "==========================================================="
    $CHASSISCMD /fabos/bin/dbc chassis show e2e
    $ECHO "==========================================================="
  fi
}

# *******************************************
# Collect ASIC hardware and driver info
# *******************************************
#ASICDB,/fabos/cliexec/ssave.sh --asic, , ,N,N,N,Y,Y,10,
# *******************************************
start_asic()
{
	# Do not dump database on standby CP.
	if [ $standby = yes ]; then
		return
	fi

	# Capture the error counters across two polling interval.
	cmd_title "sloterrshow"
	$CHASSISCMD sloterrshow -c2 -r
	/bin/echo ""

	# If db script not present, can't dump database
	if [ ! -e /fabos/link_sbin/db ]; then
		return 
	fi

	export DB_SILENT_ERR=1
	cd /proc/fabos/blade
	c1regdmpcnt=0
	c2regdmpcnt=0
	c3regdmpcnt=0
	avregdmpcnt=0
	cbrregdmpcnt=0
	cbr2regdmpcnt=0

	for i in `ls -d [0-9]* | sort -n`; do
		#
		# no shell cmd should intervene between asic_db_blade_type and 
		# check for return status stored in $?.
		# Note: "db" work on proc path slot#/mini#/chip#
		# This script assumes the following for ALL blade type.
		# The script has to be modified if the assumption becomes false.
		# 1) The following chip assigment per miniswitch
			# chip# = 0 => condor
			# chip# = 1 => pinball
			# chip# = 2 => flipper
		# 2) each mini has only 1 instance of a certain asic.

		# Capture bladeportmap for each blade to aid debugging backend links.
		cmd_title "Bladeportmap $i"
		$CHASSISCMD bladeportmap $i
		/bin/echo ""
		# Skipping ASIC-DB when slotshow does not work.
	  	# Dont skip in pizzabox as slotshow not supported.
		slotShow_op_pizza=(`slotshow | tr -s " " | cut -d " " -f 2,3 | tr -d " " | grep -c Notsupported`)
		if [ $slotShow_op_pizza -ne 1 ]
		then
			slotShow_op=(`slotshow | grep Slot | tr -d " " | grep -c SlotBladeTypeIDStatus`)
			if [ $slotShow_op -ne 1 ]
			then
				continue
			fi
		fi
		
		# Skipping ASIC-DB when DIAG is running on the blade.
		is_DIAG_running=(`diagstatus -slot $i |grep -c NONE`)
		# if [ $is_DIAG_running -ne 1 ]
		# then
		 # 	echo "DIAG RUNNING ON slot $i, Skipping the ASIC-operations during SS"
		 #   	continue
		# fi
		
		# Skipping ASIC-DB when systemverification DIAG is running on the blade.
		systemver_running_op=(`ps -aef |grep system`)
		is_systemver_running_flag=0
		systemver_run_op_count=${#systemver_running_op[*]}
		systemver_run_op_counter=0
		
		while [ $systemver_run_op_counter -lt $systemver_run_op_count ]
			do
				is_sysver_running=(`echo ${systemver_running_op[$systemver_run_op_counter]} | grep -c "systemverification"`)
		#		if [ $is_sysver_running -eq 1 ]
		#		then
		#		  is_systemver_running_flag=1
		#		  break
		#		fi
				systemver_run_op_counter=`expr $systemver_run_op_counter + 1`
			done

		if [ $is_systemver_running_flag -eq 1 ]
		then
		  	echo "System Verification RUNNING ON slot $i, Skipping the ASIC-operations during SS"
		    	continue
		fi
		# Finding Faluty Blades with PCIE_ERROR_CODE(90) and skipping asic operations during SS.
	        faulty_blade_list=(`slotshow | grep -n -e "FAULTY (90)" -e "FAULTY (51)" -e "FAULTY (77)" | tr -s " " | cut -d ":" -f1`)
	        faulty_blade_count=${#faulty_blade_list[*]}
		#echo $faulty_blades_count
		faulty_blade_counter=0
		is_this_slot_faulty=0
		
		while [ $faulty_blade_counter -lt $faulty_blade_count ]
			do
				#Subtracting 3 because slotshow's first 3 lines dont contain
			  	#any useful info.
			  	#Logical mapping of slots is just read them in sequential manner
			  	#in slotshow. So 3 needs to be subtracted.
				if [ $i -eq `expr ${faulty_blade_list[$faulty_blade_counter]} - 3` ]
				then
					is_this_slot_faulty=1
				fi
				
				faulty_blade_counter=`expr $faulty_blade_counter + 1`
			done
		if [ $is_this_slot_faulty -eq 1 ]
		then
			# /bin/echo "$i is faulty in start_asic"
			continue		# If blade is faulty with PCIE_ERROR_CODE then skip asic dumps.
		fi
	
		if [ "$(grep -s "attach_flag" "$i"/info|awk '{ print $2 }')" = 1 ]
		then
		continue;
		fi
		      
		asic_db_blade_type_ $i

		if [ "$?" -eq 0 ]; then
			#
			# Condor 2 and GoldenEye 2
			#
			if [ "$blade_type" = "f-callisto-60" ]; then
				chip=9		# Only this platfrom starts from the end
			else
				chip=0		# The rest starts from 0
			fi
			end_chip=$((chip + num_c2s))
			while [ $chip -lt $end_chip ]; do
				cmd_title "Asic Chip $i/$chip/0 RTE database"
				$CHASSISCMD db "$i"/$chip/0 rte show all
				/bin/echo ""

				if [ "$blade_type" = "mace" -o "$blade_type" = "lance" ]; then
					cmd_title "Mace/Lance $i/$chip/0 RTE info"
					$CHASSISCMD db "$i"/$chip/0 rte show if s
					/bin/echo ""

					for portnum in `seq 0 39`; do
						cmd_title "Mace/Lance $i/$chip/0 RTE port $portnum domain table"
						$CHASSISCMD db "$i"/$chip/0 rte show domain p$portnum
						/bin/echo ""

						cmd_title "Mace/Lance $i/$chip/0 RTE port $portnum area table"
						$CHASSISCMD db "$i"/$chip/0 rte show area p$portnum
						/bin/echo ""

						cmd_title "Mace/Lance $i/$chip/0 RTE port $portnum nhop table"
						$CHASSISCMD db "$i"/$chip/0 rte show nhop p$portnum
						/bin/echo ""
					done
				fi

				cmd_title "Asic Chip $i/$chip/0 RTE ge2nhop"
				$CHASSISCMD db "$i"/$chip/0 rte show ge2nhop 
				/bin/echo ""

				cmd_title "Asic Chip $i/$chip/0 FCR rp"
				$CHASSISCMD db "$i"/$chip/0 fcr show rp 
				/bin/echo ""

				cmd_title "Asic Chip $i/$chip/0 FCR proxy"
				$CHASSISCMD db "$i"/$chip/0 fcr show proxy 
				/bin/echo ""

				cmd_title "Asic Chip "$i"/$chip/0 FCR le"
				$CHASSISCMD db "$i"/$chip/0 fcr show le 
				/bin/echo ""

				cmd_title "Asic Chip $i/$chip/0 FCR dps"
				$CHASSISCMD db "$i"/$chip/0 fcr show dps 
				/bin/echo ""

				cmd_title "Asic Chip "$i"/$chip/0 VF database"
				$CHASSISCMD db "$i"/$chip/0 vf show all
				/bin/echo ""

				cmd_title "Asic Chip $i/$chip/0 STATS dump"
				$CHASSISCMD db "$i"/$chip/0 stats 24
				$CHASSISCMD db "$i"/$chip/0 stats 23 | grep -v "sid 000000 did 000000"
				# Do it again to verify that counters are incrementing
				$CHASSISCMD db "$i"/$chip/0 stats 23 | grep -v "sid 000000 did 000000" 
				/bin/echo ""

				cmd_title "Asic Chip $i/$chip/0 Regdump"
				$CHASSISCMD /fabos/sbin/c2regdump "$i"/$chip/0
				$CHASSISCMD mv /var/regdump.dmp /var/c2regdump.dmp."$i".$chip
				$CHASSISCMD gzip -f /var/c2regdump.dmp."$i".$chip
				/bin/echo ""

				cmd_title "Asic Chip "$i"/$chip/0 FTB type2 entries"
				$CHASSISCMD db "$i"/$chip/0 ftb show type2
				/bin/echo ""

				(( c2regdmpcnt += 1 ))
				(( chip += 1 ))
			done

			count=0
			while [ $count -lt $num_c3s ]; do 
				cmd_title "Asic Chip $i/$count/0 RTE database"
				$CHASSISCMD db "$i"/$count/0 rte show all
				/bin/echo ""

				cmd_title "Asic Chip $i/$count/0 Regdump"
				$CHASSISCMD /fabos/sbin/c3regdump "$i"/$count/0
				$CHASSISCMD mv /var/regdump.dmp /var/c3regdump.dmp."$i".$count
				$CHASSISCMD gzip -f /var/c3regdump.dmp."$i".$count
				/bin/echo ""

				(( c3regdmpcnt += 1 ))
				(( count += 1 ))
			done
			#
			# Condor
			#
			count=0
			while [ $count -lt $num_condors ]; do 
				cmd_title "Asic Chip $i/$count/0 RTE database"
				$CHASSISCMD db "$i"/$count/0 rte show all
				/bin/echo ""

				cmd_title "Asic Chip $i/$count/0 Regdump"
				$CHASSISCMD /fabos/sbin/c1regdump "$i"/$count/0
				$CHASSISCMD mv /var/regdump.dmp /var/c1regdump.dmp."$i".$count
				$CHASSISCMD gzip -f /var/c1regdump.dmp."$i".$count
				/bin/echo ""

				(( c1regdmpcnt += 1 ))
				(( count += 1 ))
			done

			#
			# Pinball
			#
			# Should only execute "db fcr" if blade is FCR capable
			count=0
			while [ $count -lt $num_pinballs ]; do 
				cmd_title "Asic Chip $i/$count/1 FCR database"
				$CHASSISCMD db "$i"/$count/1 fcr show all
				/bin/echo ""

				cmd_title "Asic Chip $i/$count/0 STATS dump"
				$CHASSISCMD db "$i"/$count/0 stats 24
				$CHASSISCMD db "$i"/$count/0 stats 23 | grep -v "sid 000000  did 000000"
				# Do it again to verify that counters are incrementing
				$CHASSISCMD db "$i"/$count/0 stats 23 | grep -v "sid 000000  did 000000"
				/bin/echo ""

				(( count += 1 ))
			done

			#
			# Zeus
			#
			zeus=1 # zeus starts at 1 for elara/europa
			end_zeus=$((zeus + num_zeus))
			while [ $zeus -lt $end_zeus ]; do
				cmd_title "Zeus Chip $i/$zeus/0"
				start_zeus_cmds $i $zeus
				/bin/echo ""

				(( zeus += 1 ))
			done

			#
			# Anvil
			#
			anvil=4 # anvil starts at 4 for elara/europa
			end_anvil=$((anvil + num_anvils))
			while [ $anvil -lt $end_anvil ]; do
				cmd_title "Anvil Chip $i/$anvil/0"
				start_anvil_cmds $i $anvil
				/bin/echo ""

				(( avregdmpcnt += 1 ))
				(( anvil += 1 ))
			done

			#
			# eAnvil
			#
			if [ "$blade_type" = "f-callisto-60" ]; then
				eanv=0
			else
				eanv=$num_c2s # eanv starts after C2 or GE2
			fi
			end_eanv=$((eanv + num_eanvs))
			while [ $eanv -lt $end_eanv ]; do
				cmd_title "eAnvil Chip $i/$eanv/0"
				start_eanv_cmds $i $eanv
				/bin/echo ""

				(( avregdmpcnt += 1 ))
				(( eanv += 1 ))
			done

			if [ "$blade_type" = "scimitar" -o "$blade_type" = "sabre" ]; then
				slot=$i
				cmd_title "Scimitar/Sabre $i"
				scimitar_port_
				/bin/echo ""
			fi

			if [ "$blade_type" = "striker" -o "$blade_type" = "spike" ]; then
				slot=$i
				cmd_title "Striker/Spike $i"
				striker_filter_
				/bin/echo ""
			fi

			if [ "$blade_type" = "elara-2f" ]; then
				slot=$i
				cmd_title "F-Callisto-24 $i"
				f_callisto_24_filter_
				/bin/echo ""
			fi

			if [ "$blade_type" = "f-callisto-60" ]; then
				slot=$i
				cmd_title "F-Callisto-60 $i"
				f_callisto_60_filter_
				/bin/echo ""
			fi
		fi
	done

	asic_db_blade_type_ $i

	if [ "$blade_type" = "rigel1" -o "$blade_type" = "rigelMOR" ]; then
            cmd_title "Cobra2 Chip 0/0/0"
            start_cbr2_cmds 0 0
            /bin/echo "Done"
            (( cbr2regdmpcnt += 1 ))
	fi
	if [ "$blade_type" = "castor" -o "$blade_type" = "castorT" -o	\
		 "$blade_type" = "blackbird" -o "$blade_type" = "dracoT" ]; then
	        cmd_title "Cobra Chip 0/0/0"
	        start_cbr_cmds 0 0
	        /bin/echo ""

			(( cbrregdmpcnt += 1 ))
	fi

	unset DB_SILENT_ERR

	cmd_title "Pack register dump files"

	# Clean up left-over dump files
	$CHASSISCMD /bin/rm -rf /tmp/regdump
	$CHASSISCMD /bin/mkdir /tmp/regdump

	#
	# Pick up all C2 reg dumps
	#
	if [ $c2regdmpcnt -gt 0 ]; then
		$CHASSISCMD /bin/mkdir -p /tmp/regdump/c2
		$CHASSISCMD /bin/cp /fabos/cliexec/c2hregdecode /tmp/regdump/c2
		$CHASSISCMD /bin/cp /fabos/cliexec/c2hregcmp /tmp/regdump/c2
		$CHASSISCMD "/bin/mv /var/c2regdump*gz /tmp/regdump/c2"

		tar -cvPf /tmp/C2REGDUMP.tar /tmp/regdump/c2/c2regdump*gz /tmp/regdump/c2/c2hregdecode /tmp/regdump/c2/c2hregcmp 2> /dev/null

		/bin/rm /tmp/regdump/c2/c2regdump*gz
		/bin/rm /tmp/regdump/c2/c2hregdecode
		/bin/rm /tmp/regdump/c2/c2hregcmp
		sync
		else
		$ECHO "No condor2 chips on this switch" > /var/c2emptyregdump.txt
		tar -cvf /tmp/C2REGDUMP.tar /var/c2emptyregdump.txt 2> /dev/null
		/bin/rm /var/c2emptyregdump.txt
		sync

	fi

	#
	# Pick up all C3 reg dumps
	#
	if [ $c3regdmpcnt -gt 0 ]; then
		$CHASSISCMD /bin/mkdir -p /tmp/regdump/c3
		$CHASSISCMD /bin/cp /fabos/cliexec/c3hregdecode /tmp/regdump/c3
		$CHASSISCMD /bin/cp /fabos/cliexec/c3hregdecode_be /tmp/regdump/c3
		$CHASSISCMD /bin/cp /fabos/cliexec/c3hregcmp /tmp/regdump/c3
		$CHASSISCMD "/bin/mv /var/c3regdump*gz /tmp/regdump/c3"
	fi

	#
	# Pick up all C1 reg dumps
	#
	if [ $c1regdmpcnt -gt 0 ]; then
		$CHASSISCMD /bin/mkdir -p /tmp/regdump/c1
		$CHASSISCMD /bin/cp /fabos/cliexec/c1hregdecode /tmp/regdump/c1
		$CHASSISCMD /bin/cp /fabos/cliexec/c1hregcmp /tmp/regdump/c1
		$CHASSISCMD "/bin/mv /var/c1regdump*gz /tmp/regdump/c1"
	fi

	#
	# Pick up all Anvil/eAnvil reg dumps
	#
	if [ $avregdmpcnt -gt 0 ]; then
		$CHASSISCMD /bin/mkdir -p /tmp/regdump/av
		$CHASSISCMD "/bin/mv /var/avregdump*gz /tmp/regdump/av"
	fi

	#
	# Pick up Cobra reg dump
	#
	if [ $cbrregdmpcnt -gt 0 ]; then
		$CHASSISCMD /bin/mkdir -p /tmp/regdump/cbr
		$CHASSISCMD "/bin/mv /var/cbrregdump*gz /tmp/regdump/cbr"
	fi
	
	if [ $cbr2regdmpcnt -gt 0 ]; then
		$CHASSISCMD /bin/mkdir -p /tmp/regdump/cbr2
		$CHASSISCMD "/bin/mv /var/cbr2regdump*gz /tmp/regdump/cbr2"
		$CHASSISCMD "/bin/mv /var/cbr2tcamdump*gz /tmp/regdump/cbr2"
		$CHASSISCMD "/bin/mv /var/cbr2exmdump*gz /tmp/regdump/cbr2"
		$CHASSISCMD "/bin/mv /var/cbr2cfgdump*gz /tmp/regdump/cbr2"
		$CHASSISCMD "/bin/mv /var/cbr2lpmdump*gz /tmp/regdump/cbr2"
		$CHASSISCMD "/bin/cp /fabos/sbin/asicdump /tmp/regdump/cbr2"
	fi
	#
	# Package all reg dumps into a tar ball
	#
	if [ $c1regdmpcnt -eq 0 ] && [ $c2regdmpcnt -eq 0 ] && [ $c3regdmpcnt -eq 0 ] &&
				[ $cbr2regdmpcnt -eq 0 ] &&	[ $avregdmpcnt -eq 0 ] && [ $cbrregdmpcnt -eq 0 ]; then
		$CHASSISCMD /bin/echo "No C1/C2/C3/Anvil/eAnvil/Cobra/Cobra2 chips on this switch" > /tmp/regdump/regdump.txt
	fi
	cd /tmp
	$CHASSISCMD /bin/tar -cvf regdump.tar regdump

	sync
	/bin/echo ""

	# Capture the error counters one more time.
	cmd_title "sloterrshow"
	$CHASSISCMD sloterrshow -c2 -r
	/bin/echo ""
}

# *******************************************
# Collect DCE HSL info
# *******************************************
start_dcehsl_user()
{
    # Do not dump database on standby CP.
    if [ "$STANDBY" = "TRUE" ]
    then
        return
    fi
    
  # If hsl script not present, can't dump database
    if [ ! -e /fabos/link_sbin/hsl ]; then
        return
    fi

    /bin/echo " "
    /bin/echo  +++++++++++++++++ DCE HSL IFM database start ++++++++++++++++++++
	/bin/echo " "
	/bin/echo "hsl ifm show all"
    hsl ifm show all
	# hsl ifm show bridge stp

	/bin/echo " "
    hsl_if=(`hsl ifm show if all | awk '{ print $2 }'|grep 0x`)
    for (( j=0; j < ${#hsl_if[@]}; j++ )); do
    	hsl ifm show if ${hsl_if[$j]} detail
    	hsl ifm show if ${hsl_if[$j]} counters
	done

	/bin/echo " "
	/bin/echo "hsl ifm show bridge vlan"
	hsl ifm show bridge vlan

	/bin/echo " "
	/bin/echo "hsl ifm show vlan all bcast"
	hsl ifm show vlan range 1 500 bcast
	hsl ifm show vlan range 501 1000 bcast
	hsl ifm show vlan range 1001 1500 bcast
	hsl ifm show vlan range 1501 2000 bcast
	hsl ifm show vlan range 2001 2500 bcast
	hsl ifm show vlan range 2501 3000 bcast
	hsl ifm show vlan range 3001 3500 bcast
	hsl ifm show vlan range 3501 4000 bcast
	hsl ifm show vlan range 4001 4500 bcast
	hsl ifm show vlan range 4501 5000 bcast
	hsl ifm show vlan range 5001 5500 bcast
	hsl ifm show vlan range 5501 6000 bcast
	hsl ifm show vlan range 6001 6500 bcast
	hsl ifm show vlan range 6501 7000 bcast
	hsl ifm show vlan range 7001 7500 bcast
	hsl ifm show vlan range 7501 8000 bcast
	hsl ifm show vlan range 8001 8192 bcast

	/bin/echo " "
	/bin/echo "hsl ifm show vlan association"
	hsl ifm show vlan association

#	/bin/echo " "
#	/bin/echo "hsl ifm show if all sib"
#    hsl ifm show if all sib

	/bin/echo " "
	/bin/echo "hsl ifm show tnl_tbl all"
        hsl ifm show tnl_tbl all

	/bin/echo " "
	/bin/echo "hsl ifm show vlan_vni all"
        hsl ifm show vlan_vni all

	/bin/echo " "
	/bin/echo "hsl ifm show xsfp"
    hsl ifm show xsfp
	
  /bin/echo " "
	/bin/echo "hsl ifm show span"
    hsl ifm show span

    /bin/echo " "	
	/bin/echo "hsl ifm show af l2sys"
	hsl ifm show af l2sys

    /bin/echo " "	
	/bin/echo "hsl ifm show af others"
	hsl ifm show af others


    /bin/echo " "
    /bin/echo "hsl ifm show bridge mctree"
	hsl ifm show bridge mctree

    /bin/echo " "
	/bin/echo "hsl ifm ipot"
    hsl ifm ipot show de
    hsl ifm net show vlan0.4093

    /bin/echo " "
    /bin/echo "hsl ifm show stats"
	hsl ifm show stats

    /bin/echo " "
    /bin/echo "hsl ifm show ipv6 stats"
	hsl ifm show ipv6 stats

    /bin/echo " "
    /bin/echo "hsl ifm show skbstats detail"
	hsl ifm show skbstats detail

    #/bin/echo " "
    #/bin/echo "hsl ifm show proto_cntrs l2"
	#hsl ifm show proto_cntrs l2

    #/bin/echo " "
    #/bin/echo "hsl ifm show proto_cntrs l3"
	#hsl ifm show proto_cntrs l3

	/bin/echo " "
	/bin/echo "hsl ifm kap dump tx"
	hsl ifm kap dump tx

	/bin/echo " "
	/bin/echo "hsl ifm kap dump rx"
	hsl ifm kap dump rx

    /bin/echo " "
    /bin/echo "hsl ifm show myvrf_tbl all"
	hsl ifm show myvrf_tbl all

	/bin/echo " "
	/bin/echo "hsl ifm show vrrp_cache"
	hsl ifm show vrrp_cache

    /bin/echo  +++++++++++++++++ DCE HSL IFM database end ++++++++++++++++++++++
    /bin/echo  +++++++++++++++++ DCE HSL HAL database Start ++++++++++++++++++++
    /bin/echo " "
    /bin/echo "hsl hal show all"
    hsl hal show all
    /bin/echo  +++++++++++++++++ DCE HSL HAL database end ++++++++++++++++++++++   
    /bin/echo  +++++++++++++++++ TRILL START  ++++++++++++++++++++++

    /bin/echo " "
	/bin/echo "trill_dbg trill show stats"

    trill_dbg trill show stats

    /bin/echo " "
	/bin/echo "trill_dbg trill show isl_info"
    trill_dbg trill show isl_info

    /bin/echo " "
	/bin/echo "trill_dbg trill show route"
    trill_dbg trill show route

    /bin/echo  +++++++++++++++++ TRILL END  ++++++++++++++++++++++

    /bin/echo "port vlan association - start"
    for (( j=0; j < ${#hsl_if[@]}; j++ )); do
    	hsl ifm show if ${hsl_if[$j]} port-vlan-tree
	done
    /bin/echo "port vlan association - end"
    /bin/echo  +++++++++++++++++ IPHELPER START  ++++++++++++++++++++++
    hsl ifm show iphelp v4
    hsl ifm show iphelp v6
    /bin/echo  +++++++++++++++++ IPHELPER END  ++++++++++++++++++++++
    /bin/echo " "
    /bin/echo "hsl ifm show slowfdb"
	hsl ifm show slowfdb
}

# *******************************************
# Collect AG info
# *******************************************
start_ag() 
{
	AG_EXIST=`pidof agd`
	if [ ! -z $AG_EXIST ]; then
		$CHASSISCMD /fabos/cliexec/agdbg --dump

	    $CONFDCMD show ag
	    $CONFDCMD show ag map
	    $CONFDCMD show ag pg

	fi
}

# Test the blade capability.
# Need to identify if blade support proc-entry based db cmd, and
# Need to identify blade feature capability
# Input: slot#
# Return:  If Ok, blade_type & blade_id is set properly for the slot
# Otherwise, bladeid ==0, and blade_type == ""
asic_db_blade_type_()
{
	# initialize to unknown blade id & type
	bladeid=0
	blade_type=""
	num_anvils=0
	num_eanvs=0
	num_zeus=0
	num_condors=0
	num_pinballs=0
	num_c2s=0
	num_c3s=0
	num_cbrs=0
	if test -f /proc/fabos/blade/$1/info; then
		# ref. blade id is defined in linux/include/brocade/swbd.h		
		bladeid=`cat /proc/fabos/blade/$1/info | /bin/grep --binary-files=text bladeId | sed 's/[^0-9]//g'`

		case "$bladeid" in
		"37" ) blade_type="despina";num_c2s=1;;
		"55" ) blade_type="larissa";num_c2s=2;;
		"51" ) blade_type="triton";num_c2s=2;;
		"46" ) blade_type="hydra";num_c2s=2;;
		"56" ) blade_type="spirit";num_c2s=1;;
		"59" ) blade_type="tomahawk";num_c2s=1;;
		"53" ) blade_type="thor";num_c2s=9;;
		"52" ) blade_type="proteus";num_c2s=4;;
		"29" ) blade_type="sprint";num_condors=2;num_pinballs=2;;
		"27" ) blade_type="viking";num_condors=6;;
		"24" ) blade_type="marathon";num_condors=2;num_pinballs=2;;
		"33" ) blade_type="scimitar";num_condors=2;num_pinballs=2;;
		"38" ) blade_type="sabre";num_condors=2;num_pinballs=2;;
		"45" ) blade_type="elara";num_c2s=1;num_anvils=3;num_zeus=3;;
		"74" ) blade_type="europa";num_c2s=1;num_anvils=3;num_zeus=3;;
		"76" ) blade_type="frisco";num_c2s=1;num_eanvs=1;;
		"82" ) blade_type="elara-2e";num_eanvs=1;;
		"83" ) blade_type="elara-2f";num_c2s=1;num_eanvs=1;;
		"84" ) blade_type="callisto-e";num_eanvs=9;;
		# Remove frisco-ttv when it is decommissioned.
		"86" ) blade_type="frisco-ttv";num_c2s=1;num_eanvs=1;;
		"103" ) blade_type="katana";num_eanvs=1;;
		"69" ) blade_type="spike";num_c2s=1;;
		"75" ) blade_type="striker";num_c2s=1;;
		"42" ) blade_type="mace";num_c2s=2;;
		"43" ) blade_type="lance";num_c2s=2;;
		"31" ) blade_type="ironman";num_condors=1;;
		"18" ) blade_type="electron";num_condors=2;;	# 32-ports condor
		"16" ) blade_type="neutron";num_condors=2;;		# core condors
		"36" ) blade_type="positron";num_condors=2;;	# 48-ports condor
		"39" ) blade_type="xenon";num_condors=2;;
		"118" ) blade_type="carme";num_eanvs=3;;
		"113" ) blade_type="mercury";num_c3s=3;;
		"122" ) blade_type="harrier";num_c2s=1;num_eanvs=1;;
		"94" ) blade_type="f-callisto-60";num_c2s=1;num_eanvs=9;;
		"135" ) blade_type="castor";num_cbrs=1;;
		"145" ) blade_type="castorT";num_cbrs=1;;
		"159" ) blade_type="rigel1";num_cbrs=1;;
		"146" ) blade_type="blackbird";num_cbrs=1;;
		"157" ) blade_type="dracoT";num_cbrs=1;;
		"174" ) blade_type="rigelMOR";num_cbrs=1;;
		* ) blade_type="katana";num_eanvs=1;;
	# 	* ) blade_type="others";num_condors=0;;			# pulsar/stealth/proton
		esac
	fi

	# This is a temporary hack for F-Callisto 24 running NOS 2.1.0
	if [ "$blade_type" = "elara-2f" ]; then
		# There will be only 1 mini-switch in such combination
		cat /proc/fabos/blade/$1/info | grep minis:1
		if [ $? -ne 0 ]; then
			num_c2s=0
		fi
	fi

	# This is a temporary hack for F-Callisto 60 running NOS 2.1.0
	if [ "$blade_type" = "f-callisto-60" ]; then
		# There will be only 9 mini-switches in such combination
		cat /proc/fabos/blade/$1/info | grep minis:9
		if [ $? -ne 0 ]; then
			num_c2s=0
		fi
	fi

	# return status
	if [ "$blade_type" = "" ]; then
		echo_xx 2> /dev/null;
	else
		echo 2> /dev/null
	fi	
}

start_anvil_cmds()
{
	slot=$1
	chip=$2
	ports=28
	fports=16
	eports=12

	#
	# Chip information
	#
	cmd_title "Chip Information"
	$CHASSISCMD db $slot/$chip/0 dbg show chip
	$CHASSISCMD db $slot/$chip/0 cfg show chp_cap
	/bin/echo ""

	#
	# Skip reg access if chip not initialized yet.
	#
	let chip_stat=`db $slot/$chip/0 dbg show chip | grep init_state | awk '{print $4}'`
	if [ $chip_stat -ne 6 ] ; then
		echo "*** Chip not initialized.  Regdump skipped. ***"
		echo "init_state = $chip_stat"
		return 1
	fi

	#
	# Reg dump
	#
	cmd_title "Saving Regdump"
	$CHASSISCMD regdump $slot/$chip/0
	$CHASSISCMD mv /var/regdump.dmp /var/avregdump.dmp.$slot.$chip
	$CHASSISCMD gzip -f /var/avregdump.dmp.$slot.$chip
	/bin/echo ""

	#
	# Stats
	#
	cmd_title "Stats Information"
	if test -f /proc/driver/anvil_rev; then
		anvil_rev=`cat /proc/driver/anvil_rev`
		if [ $anvil_rev != "1.0" ]; then
			$CHASSISCMD db $slot/$chip/0 anv_stats dump stats all
		else
			$CHASSISCMD db $slot/$chip/0 anv_stats dump emac port all
			$CHASSISCMD db $slot/$chip/0 anv_stats dump fmac port all
			$CHASSISCMD db $slot/$chip/0 anv_stats dump dump qmg stats
			$CHASSISCMD db $slot/$chip/0 anv_stats dump dump cfm stats
			$CHASSISCMD db $slot/$chip/0 anv_stats dump dump ets stats
			$CHASSISCMD db $slot/$chip/0 anv_stats dump dump fts stats
			$CHASSISCMD db $slot/$chip/0 anv_stats dump dump psel_mac stats
			$CHASSISCMD db $slot/$chip/0 anv_stats dump dump psel_tcam stats
			$CHASSISCMD db $slot/$chip/0 anv_stats dump dump psel_l2mpid stats
			$CHASSISCMD db $slot/$chip/0 anv_stats dump dump psel_mpid stats
			$CHASSISCMD db $slot/$chip/0 anv_stats dump dump psel_lgid stats
			$CHASSISCMD db $slot/$chip/0 anv_stats dump dump psel_l3tcam stats
		fi
	else
		$CHASSISCMD db $slot/$chip/0 anv_stats dump stats all
	fi
	/bin/echo ""

	#
	# Trunking Commands;
	#
	cmd_title "Trunking Information"
	$CHASSISCMD db $slot/$chip/0 trunk brcd show
	$CHASSISCMD db $slot/$chip/0 trunk brcd print_ifs
	/bin/echo ""

	#
	# FOS RTE Commands
	#
	cmd_title "FOS RTE Information"
	$CHASSISCMD db $slot/$chip/0 fc_rte show if_ids
	$CHASSISCMD db $slot/$chip/0 fc_rte show egid_table
	$CHASSISCMD db $slot/$chip/0 fc_rte show mcast_egid
	$CHASSISCMD db $slot/$chip/0 fc_rte show ccm_egid
	/bin/echo ""

	#
	# CFM Commands
	#
	cmd_title "CFM Information"
	$CHASSISCMD db $slot/$chip/0 cfm utc 17
	$CHASSISCMD db $slot/$chip/0 cfm show e2efrm
	$CHASSISCMD db $slot/$chip/0 cfm show e2eflush
	$CHASSISCMD db $slot/$chip/0 cfm show all
	$CHASSISCMD db $slot/$chip/0 cfm show mem
	/bin/echo ""

	#
	# RTE Commands
	#
	cmd_title "RTE Information"
	$CHASSISCMD db $slot/$chip/0 rte show exm l2 summary
	$CHASSISCMD db $slot/$chip/0 rte show exm ipv4 summary
	$CHASSISCMD db $slot/$chip/0 rte show exm ipv6 summary

	$CHASSISCMD db $slot/$chip/0 rte show l2da tree
	$CHASSISCMD db $slot/$chip/0 rte show l2_lrn

	$CHASSISCMD db $slot/$chip/0 rte show lpm ipv4 204
	$CHASSISCMD db $slot/$chip/0 rte show lpm ipv6 204

	$CHASSISCMD db $slot/$chip/0 dbg verify rte
	/bin/echo ""

	#
	# DMA Commands
	#
	cmd_title "Tx/Rx DMA Information"
	$CHASSISCMD db $slot/$chip/0 txrx show hsi
	$CHASSISCMD db $slot/$chip/0 txrx show info 0
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 0
	$CHASSISCMD db $slot/$chip/0 txrx show info 1
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 1
	$CHASSISCMD db $slot/$chip/0 txrx show info 2
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 2
	$CHASSISCMD db $slot/$chip/0 txrx show info 3
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 3
	$CHASSISCMD db $slot/$chip/0 txrx show info 4
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 4
	$CHASSISCMD db $slot/$chip/0 txrx show stats all
	$CHASSISCMD db $slot/$chip/0 txrx show rxcredit
	$CHASSISCMD db $slot/$chip/0 txrx show rxq stats
	$CHASSISCMD db $slot/$chip/0 txrx show txcredit all
	$CHASSISCMD db $slot/$chip/0 txrx show txq all
	/bin/echo ""

	#
	# UPSM Commands
	#
	cmd_title "UPSM Information"
	$CHASSISCMD db $slot/$chip/0 phyp show ports

	port=0
	while [ $port -lt $ports ]; do
		cmd_title "PHY PORT $port Information"
		$CHASSISCMD db $slot/$chip/0 phyp show ctrl $port
		$CHASSISCMD db $slot/$chip/0 phyp show lli $port
		$CHASSISCMD db $slot/$chip/0 phyp show pcs $port
		$CHASSISCMD db $slot/$chip/0 phyp show cnt $port
		$CHASSISCMD db $slot/$chip/0 phyp show hss $port
		$CHASSISCMD db $slot/$chip/0 phyp show proto $port

		if [ $port -lt $fports ]; then
			$CHASSISCMD db $slot/$chip/0 phyp show fpg $port
		else
			$CHASSISCMD db $slot/$chip/0 phyp show epg $port
		fi

		/bin/echo ""
		(( port += 1 ))
	done
}

start_eanv_cmds()
{
	slot=$1
	chip=$2
	ports=32
	eports=24
    bladeid=`cat /proc/fabos/blade/$1/info | /bin/grep --binary-files=text bladeId | sed 's/[^0-9]//g'`

	# 
	# Examine the PCI revision Id of the first eAnvil chip.
	# \( and \) delimits the rev Id to retrieve and is referenced by \1
	#
	eanv_pci_id=1657:001a
	eanv_rev=`cat /proc/pci | grep $eanv_pci_id | head -1 | \
		sed 's/.*rev \([0-9]*\).*/\1/'`

	#
	# Chip information
	#
	cmd_title "Chip Information"
	$CHASSISCMD db $slot/$chip/0 dbg show chip
	$CHASSISCMD db $slot/$chip/0 cfg show chp_cap
	/bin/echo ""

	#
	# Skip reg access if chip not initialized yet.
	#
	chip_stat=`db $slot/$chip/0 dbg show chip init_state`
	if [ "$chip_stat" != "Initialized" ] ; then
		echo "*** Chip not initialized.  Regdump skipped. ***"
		echo $chip_stat
		return 1
	fi

	#
	# Reg dump
	#
	cmd_title "Saving Regdump"
	$CHASSISCMD db $slot/$chip/0 dbg set regdump on
	$CHASSISCMD regdump $slot/$chip/0
	$CHASSISCMD db $slot/$chip/0 dbg set regdump off
	$CHASSISCMD mv /var/regdump.dmp /var/avregdump.dmp.$slot.$chip
	$CHASSISCMD gzip -f /var/avregdump.dmp.$slot.$chip
	/bin/echo ""

	#
	# Stats
	#
	cmd_title "Stats Information"
	dmp_cnt=0
	while [ $dmp_cnt -lt 3 ]; do
		/bin/echo "Counter Dump iteration # $dmp_cnt:"
		/bin/echo ""
	$CHASSISCMD db $slot/$chip/0 eanv_stats dump stats all
	$CHASSISCMD db $slot/$chip/0 eanv_stats dump port_pingpong bufs
		(( dmp_cnt += 1 ))
		sleep 1
	done
	$CHASSISCMD db $slot/$chip/0 eanv_stats dump ioctl_stats all

	#
	# Trunking Commands;
	#
	cmd_title "Trunking Information"
	$CHASSISCMD db $slot/$chip/0 trunk brcd show
	$CHASSISCMD db $slot/$chip/0 trunk brcd print_ifs
	/bin/echo ""

	#
	# FOS RTE Commands
	#
	cmd_title "FOS RTE Information"
	$CHASSISCMD db $slot/$chip/0 fos_rte show if_ids
	$CHASSISCMD db $slot/$chip/0 fos_rte show egid_table
	$CHASSISCMD db $slot/$chip/0 fos_rte show policy
	/bin/echo ""

	#
	# CFM Commands
	#
	cmd_title "CFM Information"
	$CHASSISCMD db $slot/$chip/0 cfm show all
	$CHASSISCMD db $slot/$chip/0 cfm show mem
	/bin/echo ""

	#
	# RTE Commands
	#
	cmd_title "RTE Information"
	$CHASSISCMD db $slot/$chip/0 rte show exm l2 summary
	$CHASSISCMD db $slot/$chip/0 rte show exm ipv4 summary
	$CHASSISCMD db $slot/$chip/0 rte show exm ipv6 summary
	$CHASSISCMD db $slot/$chip/0 rte show exm l2 aging
	$CHASSISCMD db $slot/$chip/0 rte show exm ipv4 used
	$CHASSISCMD db $slot/$chip/0 rte show lpm ipv4 used
	$CHASSISCMD db $slot/$chip/0 rte show mpid l3

	$CHASSISCMD db $slot/$chip/0 rte show l2da used
	$CHASSISCMD db $slot/$chip/0 rte show l2_lrn

	$CHASSISCMD db $slot/$chip/0 rte show lpm ipv4 204
	$CHASSISCMD db $slot/$chip/0 rte show lpm ipv6 204

	$CHASSISCMD db $slot/$chip/0 rte show trill route all
	$CHASSISCMD db $slot/$chip/0 rte show trill mpid all

	$CHASSISCMD db $slot/$chip/0 dbg verify rte

	# Add RTE rev-B related stuff here
#	if [ $eanv_rev != "0" ]; then
#	fi
	/bin/echo ""

	#
	# MCT Commands
	#
	$CHASSISCMD db $slot/$chip/0 mct show vrb map all
	$CHASSISCMD db $slot/$chip/0 mct show l3exm all
	$CHASSISCMD db $slot/$chip/0 mct show l3lpm all
	$CHASSISCMD db $slot/$chip/0 mct show vrb lags
	$CHASSISCMD db $slot/$chip/0 mct show lgid
	$CHASSISCMD db $slot/$chip/0 mct show tcam
	$CHASSISCMD db $slot/$chip/0 mct trace dump
	$CHASSISCMD db $slot/$chip/0 mct show stats all
	/bin/echo ""

	#
	# DMA Commands
	#
	cmd_title "Tx/Rx DMA Information"
	$CHASSISCMD db $slot/$chip/0 txrx show hsi
	$CHASSISCMD db $slot/$chip/0 txrx show info 0
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 0
	$CHASSISCMD db $slot/$chip/0 txrx show info 1
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 1
	$CHASSISCMD db $slot/$chip/0 txrx show info 2
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 2
	$CHASSISCMD db $slot/$chip/0 txrx show info 3
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 3
	$CHASSISCMD db $slot/$chip/0 txrx show info 4
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 4
	$CHASSISCMD db $slot/$chip/0 txrx show stats all
	$CHASSISCMD db $slot/$chip/0 txrx show rxcredit borrow
	$CHASSISCMD db $slot/$chip/0 txrx show rxq stats
	$CHASSISCMD db $slot/$chip/0 txrx show txcredit all
	$CHASSISCMD db $slot/$chip/0 txrx show txq all
	$CHASSISCMD db $slot/$chip/0 txrx dump dmatrace
	$CHASSISCMD db $slot/$chip/0 txrx trace dump
	/bin/echo ""

	#
	# FCOE Commands
	#
	cmd_title "FCOE-BEGIN: Information"
    /bin/echo "======================================================================="

    /bin/echo "FCOE-CMD: Show Chip All"
    /bin/echo "======================================================================="
    $CHASSISCMD db $slot/$chip/0 cfg show chip all

    #/bin/echo "FCOE-CMD: Show the L2 EXM table:"
    #/bin/echo "======================================================================="
    #$CHASSISCMD db $slot/$chip/0 rte show exm l2 used

    /bin/echo "FCOE-CMD: Show the cfg of the L2 TCAM:"
    /bin/echo "======================================================================="
    $CHASSISCMD db $slot/$chip/0 rte show tcam cfg l2

    /bin/echo "FCOE-CMD: Show the list of different regions in L2 TCAM region 0x1002 (FCoE region)"
    /bin/echo "======================================================================="
    $CHASSISCMD db $slot/$chip/0 rte show tcam list 0x1002

    /bin/echo "FCOE-CMD: Show permit entries for all regions"
    /bin/echo "======================================================================="
    $CHASSISCMD db $slot/$chip/0 rte show tcam entry 0x1002 1 -1
    $CHASSISCMD db $slot/$chip/0 rte show tcam entry 0x1002 2 -1
    $CHASSISCMD db $slot/$chip/0 rte show tcam entry 0x1002 3 -1

    /bin/echo "FCOE-CMD: Show L3 FCoE EXM table:"
    /bin/echo "======================================================================="
    $CHASSISCMD db $slot/$chip/0 fcoe chio dmp_nhop rte 0 32
 
    /bin/echo "FCOE-CMD: Show L3 FCoE EXM table:"
    /bin/echo "======================================================================="
   	$CHASSISCMD db $slot/$chip/0 fcoe show all
    
    /bin/echo "FCOE-CMD: Show FCoE DRV All:"
    /bin/echo "======================================================================="
	$CHASSISCMD db $slot/$chip/0 fcoe show drv
    
    /bin/echo "FCOE-CMD: Show FCoE EXM RTE Summary:"
    /bin/echo "======================================================================="
	$CHASSISCMD db $slot/$chip/0 fcoe show exm rte summary
    
    /bin/echo "FCOE-CMD: Show FCoE EXM ZUS Summary:"
    /bin/echo "======================================================================="
	$CHASSISCMD db $slot/$chip/0 fcoe show exm zus summary
    
    /bin/echo "FCOE-CMD: Show FCoE EXM RTE Used:"
    /bin/echo "======================================================================="
	$CHASSISCMD db $slot/$chip/0 fcoe show exm rte used
    
    /bin/echo "FCOE-CMD: Show FCoE EXM ZUS Used:"
    /bin/echo "======================================================================="
	$CHASSISCMD db $slot/$chip/0 fcoe show exm zus used
    
    /bin/echo "FCOE-CMD: Show FCoE Port Error:"
    /bin/echo "======================================================================="
	$CHASSISCMD db $slot/$chip/0 fcoe show port_err

    /bin/echo "FCOE-CMD: Show FCoE Default VFID:"
    /bin/echo "======================================================================="
	$CHASSISCMD db $slot/$chip/0 fcoe show dflt_vfid

    /bin/echo "FCOE-CMD: Show L3 FCoE EXM table Don't care:"
    /bin/echo "======================================================================="
    $CHASSISCMD db $slot/$chip/0 fcoe chio dmp_nhop rte 0xffffffff
 
    /bin/echo "FCOE-CMD: Show L3 FCoE EXM table ZUS:"
    /bin/echo "======================================================================="
    $CHASSISCMD db $slot/$chip/0 fcoe chio dmp_nhop zus 0 64

    /bin/echo "FCOE-END"

	#
	# UPSM Commands
	#
	cmd_title "UPSM Information"
	$CHASSISCMD db $slot/$chip/0 phyp show ports
	$CHASSISCMD db $slot/$chip/0 phyp show serdes
	/bin/echo ""

	port=0
	while [ $port -lt $ports ]; do
		cmd_title "PHY PORT $port Information"
		$CHASSISCMD db $slot/$chip/0 phyp show ctrl $port
		$CHASSISCMD db $slot/$chip/0 phyp show lli $port
		$CHASSISCMD db $slot/$chip/0 phyp show pcs $port
		$CHASSISCMD db $slot/$chip/0 phyp show cnt $port
		$CHASSISCMD db $slot/$chip/0 phyp show hss $port
		$CHASSISCMD db $slot/$chip/0 phyp show proto $port
		$CHASSISCMD db $slot/$chip/0 phyp show ctrl $port 1g
		$CHASSISCMD db $slot/$chip/0 phyp show lli $port kran

		if [ $port -lt $eports ]; then
			$CHASSISCMD db $slot/$chip/0 phyp show epg $port
		else
			$CHASSISCMD db $slot/$chip/0 phyp show fpg $port
		fi

	#
	# CARME specifc 1G port informaton
	#
		if [ $bladeid -eq 118 ]; then
			if [ $port -lt $eports ]; then
				if [ $chip -eq 0 ]; then
					if 	[ $port -ne 16 ] && [ $port -ne 17 ] &&
				   		[ $port -ne 20 ] && [ $port -ne 21 ] &&
				   		[ $port -ne 22 ] && [ $port -ne 23 ]; then
						$CHASSISCMD db $slot/$chip/0 phyp show gmii $port
					fi
				else
					$CHASSISCMD db $slot/$chip/0 phyp show gmii $port
				fi
			fi
		fi
		/bin/echo ""

		(( port += 1 ))
	done
}

start_cbr_cmds()
{
	slot=$1
	chip=$2
	ports=64
	eports=52

	bladeid=`cat /proc/fabos/blade/$1/info | /bin/grep --binary-files=text bladeId | sed 's/[^0-9]//g'`

	# Check Chip Init state
	let init_state=`db dbg show chip | grep init_state | awk '{print $2}'`
	if [ $init_state -ne 6 ] ; then
		echo "*** Chip not initialized.  Regdump skipped. ***"
		echo "init_state = $init_state"
		return 1
	fi

	# Enable Capture 
	#$CHASSISCMD db $slot/$chip/0 txrx bpqhist enable
    /bin/echo ""
	COUNT=1
	while [ $COUNT -gt 0 ]
	do	
    #
    # Reg dump
    #
    cmd_title "Saving Regdump iterations : $COUNT"
    $CHASSISCMD regdump $slot/$chip
    $CHASSISCMD mv /var/regdump.dmp /var/cbrregdump_$COUNT.dmp.$slot.$chip
    $CHASSISCMD gzip -f /var/cbrregdump_$COUNT.dmp.$slot.$chip
    /bin/echo ""
	(( COUNT = $COUNT - 1 ))
	done
	
	#
	# Chip information
	#
	cmd_title "Chip Information"
	$CHASSISCMD db $slot/$chip/0 dbg show chip
	$CHASSISCMD db $slot/$chip/0 cfg show chp_cap
	/bin/echo ""

	#
	# Error Infrastructure
	#
	cmd_title "Error Infrastructure Information"
	$CHASSISCMD db $slot/$chip/0 err show stats
	$CHASSISCMD db $slot/$chip/0 err show err_table
	$CHASSISCMD db $slot/$chip/0 err show cfg_table
	$CHASSISCMD db $slot/$chip/0 err show xlate_table
	/bin/echo ""

	#
	# Stats
	#
	cbr_dmp_cnt=0
	while [ $cbr_dmp_cnt -lt 3 ]; do
	/bin/echo "Counter Dump iteration # $cbr_dmp_cnt:"
	/bin/echo "Stats Information:"
	$CHASSISCMD db $slot/$chip/0 cbr_stat dump stat blk all
	$CHASSISCMD db $slot/$chip/0 cbr_stat dump stat blk inf
	$CHASSISCMD db $slot/$chip/0 cbr_stat dump drop_cnt blk all detail	
	/bin/echo ""	
	(( cbr_dmp_cnt += 1 ))
	sleep 1
	done
	#
	# Trunking Commands
	#
	cmd_title "Trunking Information"
	$CHASSISCMD db $slot/$chip/0 trunk show basic
	$CHASSISCMD db $slot/$chip/0 trunk show all
	/bin/echo ""

	#
	# RTE Commands
	#
	cmd_title "RTE Information"
	$CHASSISCMD db $slot/$chip/0 rte show exm l2 summary
	$CHASSISCMD db $slot/$chip/0 rte show exm ipv4mc summary
	$CHASSISCMD db $slot/$chip/0 rte show exm ipv6mc summary
	$CHASSISCMD db $slot/$chip/0 rte show exm ipv4mcu summary
	$CHASSISCMD db $slot/$chip/0 rte show exm ipv6mcu summary
	$CHASSISCMD db $slot/$chip/0 rte show exm ipv4addr summary
	$CHASSISCMD db $slot/$chip/0 rte show exm ipv6addr summary
	$CHASSISCMD db $slot/$chip/0 rte show exm fcoe summary
	$CHASSISCMD db $slot/$chip/0 rte show exm fcoe used
	$CHASSISCMD db $slot/$chip/0 rte show exm plcyid used
	$CHASSISCMD db $slot/$chip/0 rte show exm ipv4mc used

	$CHASSISCMD db $slot/$chip/0 rte show mpid mct cfg
	$CHASSISCMD db $slot/$chip/0 rte show mpid drb cfg
	$CHASSISCMD db $slot/$chip/0 rte show mpid lag cfg

	$CHASSISCMD db $slot/$chip/0 rte show trill myrb
	$CHASSISCMD db $slot/$chip/0 rte show tcam psel cfg
	$CHASSISCMD db $slot/$chip/0 rte show tcam minipsel cfg
	$CHASSISCMD db $slot/$chip/0 rte show tcam eacl cfg
	$CHASSISCMD db $slot/$chip/0 rte show tcam lpm cfg
	$CHASSISCMD db $slot/$chip/0 rte show tcam l3ctrl cfg
	$CHASSISCMD db $slot/$chip/0 rte show tcam type cfg

	$CHASSISCMD db $slot/$chip/0 rte show tcam psel region list
	$CHASSISCMD db $slot/$chip/0 rte show tcam minipsel region list
	$CHASSISCMD db $slot/$chip/0 rte show tcam eacl region list
	$CHASSISCMD db $slot/$chip/0 rte show tcam type region list

	$CHASSISCMD db $slot/$chip/0 rte show exm stats
	$CHASSISCMD db $slot/$chip/0 rte show span
	/bin/echo ""

	#
	# MCAST Commands
	#
	$CHASSISCMD db $slot/$chip/0 mcast show mgid all
	$CHASSISCMD db $slot/$chip/0 mcast show pet all ipv4
	$CHASSISCMD db $slot/$chip/0 mcast show pet all ipv6
	$CHASSISCMD db $slot/$chip/0 mcast show l2_l3_assoc
	$CHASSISCMD db $slot/$chip/0 mcast show l3_l2_chain_head
	$CHASSISCMD db $slot/$chip/0 mcast show l3_l2_assoc
	$CHASSISCMD db $slot/$chip/0 mcast show bmaprefcnt
	/bin/echo ""

	#
	# MAC refresh Commands
	#
	cmd_title "MAC Refresh Information"
	$CHASSISCMD db $slot/$chip/0 util show mac_refresh ss
	/bin/echo ""

	#
	# DMA Commands
	#
	cmd_title "Tx/Rx DMA Information"
	$CHASSISCMD db $slot/$chip/0 txrx show pib control
	$CHASSISCMD db $slot/$chip/0 txrx show pib errors
	$CHASSISCMD db $slot/$chip/0 txrx show txcredit all
	$CHASSISCMD db $slot/$chip/0 txrx show txq all
	$CHASSISCMD db $slot/$chip/0 txrx show rxq stats
	$CHASSISCMD db $slot/$chip/0 txrx show stats all
	$CHASSISCMD db $slot/$chip/0 txrx show stats all active
	$CHASSISCMD db $slot/$chip/0 txrx show info
	#
	# Dump KA queued packets
	#
	$CHASSISCMD db $slot/$chip/0 txrx dump ka_pkt
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 22 0
	$CHASSISCMD db $slot/$chip/0 txrx show port_info
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 1 0
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 0 0
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 19 0
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 20 0
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 21 0
	
	cbr_port=0 
	cbr_ports=64

	while [ $cbr_port -lt $cbr_ports ]; do
		$CHASSISCMD db $slot/$chip/0 txrx show trap stats $cbr_port
		(( cbr_port += 1 ))
	done
	/bin/echo ""

	#
	# LAG commands
	#
	cmd_title "LAG Information"
	$CHASSISCMD db $slot/$chip/0 lag show local all
	$CHASSISCMD db $slot/$chip/0 lag show flavor
	$CHASSISCMD db $slot/$chip/0 lag show egress table -1
	$CHASSISCMD db $slot/$chip/0 lag show ingress table all
	/bin/echo ""
	
	#
	# FCoE commands
	#
	cmd_title "FCoE Information"
	$CHASSISCMD db $slot/$chip/0 fcoe show basic
	/bin/echo ""
	
	#
	# Commands for AG routes on Cobra
	#
	/bin/echo "FCOE-CMD: Show RTE FCoE EXM:"
	/bin/echo "======================================================================="
	$CHASSISCMD db rte show exm fcoe dump

    /bin/echo "RTE-CMD: Show RTE TCAM PSEL:"
    /bin/echo "=======================================================================" 
	$CHASSISCMD db rte show tcam psel raw 15 0 10000

    /bin/echo "RTE-CMD: Show RTE TAE L2 lookup:"
    /bin/echo "=======================================================================" 
	$CHASSISCMD db rte show capture tae rte0 l2

    /bin/echo "RTE-CMD: Show RTE TAE L3 lookup:"
    /bin/echo "=======================================================================" 
	$CHASSISCMD db rte show capture tae rte0 l3

	#Get the feature_num of LDEV_L3FWD_FCOE
	feature_num=`db $slot/$chip/0 rte show tcam lpm cfg | grep LDEV_L3FWD_FCOE | awk '{print $3}'`

	cmd_title "Area Entries for F-ports"
	$CHASSISCMD db $slot/$chip/0 rte show tcam lpm region entries $feature_num 1 0 100
	
	cmd_title "LPM domain entries"
	$CHASSISCMD db $slot/$chip/0 rte show tcam lpm region entries $feature_num 2 0 100

	cmd_title "Tunnel Map"
	$CHASSISCMD db $slot/$chip/0 tun show tun_map

	cmd_title "Tunnel Mpid"
	$CHASSISCMD db $slot/$chip/0 tun show mpid 0 2047

	cmd_title "vtpt ivf used"
	$CHASSISCMD db $slot/$chip/0 rte show exm vtpt_ivf used

	cmd_title "vtpt evf used"
	$CHASSISCMD db $slot/$chip/0 rte show exm vtpt_evf used

    /bin/echo "AG-ROUTES-END"

	#
	# UPSM Commands
	#
	cmd_title "UPSM Information"
	$CHASSISCMD db $slot/$chip/0 phyp show ports
	$CHASSISCMD db $slot/$chip/0 phyp show serdes
	/bin/echo ""

	#
	# CastorT specifc 1G port informaton
	#
	if [ $bladeid -eq 145 ] || [ $bladeid -eq 159 ] || [ $bladeid -eq 174 ]; then
		cmd_title "AQPHY Quad Information"
		$CHASSISCMD db $slot/$chip/0 xphy show -status -chip 0 -quad 0
		$CHASSISCMD db $slot/$chip/0 xphy show -status -chip 1 -quad 0
		$CHASSISCMD db $slot/$chip/0 xphy show -status -chip 2 -quad 0
		$CHASSISCMD db $slot/$chip/0 xphy show -status -chip 3 -quad 0
		$CHASSISCMD db $slot/$chip/0 xphy show -status -chip 4 -quad 0
		$CHASSISCMD db $slot/$chip/0 xphy show -status -chip 5 -quad 0
		$CHASSISCMD db $slot/$chip/0 xphy show -status -chip 6 -quad 0
		$CHASSISCMD db $slot/$chip/0 xphy show -status -chip 7 -quad 0
		$CHASSISCMD db $slot/$chip/0 xphy show -status -chip 8 -quad 0
		$CHASSISCMD db $slot/$chip/0 xphy show -status -chip 9 -quad 0
		$CHASSISCMD db $slot/$chip/0 xphy show -status -chip 10 -quad 0
		$CHASSISCMD db $slot/$chip/0 xphy show -status -chip 11 -quad 0
		port=1
		fe_port=48
		while [ $port -le $fe_port ]; do
			cmd_title "AQPHY PORT $port Information"
			$CHASSISCMD db $slot/$chip/0 xphy show -reg -mmd 1 -port $port
			$CHASSISCMD db $slot/$chip/0 xphy show -reg -mmd 3 -port $port
			$CHASSISCMD db $slot/$chip/0 xphy show -reg -mmd 7 -port $port
			$CHASSISCMD db $slot/$chip/0 xphy show -stats -port $port -reg
			/bin/echo ""
			(( port += 1 ))
		done
	/bin/echo ""
	fi

	#
	# Dump Captured packets 
	#
	$CHASSISCMD db $slot/$chip/0 txrx bpqhist show all
	$CHASSISCMD db $slot/$chip/0 txrx bpqhist disable
	/bin/echo ""

}

start_cbr2_cmds()
{
	slot=$1
	chip=$2
	ports=144
	eports=52

	bladeid=`cat /proc/fabos/blade/$1/info | /bin/grep --binary-files=text bladeId | sed 's/[^0-9]//g'`

	# Check Chip Init state
	let init_state=`db dbg show chip | grep init_state | awk '{print $2}'`
	if [ $init_state -ne 6 ] ; then
		$ECHO "*** Chip not initialized.  Regdump skipped. ***"
		echo "init_state = $init_state"
		return 1
	fi
	$ECHO "*** Chip initialized.  Regdump  ***"

	# Enable Capture 
	$CHASSISCMD db $slot/$chip/0 txrx bpqhist enable
    /bin/echo ""

    #
    # Reg dump
    #
    cmd_title "Saving Regdump"
    $CHASSISCMD regdump $slot/$chip
    $CHASSISCMD mv /var/regdump.dmp /var/cbr2regdump.dmp.$slot.$chip
    $CHASSISCMD gzip -f /var/cbr2regdump.dmp.$slot.$chip
    /bin/echo ""
	
    #
    # utildmp 
    #
    cmd_title "Saving utildump"
    $CHASSISCMD utildump $slot/$chip
    $CHASSISCMD mv /var/tcamdump.dmp /var/cbr2tcamdump.dmp.$slot.$chip
    $CHASSISCMD mv /var/cfgdump.dmp /var/cbr2cfgdump.dmp.$slot.$chip
    $CHASSISCMD mv /var/exmdump.dmp /var/cbr2exmdump.dmp.$slot.$chip
    $CHASSISCMD mv /var/lpmdump.dmp /var/cbr2lpmdump.dmp.$slot.$chip
    $CHASSISCMD gzip -f /var/cbr2tcamdump.dmp.$slot.$chip
    $CHASSISCMD gzip -f /var/cbr2exmdump.dmp.$slot.$chip
    $CHASSISCMD gzip -f /var/cbr2cfgdump.dmp.$slot.$chip
    $CHASSISCMD gzip -f /var/cbr2lpmdump.dmp.$slot.$chip
    /bin/echo ""
	#
	# Chip information
	#
	cmd_title "Chip Information"
	$CHASSISCMD db $slot/$chip/0 dbg show chip
	$CHASSISCMD db $slot/$chip/0 cfg show chp_cap
	/bin/echo ""

	#
	# Error Infrastructure
	#
	cmd_title "Error Infrastructure Information"
	$CHASSISCMD db $slot/$chip/0 err show stats
	$CHASSISCMD db $slot/$chip/0 err show err_table
	$CHASSISCMD db $slot/$chip/0 err show cfg_table
	$CHASSISCMD db $slot/$chip/0 err show xlate_table
	/bin/echo ""

	#
	# Stats
	#
	/bin/echo "Stats Information:"
	$CHASSISCMD db $slot/$chip/0 cbr2_stat dump stat blk all
	$CHASSISCMD db $slot/$chip/0 cbr2_stat dump stat blk inf
	$CHASSISCMD db $slot/$chip/0 cbr2_stat dump drop_cnt blk all detail	
	/bin/echo ""	

	#
	# Trunking Commands
	#
	cmd_title "Trunking Information"
	$CHASSISCMD db $slot/$chip/0 trunk show basic
	$CHASSISCMD db $slot/$chip/0 trunk show all
	/bin/echo ""

	#
	# RTE Commands
	#
	cmd_title "RTE Information"
	$CHASSISCMD db $slot/$chip/0 rte show exm l2 summary
	$CHASSISCMD db $slot/$chip/0 rte show exm ipv4mc summary
	$CHASSISCMD db $slot/$chip/0 rte show exm ipv6mc summary
	$CHASSISCMD db $slot/$chip/0 rte show exm ipv4mcu summary
	$CHASSISCMD db $slot/$chip/0 rte show exm ipv6mcu summary
	$CHASSISCMD db $slot/$chip/0 rte show exm ipv4addr summary
	$CHASSISCMD db $slot/$chip/0 rte show exm ipv6addr summary
	$CHASSISCMD db $slot/$chip/0 rte show exm fcoe summary
	$CHASSISCMD db $slot/$chip/0 rte show exm fcoe used
	$CHASSISCMD db $slot/$chip/0 rte show exm plcyid used
	$CHASSISCMD db $slot/$chip/0 rte show exm ipv4mc used

	$CHASSISCMD db $slot/$chip/0 rte show mpid mct cfg
	$CHASSISCMD db $slot/$chip/0 rte show mpid drb cfg
	$CHASSISCMD db $slot/$chip/0 rte show mpid lag cfg

	$CHASSISCMD db $slot/$chip/0 rte show trill myrb
	$CHASSISCMD db $slot/$chip/0 rte show tcam psel cfg
	$CHASSISCMD db $slot/$chip/0 rte show tcam minipsel cfg
	$CHASSISCMD db $slot/$chip/0 rte show tcam eacl cfg
	$CHASSISCMD db $slot/$chip/0 rte show tcam lpm cfg
	$CHASSISCMD db $slot/$chip/0 rte show tcam l3ctrl cfg
	$CHASSISCMD db $slot/$chip/0 rte show tcam type cfg

	$CHASSISCMD db $slot/$chip/0 rte show tcam psel region list
	$CHASSISCMD db $slot/$chip/0 rte show tcam minipsel region list
	$CHASSISCMD db $slot/$chip/0 rte show tcam eacl region list
	$CHASSISCMD db $slot/$chip/0 rte show tcam type region list

	$CHASSISCMD db $slot/$chip/0 rte show exm stats
	$CHASSISCMD db $slot/$chip/0 rte show span
	/bin/echo ""

	#
	# MCAST Commands
	#
	$CHASSISCMD db $slot/$chip/0 mcast show mgid all
	$CHASSISCMD db $slot/$chip/0 mcast show pet all ipv4
	$CHASSISCMD db $slot/$chip/0 mcast show pet all ipv6
	$CHASSISCMD db $slot/$chip/0 mcast show l2_l3_assoc
	$CHASSISCMD db $slot/$chip/0 mcast show l3_l2_chain_head
	$CHASSISCMD db $slot/$chip/0 mcast show l3_l2_assoc
	$CHASSISCMD db $slot/$chip/0 mcast show bmaprefcnt
	/bin/echo ""


    cmd_title "Tunnel Map"
    $CHASSISCMD db $slot/$chip/0 tun show tun_map
    $CHASSISCMD db $slot/$chip/0 tun show egr_tun
    $CHASSISCMD db $slot/$chip/0 tun show ing_tun
    $CHASSISCMD db $slot/$chip/0 tun show ing_tun_internal
	$CHASSISCMD db $slot/$chip/0 rte show exm tun_da_ipv4 dump 

    cmd_title "Tunnel Mpid"
    $CHASSISCMD db $slot/$chip/0 tun show mpid 0 2047

	#
	# MAC refresh Commands
	#
	cmd_title "MAC Refresh Information"
	$CHASSISCMD db $slot/$chip/0 util show mac_refresh ss
	/bin/echo ""

	#
	# DMA Commands
	#
	cmd_title "Tx/Rx DMA Information"
	$CHASSISCMD db $slot/$chip/0 txrx show pib control
	$CHASSISCMD db $slot/$chip/0 txrx show pib errors
	$CHASSISCMD db $slot/$chip/0 txrx show txcredit all
	$CHASSISCMD db $slot/$chip/0 txrx show txq all
	$CHASSISCMD db $slot/$chip/0 txrx show rxq stats
	$CHASSISCMD db $slot/$chip/0 txrx show stats all
	$CHASSISCMD db $slot/$chip/0 txrx show stats all active
	$CHASSISCMD db $slot/$chip/0 txrx show info
	#
	# Dump KA queued packets
	#
	$CHASSISCMD db $slot/$chip/0 txrx dump ka_pkt
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 22 0
	$CHASSISCMD db $slot/$chip/0 txrx show port_info
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 1 0
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 0 0
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 19 0
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 20 0
	$CHASSISCMD db $slot/$chip/0 txrx dump desc 21 0
	
	cbr2_port=0 
	cbr2_ports=144

	while [ $cbr2_port -lt $cbr2_ports ]; do
		$CHASSISCMD db $slot/$chip/0 txrx show trap stats $cbr2_port
		(( cbr2_port += 1 ))
	done
	/bin/echo ""

	#
	# LAG commands
	#
	cmd_title "LAG Information"
	$CHASSISCMD db $slot/$chip/0 lag show local all
	$CHASSISCMD db $slot/$chip/0 lag show flavor
	$CHASSISCMD db $slot/$chip/0 lag show egress table -1
	$CHASSISCMD db $slot/$chip/0 lag show ingress table all
	/bin/echo ""
	
	#
	# FCoE commands
	#
	cmd_title "FCoE Information"
	$CHASSISCMD db $slot/$chip/0 fcoe show basic
	/bin/echo ""
	
	#
	# UPSM Commands
	#
	cmd_title "UPSM Information"
	$CHASSISCMD db $slot/$chip/0 phyp show ports
	$CHASSISCMD db $slot/$chip/0 phyp show serdes
	/bin/echo ""

	#
	# Dump Captured packets 
	#
	$CHASSISCMD db $slot/$chip/0 txrx bpqhist show all
	$CHASSISCMD db $slot/$chip/0 txrx bpqhist disable
	/bin/echo ""

}

	
start_zeus_cmds()
{
	slot=$1
	chip=$2
	ports=24

	#
	# Stats
	#
	cmd_title "Stats Information"
	$CHASSISCMD db $slot/$chip/0 dbg show stats
	/bin/echo ""

	#
	# Trace
	#
	cmd_title "Trace Information"
	$CHASSISCMD db $slot/$chip/0 dbg show trace
	/bin/echo ""

	#
	# Chip
	#
	cmd_title "Chip Information"
	$CHASSISCMD db $slot/$chip/0 dbg show chip
	/bin/echo ""

	#
	# lue
	#
	cmd_title "LUE Information"
	$CHASSISCMD db $slot/$chip/0 dbg show lue
	/bin/echo ""

	#
	# fce
	#
	cmd_title "FCE Information"
	$CHASSISCMD db $slot/$chip/0 dbg show fce 0
	$CHASSISCMD db $slot/$chip/0 dbg show fce 1
	/bin/echo ""

	#
	# fcd
	#
	cmd_title "FCD Information"
	$CHASSISCMD db $slot/$chip/0 dbg show fcd 0
	$CHASSISCMD db $slot/$chip/0 dbg show fcd 1
	/bin/echo ""

	#
	# fce
	#
	cmd_title "FPG Information"
	$CHASSISCMD db $slot/$chip/0 dbg show fpg 0
	$CHASSISCMD db $slot/$chip/0 dbg show fpg 1
	/bin/echo ""

	#
	# fcm
	#
	cmd_title "fcm Information"
	$CHASSISCMD db $slot/$chip/0 dbg show fcm 0 0
	$CHASSISCMD db $slot/$chip/0 dbg show fcm 0 1
	$CHASSISCMD db $slot/$chip/0 dbg show fcm 0 2
	$CHASSISCMD db $slot/$chip/0 dbg show fcm 0 3
	$CHASSISCMD db $slot/$chip/0 dbg show fcm 0 0
	$CHASSISCMD db $slot/$chip/0 dbg show fcm 1 1
	$CHASSISCMD db $slot/$chip/0 dbg show fcm 2 2
	$CHASSISCMD db $slot/$chip/0 dbg show fcm 3 3
	/bin/echo ""

	#
	# proto
	#
	cmd_title "proto Information"
	$CHASSISCMD db $slot/$chip/0 dbg show proto
	/bin/echo ""

	#
	# eport
	#
	cmd_title "eport Information"
	$CHASSISCMD db $slot/$chip/0 dbg show eport
	/bin/echo ""

	#
	# emac
	#
	cmd_title "emac Information"
	$CHASSISCMD db $slot/$chip/0 dbg show emac 0
	$CHASSISCMD db $slot/$chip/0 dbg show emac 1
	/bin/echo ""

	#
	# emac
	#
	cmd_title "flc Information"
	$CHASSISCMD db $slot/$chip/0 dbg show flc 0
	$CHASSISCMD db $slot/$chip/0 dbg show flc 1	
	/bin/echo ""
}

scimitar_port_()
{
	cmd_title "ptsupportshow"
	if [ $slot = 0 ]; then
		$CHASSISCMD ptsupportshow -all
	else
		$CHASSISCMD ptsupportshow $slot -all
	fi
	/bin/echo ""
}

striker_filter_()
{
	if [ $slot = 0 ]; then
		/bin/echo "ptfilterportshow 1"
		$CHASSISCMD ptfilterportshow 1
		/bin/echo "ptstatsshow 1"
		$CHASSISCMD ptstatsshow 1
		/bin/echo "ptregshow 1"
		$CHASSISCMD ptregshow 1
		/bin/echo "ptfilterportshow 3"
		$CHASSISCMD ptfilterportshow 3
		/bin/echo "ptstatsshow 3"
		$CHASSISCMD ptstatsshow 3
		/bin/echo "ptregshow 3"
		$CHASSISCMD ptregshow 3
		/bin/echo "ptfilterportshow 5"
		$CHASSISCMD ptfilterportshow 5
		/bin/echo "ptstatsshow 5"
		$CHASSISCMD ptstatsshow 5
		/bin/echo "ptregshow 5"
		$CHASSISCMD ptregshow 5
		/bin/echo "ptfilterportshow 6"
		$CHASSISCMD ptfilterportshow 6
		/bin/echo "ptstatsshow 6"
		$CHASSISCMD ptstatsshow 6
		/bin/echo "ptregshow 6"
		$CHASSISCMD ptregshow 6
		/bin/echo "ptfilterportshow 7"
		$CHASSISCMD ptfilterportshow 7
		/bin/echo "ptstatsshow 7"
		$CHASSISCMD ptstatsshow 7
		/bin/echo "ptregshow 7"
		$CHASSISCMD ptregshow 7
		/bin/echo ""
	else
		for k in `seq 24 28`; do
			/bin/echo "ptfilterportshow $slot/$k"
			$CHASSISCMD ptfilterportshow $slot/$k
			/bin/echo "ptstatsshow $slot/$k"
			$CHASSISCMD ptstatsshow $slot/$k
			/bin/echo "ptregshow $slot/$k"
			$CHASSISCMD ptregshow $slot/$k
		done
		for k in `seq 0 4`; do
			/bin/echo "ptfilterportshow $slot/$k"
			$CHASSISCMD ptfilterportshow $slot/$k
			/bin/echo "ptstatsshow $slot/$k"
			$CHASSISCMD ptstatsshow $slot/$k
			/bin/echo "ptregshow $slot/$k"
			$CHASSISCMD ptregshow $slot/$k
		done
		for k in `seq 11 15`; do
			/bin/echo "ptfilterportshow $slot/$k"
			$CHASSISCMD ptfilterportshow $slot/$k
			/bin/echo "ptstatsshow $slot/$k"
			$CHASSISCMD ptstatsshow $slot/$k
			/bin/echo "ptregshow $slot/$k"
			$CHASSISCMD ptregshow $slot/$k
		done
		for k in `seq 17 21`; do
			/bin/echo "ptfilterportshow $slot/$k"
			$CHASSISCMD ptfilterportshow $slot/$k
			/bin/echo "ptstatsshow $slot/$k"
			$CHASSISCMD ptstatsshow $slot/$k
			/bin/echo "ptregshow $slot/$k"
			$CHASSISCMD ptregshow $slot/$k
		done
	fi

	/bin/echo ""
}

f_callisto_24_filter_()
{
	for k in `seq 0 7`; do
		/bin/echo "filterportshow 0/$k"
		$CHASSISCMD filterportshow 0/$k
	done

	/bin/echo ""

	for k in `seq 8 39`; do
	    cmd_title "0/0 rte nhop p$k"
	    $CHASSISCMD db 0/0 rte show nhop p$k
	    /bin/echo ""
	done
}

f_callisto_60_filter_()
{
	for k in `seq 0 15`; do
		/bin/echo "filterportshow 0/$k"
		$CHASSISCMD filterportshow 0/$k
	done

	/bin/echo ""

	for k in `seq 0 39`; do
	    cmd_title "0/9 rte nhop p$k"
	    $CHASSISCMD db 0/9 rte show nhop p$k
	    /bin/echo ""
	done
}
# *******************************************
# Collect Dmesg and Ftrace occur during ffdc event
# *******************************************
#DM_FTR_FFDC,/fabos/cliexec/ssave.sh --dmesg,/bin/rm -f /var/log/*.tar,/var/log/Dmsg_Ftr_ffdc.tar,N,N,N,Y,Y,2,
# *******************************************
start_dmesg()
{
	nfile=`ls -l /var/log/ | grep Dmesg* | wc -l`
	if [ "$nfile" -eq 0 ]
	then
		$ECHO "No Dmesg* files found" > /var/log/Dmsg_Ftr_ffdc
		tar cvPf /var/log/Dmsg_Ftr_ffdc.tar /var/log/Dmsg_Ftr_ffdc
		return 0
	fi
	tar cvPf /var/log/Dmesg_ffdc.tar /var/log/Dmesg* 
	tar cvPf /var/log/Ftrace_ffdc.tar /var/log/Ftrace*
	tar cvPf /var/log/Dmsg_Ftr_ffdc.tar /var/log/Dmesg_ffdc.tar /var/log/Ftrace_ffdc.tar
	rm /var/log/Dmesg*
	return 0
}


# *******************************************
# Collect CRYP /Mace
# *******************************************
#CVLMD_DBG,/fabos/link_bin/cryptodbg --show -v, , ,N,N,N,N,N,5,
#CVLMD_INFO,/bin/cat /tmp/cvlm_lun.txt /tmp/cvlm_wwn_map.txt /tmp/cd.txt, , ,Y,Y,N,N,Y,5,
#SPM_DBG,/fabos/libexec/spmCmds, , ,N,N,N,N,N,5,
# *******************************************
start_cryp()
{
    if [ $standby = no ]
    then
	$CHASSISCMD /fabos/bin/cryptodbg --show -v

	$CHASSISCMD  /bin/cat /tmp/cvlm_lun.txt
    if [ -f /tmp/cvlm_lun.txt ]
    then
	    /bin/rm -f /tmp/cvlm_lun.txt
    fi
    

	$CHASSISCMD  /bin/cat /tmp/cvlm_wwn_map.txt
    if [ -f /tmp/cvlm_wwn_map.txt ]
    then
	    /bin/rm -f /tmp/cvlm_wwn_map.txt
    fi

	$CHASSISCMD  /bin/cat /tmp/cd.txt
    if [ -f /tmp/cd.txt ]
    then
	    /bin/rm -f /tmp/cd.txt
    fi

	$CHASSISCMD  /fabos/libexec/spmCmds
	
	$CHASSISCMD /fabos/libexec/cnmdbg --cs

	$CHASSISCMD /fabos/libexec/cnmdbg --ds

	$CHASSISCMD /fabos/libexec/cnmdbg --ns

	$CHASSISCMD /fabos/libexec/cnmdbg --hs
	
	$CHASSISCMD /fabos/libexec/cnmdbg --evth

	$CHASSISCMD /fabos/libexec/cnmdbg --cfgs

	$CHASSISCMD  /bin/cat /etc/fabos/mace/cnm_hbt.log

	$CHASSISCMD  /bin/cat /etc/fabos/mace/cnm_node.log

	cmd_title "cnm_node.log"
	$CHASSIS /bin/cat /etc/fabos/mace/cnm_node.log
	/bin/echo ""
	fi
}

# *******************************************
# Collect FCIP Spike/Striker
# *******************************************
start_fcip()
{
    if [ $sw_platform = 83 ]; then
        spike_internal_cmds
    elif [ $sw_platform = 62 -o $sw_platform = 77 ]; then
        cd /proc/fabos/blade
        for j in `ls -d [0-9]* | sort -n` ; do
            # check for return status stored in $?.
            asic_db_blade_type_ $j
            if [ "$?" -eq 0 ]; then
                if [ "$blade_type" = "striker" ]; then
                    striker_internal_cmds $j
                fi
            fi
        done
    fi
}

spike_internal_cmds()
{
    $CHASSISCMD date

    # Test if DP is up
    spiker_test_dp_up 16
    DP_UP=$?

    # Check for IPSec enabled tunnels on DP's
    spike_ipsec_on_dp
    ipsec_on_dp=$?

    if [ "$DP_UP" -eq 0 ]; then
        $ECHO "Detected DP to be down!"
    else
        $ECHO "Detected DP to be up!"
    fi

    if [ "$DP_UP" -eq 1 ] && [ "$ipsec_on_dp" -eq 1 ]; then
        spiker_security_dbg ge0
    elif [ "$DP_UP" -eq 1 ] && [ "$ipsec_on_dp" -eq 0 ]; then
        $ECHO "No IPSec tunnels detected on Spike DP"
    else
        $ECHO "Skipping IPSec debug commands due to DP down."
    fi

    $CHASSISCMD date
}

striker_internal_cmds()
{
    $CHASSISCMD date

    # Forcing SWITCHCMD to execute in a non-VF mode.
    # Optimized iteration of logical switches will be
    # handled below.     
    ORIGINAL_SWITCHCMD="$SWITCHCMD"
    SWITCHCMD='cmd_nonvf' 
    # Variables to be used to signify if DP's are up
    DP0_UP=1
    DP1_UP=1

    # VF mode is enabled
    if [ -n "$HOME_VF" ]; then
        # Get Configured Logical Switches and Corresponding FIDs
        ls_fids=( `lscfg_test --all | sed 's/^[ \t]*[^ \t]*[ \t]*//;s/[ \t].*//;/[0-9]/!d'` )
        # Test if DP's are up
        for (( i=0; i < ${#ls_fids[@]}; i++ )); do
            setcontext ${ls_fids[$i]} $i

            # Get VEs in current logical switch
            ve_ports=( `switchshow -slot $1 | sed '/VE/!d;s/^[ \t]*[^ \t]*[ \t]*//;s/^[^ \t]*[ \t]*//;s/[ \t].*//'` )
            for (( j=0; j < ${#ve_ports[@]}; j++ )); do
                if [ ${ve_ports[$j]} -eq 12 ]; then
                    spiker_test_dp_up $1/12
                    DP0_UP=$?
                fi
                if [ ${ve_ports[$j]} -eq 22 ]; then
                    spiker_test_dp_up $1/22
                    DP1_UP=$?
                fi
            done
        done

        if [ "$DP0_UP" -eq 0 ]; then
            $ECHO "Detected DP0 to be down!"
        else
            $ECHO "Detected DP0 to be up!"
        fi
        if [ "$DP1_UP" -eq 0 ]; then
            $ECHO "Detected DP1 to be down!"
        else
            $ECHO "Detected DP1 to be up!"
        fi

        # Display Security Information for ge0
        for (( i=0; i < ${#ls_fids[@]}; i++ )); do
            setcontext ${ls_fids[$i]} $i

            # Get GEs in current logical switch
            ge_ports=( `switchshow -slot $1 | sed '/FCIP/!d;s/^[ \t]*[^ \t]*[ \t]*//;s/[ \t].*//'` )

            # Check for IPSec enabled tunnels on DP's
            striker_ipsec_on_dps $1
            ipsec_dps=$?

            if [ "$ipsec_dps" -eq 3 ]; then
                ipsec_on_dp0=1
                ipsec_on_dp1=1
            elif [ "$ipsec_dps" -eq 2 ]; then
                ipsec_on_dp0=0
                ipsec_on_dp1=1
            elif [ "$ipsec_dps" -eq 1 ]; then
                ipsec_on_dp0=1
                ipsec_on_dp1=0
            else
                ipsec_on_dp0=0
                ipsec_on_dp1=0
            fi

            # Security Information
            for (( j=0; j < ${#ge_ports[@]}; j++ )); do
                if [ ${ge_ports[$j]} = 'ge0' ]; then
                    if [ "$DP0_UP" -eq 1 ] &&  [ "$ipsec_on_dp0" -eq 1 ]; then
                        spiker_security_dbg $1/ge0
                    elif [ "$DP0_UP" -eq 1 ] && [ "$ipsec_on_dp0" -eq 0 ]; then
                        $ECHO "No IPSec tunnels detected on Striker slot: $1 DP0"
                    else
                        $ECHO "Skipping IPSec debug commands due to Striker slot: $1 DP0 down"
                    fi
                elif [ ${ge_ports[$j]} = 'xge0' ]; then
                    if [ "$DP1_UP" -eq 1 ] && [ "$ipsec_on_dp1" -eq 1 ]; then
                        spiker_security_dbg $1/xge0
                    elif [ "$DP1_UP" -eq 1 ] && [ "$ipsec_on_dp1" -eq 0 ]; then
                        $ECHO "No IPSec tunnels detected on Striker slot: $1 DP1"
                    else
                        $ECHO "Skipping IPSec debug commands due to Striker slot: $1 DP1 down"
                    fi
                fi
            done
        done
    else # Non-VF mode
        # Test if DP's are up
        spiker_test_dp_up $1/12
        DP0_UP=$?
        spiker_test_dp_up $1/22
        DP1_UP=$?

        if [ "$DP0_UP" -eq 0 ]; then
            $ECHO "Detected DP0 to be down!"
        else
            $ECHO "Detected DP0 to be up!"
        fi
        if [ "$DP1_UP" -eq 0 ]; then
            $ECHO "Detected DP1 to be down!"
        else
            $ECHO "Detected DP1 to be up!"
        fi

        # Check for IPSec enabled tunnels on DP's
        striker_ipsec_on_dps $1
        ipsec_dps=$?

        if [ "$ipsec_dps" -eq 3 ]; then
            ipsec_on_dp0=1
            ipsec_on_dp1=1
        elif [ "$ipsec_dps" -eq 2 ]; then
            ipsec_on_dp0=0
            ipsec_on_dp1=1
        elif [ "$ipsec_dps" -eq 1 ]; then
            ipsec_on_dp0=1
            ipsec_on_dp1=0
        else
            ipsec_on_dp0=0
            ipsec_on_dp1=0
        fi

        # Display Security Information
        if [ "$DP0_UP" -eq 1 ] && [ "$ipsec_on_dp0" -eq 1 ]; then
            spiker_security_dbg $1/ge0
        elif [ "$DP0_UP" -eq 1 ] && [ "$ipsec_on_dp0" -eq 0 ]; then 
            $ECHO "No IPSec tunnels detected on Striker slot: $1 DP0"
        else
            $ECHO "Skipping IPSec debug commands due to Striker slot: $1 DP0 down"
        fi

        if [ "$DP1_UP" -eq 1 ] && [ "$ipsec_on_dp1" -eq 1 ]; then
            spiker_security_dbg $1/xge0
        elif [ "$DP1_UP" -eq 1 ] && [ "$ipsec_on_dp1" -eq 0 ]; then
            $ECHO "No IPSec tunnels detected on Striker slot: $1 DP1"
        else
            $ECHO "Skipping IPSec debug commands due to Striker slot: $1 DP1 down"
        fi
    fi

    # Restore Original SWITCHCMD variable
    SWITCHCMD="$ORIGINAL_SWITCHCMD"

    $CHASSISCMD date
}

spike_ipsec_on_dp()
{
    local ipsec_on_dp=0

    local ipsec_ves=`configshow | sed "/xportCfg.VE.*XFCIPTUNNEL.*IPSec=1.*/!d;s/.*VE\([0-9]*\).*/\1/"`            
    for ipsec_ve in $ipsec_ves; do
        case "$ipsec_ve" in
        16|17|18|19|20|21)
            ipsec_on_dp=1
            ;;
        esac
    done 
    
    return "$ipsec_on_dp"
}

striker_ipsec_on_dps()
{
    local ipsec_on_dp0=0
    local ipsec_on_dp1=0

    local ipsec_ve_on_cur_slot=`configshow | sed "/xportCfg.S$1.VE.*XFCIPTUNNEL.*IPSec=1.*/!d;s/.*VE\([0-9]*\).*/\1/"`          
    for ipsec_ve in $ipsec_ve_on_cur_slot; do
        case "$ipsec_ve" in
        12|13|14|15|16|17|18|19|20|21)
            ipsec_on_dp0=1
            ;;
        22|23|24|25|26|27|28|29|30|31)
            ipsec_on_dp1=1
            ;;
        esac
    done 
    
    if [ "$ipsec_on_dp1" -eq 1 ] && [ "$ipsec_on_dp0" -eq 1 ]; then
        return 3
    elif [ "$ipsec_on_dp1" -eq 1 ] && [ "$ipsec_on_dp0" -eq 0 ]; then
        return 2
    elif [ "$ipsec_on_dp1" -eq 0 ] && [ "$ipsec_on_dp0" -eq 1 ]; then
        return 1
    else
        return 0
    fi
}

spiker_test_dp_up()
{
    local dp_up=1

    local rc_dp=`portshow xtun $1 -fcp -itl -info|sed -n 's/.*rc = \([a-fA-F0-9]*\)/\1/p'`

    if [ "$rc_dp" == 'fffffffc' ]; then
        dp_up=0
    fi

    return $dp_up
}

spiker_security_dbg()
{
    $ECHO  /*------------------------------------------------
    $ECHO  Dumping Individual SA Logs:
    $ECHO  ------------------------------------------------*/

    for tt in 0 1 2 3 4 5 6 7 8 9 a b c d e f; do
        $ECHO  "IKEv2_Dump_SA_Log_00_0$tt"
        $SWITCHCMD /fabos/cliexec/portshow fcipdebug $1 ipsec IKEv2_Dump_SA_Log_00_0$tt
    done

    $ECHO  /*------------------------------------------------
    $ECHO  SPD Summary:
    $ECHO  ------------------------------------------------*/
    $ECHO  "IKEv2_Dump_SPD_Table"
    $SWITCHCMD /fabos/cliexec/portshow fcipdebug $1 ipsec IKEv2_Dump_SPD_Table

    $ECHO  /*------------------------------------------------
    $ECHO  IKEv2 Session Summary
    $ECHO  ------------------------------------------------*/
    $ECHO  "IKEv2_Dump_IKEv2_Dump_IKEv2_Summary"
    $SWITCHCMD /fabos/cliexec/portshow fcipdebug $1 ipsec IKEv2_Dump_IKEv2_Summary

    $ECHO  /*------------------------------------------------
    $ECHO  SADB Summary:
    $ECHO  ------------------------------------------------*/
    $ECHO  "IKEv2_Dump_SA_Summary"
    $SWITCHCMD /fabos/cliexec/portshow fcipdebug $1 ipsec IKEv2_Dump_SA_Summary

    $ECHO  /*------------------------------------------------
    $ECHO   SA_DI_SPI_Loop Summary:
    $ECHO  ------------------------------------------------*/
    $ECHO  "Mstr_Dump_SA_DA_SPI_Ram_00"
    $SWITCHCMD /fabos/cliexec/portshow fcipdebug $1 ipsec Mstr_Dump_SA_DA_SPI_Ram_00
    $ECHO  "Mstr_Dump_SA_DA_SPI_Ram_01"
    $SWITCHCMD /fabos/cliexec/portshow fcipdebug $1 ipsec Mstr_Dump_SA_DA_SPI_Ram_01

    $ECHO  /*------------------------------------------------
    $ECHO  Cavium Key Memory:
    $ECHO  ------------------------------------------------*/
    $ECHO  "IKEv2_Dump_Cavium_Key_Memory_Control_Block_Array"
    $SWITCHCMD /fabos/cliexec/portshow fcipdebug $1 ipsec IKEv2_Dump_Cavium_Key_Memory_Control_Block_Array
    
    $ECHO  /*------------------------------------------------
    $ECHO  Master Log for both IKE/IPSEC and Ethernet-Driver
    $ECHO  ------------------------------------------------*/
    $ECHO  "Mstr_log"
    $SWITCHCMD /fabos/cliexec/portshow fcipdebug $1 ipsec Mstr_log 

    $ECHO  /*------------------------------------------------
    $ECHO  Master IPsec log:
    $ECHO  ------------------------------------------------*/
    $ECHO  "Mstr_ipsec_log"
    $SWITCHCMD /fabos/cliexec/portshow fcipdebug $1 ipsec Mstr_ipsec_log

    $ECHO  /*------------------------------------------------
    $ECHO  Master IKEv2 Log:
    $ECHO  ------------------------------------------------*/
    $ECHO  "Mstr_ikev2_log"
    $SWITCHCMD /fabos/cliexec/portshow fcipdebug $1 ipsec Mstr_ikev2_log

    $ECHO  /*------------------------------------------------
    $ECHO  Blaster Registers:
    $ECHO  ------------------------------------------------*/
    $ECHO  "Mstr_Dump_Blaster_Registers_00"
    $SWITCHCMD /fabos/cliexec/portshow fcipdebug $1 ipsec Mstr_Dump_Blaster_Registers_00
    $ECHO  "Mstr_Dump_SALT_Memory_00"
    $SWITCHCMD /fabos/cliexec/portshow fcipdebug $1 ipsec Mstr_Dump_SALT_Memory_00
    $ECHO  "Mstr_Revision"
    $SWITCHCMD /fabos/cliexec/portshow fcipdebug $1 ipsec Mstr_Revision

    $ECHO  /*------------------------------------------------
    $ECHO  IKEv2 Session Control Block Summary:
    $ECHO  ------------------------------------------------*/
    $ECHO  "IKEv2_Dump_IKEv2_Session_Control_Block_Array"
    $ECHO  portshow fcipdebug 1/ge0 ipsec IKEv2_Dump_IKEv2_Session_Control_Block_Array

    $ECHO  /*------------------------------------------------
    $ECHO  Individual IKEv2 Session Control blocks:
    $ECHO  ------------------------------------------------*/

    for tt in 0 1 2 3 4 5 6 7 8 9 a b c d e f; do
        $ECHO  "IKEv2_Dump_IKEv2_Session_Control_Block_Entry_0$tt"
        $SWITCHCMD /fabos/cliexec/portshow fcipdebug $1 ipsec IKEv2_Dump_IKEv2_Session_Control_Block_Entry_0$tt
    done

    $ECHO  /*------------------------------------------------
    $ECHO  Individual SADB Entries:
    $ECHO  ------------------------------------------------*/

    for tt in 0 1 2 3 4 5 6 7 8 9 a b c d e f; do
        $ECHO  "IKEv2_Dump_SADB_Entry_00_0$tt"
        $SWITCHCMD /fabos/cliexec/portshow fcipdebug $1 ipsec IKEv2_Dump_SADB_Entry_00_0$tt
    done

    $ECHO  /*------------------------------------------------
    $ECHO  Dumping Individual IKE Session Logs:
    $ECHO  ------------------------------------------------*/

    for tt in 00 01 02 03 04 05 06 07 08 09 0a 0b 0c 0d 0e 0f 10 11 12 13 14 15 16 17 18 19 1a 1b 1c 1d 1e 1f; do
        $ECHO  "IKEv2_Dump_IKE_Session_Log_$tt"
        $SWITCHCMD /fabos/cliexec/portshow fcipdebug $1 ipsec IKEv2_Dump_IKE_Session_Log_$tt
    done

    $ECHO  /*------------------------------------------------
    $ECHO  Individual SPD Entries:
    $ECHO  ------------------------------------------------*/

    for tt in 0 1 2 3 4 5 6 7 8 9 a b c d e f; do
        $ECHO  "IKEv2_Dump_SPD_Entry_000$tt"
        $SWITCHCMD /fabos/cliexec/portshow fcipdebug $1 ipsec IKEv2_Dump_SPD_Entry_000$tt
    done

    $ECHO  /*------------------------------------------------
    $ECHO  Individual Cavium Key Memory Entries:
    $ECHO  ------------------------------------------------*/
    $ECHO  "IKEv2_Dump_Cavium_Key_Memory_Control_Block_Entry_00"
    $SWITCHCMD /fabos/cliexec/portshow fcipdebug $1 ipsec IKEv2_Dump_Cavium_Key_Memory_Control_Block_Entry_00
}


# *******************************************
# Collect PSDUMP
# *******************************************
#PSDUMP,/fabos/cliexec/ps_dump --a, , ,Y,Y,N,Y,Y,5,
# *******************************************
start_psd()
{
    $CHASSISCMD /fabos/cliexec/ps_dump -t
    if [ -f /tmp/tt.dbg ]; then
    	$CHASSISCMD /bin/cat /tmp/tt.dbg
	/bin/rm -f /tmp/tt.dbg
    else
	$ECHO "PS_DUMP Debug file is empty or does not exist."
    fi
	$CHASSISCMD /fabos/cliexec/ps_dump -b
	if [ -f /tmp/bitmap.dbg ]; then
		$CHASSISCMD /bin/cat /tmp/bitmap.dbg
	/bin/rm -f /tmp/bitmap.dbg
	else
	$ECHO /bin/echo "PS_DUMP bitmap file is empty or does not exist."
	fi
	$CHASSISCMD /fabos/cliexec/ps_dump -a 
	if [ -f /tmp/flt.dbg ]; then
			$CHASSISCMD /bin/cat /tmp/flt.dbg
	/bin/rm -f /tmp/flt.dbg
	else
	$ECHO "PS_DUMP flt  file is empty or does not exist."
	fi
	if [ -f /tmp/ee.dbg ]; then
			$CHASSISCMD /bin/cat /tmp/ee.dbg
	/bin/rm -f /tmp/ee.dbg
	else
	$ECHO "PS_DUMP ee file is empty or does not exist."
	fi
}


# *******************************************
# Collect FW
# *******************************************
#FWSWITCH,/fabos/bin/fwdumpall, , ,Y,Y,N,Y,Y,2,
# *******************************************
start_fw()
{
    $SWITCHCMD /fabos/bin/fwdumpall

    if [ -f /tmp/fwShowDebug ]; then
    	$CHASSISCMD /bin/cat /tmp/fwShowDebug
	/bin/rm -f /tmp/fwShowDebug
    else
	$ECHO "FWSHOW Debug file is empty or does not exist."
    fi
}
# *******************************************
# Collect AN
# *******************************************
#FRMLOG_DUMP,/fabos/sbin/framelog --show -n 1200 * 10, , ,Y,Y,N,Y,Y,3,
#BD_DUMP,/fabos/sbin/bottleneckmon --status, , ,Y,Y,N,Y,Y,3,
# *******************************************
start_an()
{
    $SWITCHCMD /fabos/sbin/bottleneckmon --status

    $CHASSISCMD /fabos/sbin/framelog --show -mode dump -n 12000 

} 


# *******************************************
# Collect REGDUMP/C2REGDUMP
# *******************************************
#C2REGDUMP,/bin/touch -c /tmp/c2regdump.tar,/bin/rm -f /tmp/c2regdump.tar,/tmp/c2regdump.tar,N,N,N,Y,Y,1,
#REGDUMP,/bin/touch -c /tmp/regdump.tar,/bin/rm -f /tmp/regdump.tar,/tmp/regdump.tar,N,N,N,Y,Y,1,
# *******************************************
start_regdump()
{    
    /bin/touch -c /tmp/$1.tar
    if [ ! -f /tmp/$1.tar ]
    then 
    return 255
    fi
    return 0
}

# *******************************************
# Collect system info
# *******************************************
start_sys()
{
     $ECHO "Platform: $sw_platform"
     $ECHO "Standby CP: $standby"
     $ECHO "Date:"
     date

	 if [ "$sw_platform"  == "131" ]
	 then
	 $ECHO " "
	 $ECHO "For Castor some of the commands have been moved under the Regdecode Utility. For more information refer to /vobs/projects/springboard/fabos/src/utils/regdump/cbr/README.txt"
	 fi
}

start_kvlog()
{
	if [ "$standby"  == "yes" ]
	then
		$ECHO "Not supported in standby" >/tmp/kvlog
		/bin/tar zcvf /tmp/archived_log.tgz /tmp/kvlog
		/bin/rm /tmp/kvlog
		return 0
	fi
	
	if [ $sw_platform -eq  67  -o  $sw_platform -eq 62 ]
	then
		/fabos/bin/encryption_logger -L START
	else
		$ECHO "Not Supported on the platform" >/tmp/kvlog
		/bin/tar zcvf /tmp/archived_log.tgz /tmp/kvlog
		/bin/rm /tmp/kvlog
	fi
	return 0
}
# *******************************************
# Collect Memory patroller logs
# *******************************************
start_mplog()
{
	nfile=`ls -l /var/log/ | grep mp_* | wc -l`
	if [ "$nfile" -eq 0 ]
	then
		$ECHO "No MP logs found" > /var/log/mp_*
	fi
	tar -cvf /tmp/MP_LOG.tar /var/log/mp_* 2> /dev/null
	/bin/rm /var/log/mp_*
	return 0
}
# ***** Main ****************************************
  standby=no;
  # set standby flag
#  /fabos/cliexec/hashow | awk '/Local/ && /Standby/' > /dev/null 2>&1
  /fabos/cliexec/hashow | grep Local | grep Standby > /dev/null 2>&1	
  if [ $? -eq 0 ]; then
	standby=yes;
  fi
  fabos_off=no;
  /fabos/sbin/chkconfig | grep "fabos " | grep off > /dev/null 2>&1
  if [ $? -eq 0 ]; then
        fabos_off=yes;
  fi
  # set platform
#  sw_platform=`/sbin/sin 2>/dev/null | /bin/grep SWBD | /usr/bin/cut -d ' ' -f 2 | /usr/bin/cut -c 5-6`
   sw_platform=$( /sbin/sin 2>/dev/null | sed -n 's/^.*SWBD\([^,]*\),.*/\1/p' )	
  group_show start_sys

if [ -e /fabos/link_sbin/lscfg_test ]
then
    /bin/rm /fabos/link_sbin/lscfg_test
fi

/bin/ln -s /fabos/cliexec/lscfg_util /fabos/link_sbin/lscfg_test 2> /dev/null
export PATH=/fabos/link_bin:/bin:/usr/bin:/sbin:/usr/sbin:/fabos/link_abin:/fabos/link_sbin:/fabos/factory:/fabos/xtool
#NUM_SW_INSTANCE=`lscfg_test --all  | awk '/Total/ {print $5}'`
if [ "$(lscfg_test --vf_enabled 2> /dev/null)" = 'VF is enabled.' ]; then
    NUM_SW_INSTANCE=`lscfg_test --max`
    HOME_VF=128
    export HOME_VF
else
    HOME_VF=
    export HOME_VF
fi	
  if [ "$HOME_VF" = "" ]
  then
     $ECHO "Non-VF"
     $ECHO "======================"
     SWITCHCMD="cmd_nonvf"
     CHASSISCMD="cmd_nonvf"
  else
     $ECHO "VF"
     $ECHO "======================"
     SWITCHCMD="cmd_iterate_all"
     CHASSISCMD="cmd_chassis"
  fi
  SSCMD="/fabos/cliexec/sscmd"

 for param in $@
  do
    # remove debug switch, if present, processed at top
    if [ "$param" = "--pre" ]
    then
      group_show start_pre
    fi

    if [ "$param" = "--post" ]
     then
     group_show start_post
    fi

    if [ "$param" = "--fs" ]
     then
     group_show start_fabric_service
    fi

    if [ "$param" = "--diag" ]
     then
     group_show start_diag
    fi

    if [ "$param" = "--cryp" ]
     then
     group_show start_cryp
    fi

    if [ "$param" = "--fcip" ]
     then
     group_show start_fcip
    fi

    if [ "$param" = "--vf" ]
     then
     group_show start_vf
    fi

    if [ "$param" = "--c2regdump" ]
     then
     start_regdump C2REGDUMP
     retval=`$ECHO $?`
    fi

	if [ "$param" = "--psd" ]
     then
     group_show start_psd
    fi
	
    if [ "$param" = "--fw" ]
     then
     group_show start_fw
    fi

    if [ "$param" == "--an" ]
     then
     group_show start_an
     fi

    if [ "$param" = "--asicdb" ]
     then
     start_asic_db_cmd
	 retval=`$ECHO $?`
    fi
    if [ "$param" = "--test" ]
     then
     date
     time cmd_iterate_all date
     date
    fi

	if [ "$param" = "--asic" ]; then
		group_show start_asic
	fi

	if [ "$param" = "--dcehsl" ]; then
		group_show start_dcehsl_user
		retval=`$ECHO $?`
	fi

	if [ "$param" = "--ag" ]; then
		group_show start_ag
	 retval=`$ECHO $?`
	fi

    if [ "$param" = "--dmesg" ]
     then
     start_dmesg
	retval=`$ECHO $?`
    fi

	if [ "$param" = "--cryp_kv" ]
	then
		start_kvlog
		retval=`$ECHO $?`
	fi

	if [ "$param" = "--mplog" ]
	then
		start_mplog
		retval=`$ECHO $?`
	fi


    /bin/rm -rf /fabos/link_sbin/lscfg_test 2> /dev/null
	if [ $newline -eq 1 ]
	then
    	$ECHO  " " > $TTY
	fi
    exit $retval
  done
