#!/bin/sh
PATH=/bin:/usr/bin:/usr/sbin:/fabos/bin:/fabos/link_bin:

ssavecomm="/fabos/cliexec/ssave_util.sh"

#
#include ssave utility
#
if [ -e "$ssavecomm" ]
then
    . $ssavecomm
else
    echo "Error -- could not locate $ssavecomm"
    exit 3
fi

start_l2sys_user()
{
    /bin/echo "L2Mgr Debug Commands"
    $CONFDCMD debug internal l2mgr debug mac dump bridges 0
    $CONFDCMD debug internal l2mgr debug mac dump classifier all
    $CONFDCMD debug internal l2mgr debug mac dump counters
    $CONFDCMD debug internal l2mgr debug mac dump fdbs all
    $CONFDCMD debug internal l2mgr debug mac dump globals
    $CONFDCMD debug internal l2mgr debug mac dump instances
    $CONFDCMD debug internal l2mgr debug mac dump interfaces detail
    $CONFDCMD debug internal l2mgr debug mac dump l2agt counters all
 #   $CONFDCMD debug internal l2mgr debug mac dump port-profiles
    $CONFDCMD debug internal l2mgr debug mac dump rbridges
    $CONFDCMD debug internal l2mgr debug mac dump slowpaths
    $CONFDCMD debug internal l2mgr debug mac dump timers
    $CONFDCMD debug internal l2mgr debug mac dump vlans
	$CONFDCMD debug internal l2mgr debug mac dump fids
	$CONFDCMD debug internal l2mgr debug mac dump enstree all
	$CONFDCMD debug internal l2mgr debug mac dump port-security
	$CONFDCMD debug internal l2mgr debug mac dump port-security ouis
	$CONFDCMD debug internal l2mgr debug mac dump static-avl 

 	for i in $LC_BLADES; do
    	/bin/echo "L2Agt Debug Commands - slot $i"
    	$CONFDCMD debug internal l2agt $i p0 dump globals
    	$CONFDCMD debug internal l2agt $i p0 dump bridges 0
    	$CONFDCMD debug internal l2agt $i p0 dump chips
    	$CONFDCMD debug internal l2agt $i p0 dump counters all
    	$CONFDCMD debug internal l2agt $i p0 dump fdbs all
    	$CONFDCMD debug internal l2agt $i p0 dump fids
    	$CONFDCMD debug internal l2agt $i p0 dump instances
    	$CONFDCMD debug internal l2agt $i p0 dump interfaces detail
    	$CONFDCMD debug internal l2agt $i p0 dump vlans
    	$CONFDCMD debug internal l2agt $i p0 dump rbridges all
    	$CONFDCMD debug internal l2agt $i p0 dump mac-vlan classifier
    	$CONFDCMD debug internal l2agt $i p0 dump fdbs count all
		$CONFDCMD debug internal l2agt $i p0 dump counters chip all
		$CONFDCMD debug internal l2agt $i p0 dump appm fdbs all
		$CONFDCMD debug internal l2agt $i p0 dump appm profiles all
		$CONFDCMD debug internal l2agt $i p0 dump appm profiled-ports
		$CONFDCMD debug internal l2agt $i p0 dump port-security
		$CONFDCMD debug internal l2agt $i p0 dump port-security ouis

	# Partion 1
    	$CONFDCMD debug internal l2agt $i p1 dump globals
    	$CONFDCMD debug internal l2agt $i p1 dump bridges 0
    	$CONFDCMD debug internal l2agt $i p1 dump chips
    	$CONFDCMD debug internal l2agt $i p1 dump counters all
    	$CONFDCMD debug internal l2agt $i p1 dump fdbs all
    	$CONFDCMD debug internal l2agt $i p1 dump fids
    	$CONFDCMD debug internal l2agt $i p1 dump instances
    	$CONFDCMD debug internal l2agt $i p1 dump interfaces detail
    	$CONFDCMD debug internal l2agt $i p1 dump vlans
    	$CONFDCMD debug internal l2agt $i p1 dump rbridges all
    	$CONFDCMD debug internal l2agt $i p1 dump mac-vlan classifier
    	$CONFDCMD debug internal l2agt $i p1 dump fdbs count all
		$CONFDCMD debug internal l2agt $i p1 dump counters chip all
		$CONFDCMD debug internal l2agt $i p1 dump appm fdbs all
		$CONFDCMD debug internal l2agt $i p1 dump appm profiles all
		$CONFDCMD debug internal l2agt $i p1 dump appm profiled-ports
		$CONFDCMD debug internal l2agt $i p1 dump port-security
		$CONFDCMD debug internal l2agt $i p1 dump port-security ouis
		$CONFDCMD show mac-address-table conversational linecard $i
	done
}

ospfv3_cmd_ss()
{
	/bin/echo "$@" >> $ospfv3_user_file
}

start_v6_proto_user()
{
	/bin/echo "OSPFV3 Debug Commands"

	date
	# OSPFV3 Related configuration CMDS to file 
	ospfv3_user_file=/tmp/ospfv3_db_cmds.txt

	OSPFv3[0]="show ipv6 ospf"
	OSPFv3[1]="show debug ipv6 ospf internal config"
	OSPFv3[2]="show ipv6 ospf interface"
	OSPFv3[3]="show ipv6 ospf neighbor detail"
	OSPFv3[4]="show ipv6 ospf redistribute route"
	OSPFv3[5]="show ipv6 ospf spf table"
	OSPFv3[6]="show ipv6 ospf virtual-links"
	OSPFv3[7]="show debug ipv6 ospf internal bfd"

	OSPFv3_Extra[0]="show ipv6 ospf database summary"
	OSPFv3_Extra[1]="show ipv6 ospf database network"
	OSPFv3_Extra[2]="show ipv6 ospf database link"
	OSPFv3_Extra[3]="show ipv6 ospf database router"
	OSPFv3_Extra[4]="show ipv6 ospf database as-external"
	OSPFv3_Extra[5]="show ipv6 ospf database inter-prefix"
	OSPFv3_Extra[6]="show ipv6 ospf database inter-router"
	OSPFv3_Extra[7]="show ipv6 ospf database intra-prefix"
	OSPFv3_Extra[8]="show ipv6 ospf database type-7"
	OSPFv3_Extra[9]="show ipv6 ospf routes"

    /bin/rm -f /tmp/ospf6_vrf_ss.txt.gz
    /bin/rm -f /tmp/vrf.tmp1
    /bin/rm -f /tmp/vrf.tmp
    /bin/rm -f /tmp/vrf.lst
    $CONFDCMD show ipv6 ospf summary all-vrfs > /tmp/vrf.tmp1
    /bin/cat /tmp/vrf.tmp1 | /bin/grep "^[0-9]" > /tmp/vrf.tmp
    /bin/cat /tmp/vrf.tmp | awk  '{print $2}' > /tmp/vrf.lst 

    #File for collecting database and routes for vrfs
    /bin/rm -f /tmp/ospf6_vrf_ss.txt
    echo "OSPFV3 Supportsave" >> /tmp/ospf6_vrf_ss.txt

	/bin/echo "terminal length 0" >>  $ospfv3_user_file

    max_ospfv3_vrf=50
    ospfv3_vrf=0
    for VRF in $(cat /tmp/vrf.lst)
    do
        #Max cli info to collect per vrf
        extra_ospfv3_ss_cli=0
        if [ "$VRF" = "mgmt-vrf" ]; then #Skip management vrf
            continue
        elif [ "$VRF" = "default-vrf" ]; then #Collect all info for default-vrf
            extra_ospfv3_ss_cli=1
        fi
 
        i=0
        while (( i < ${#OSPFv3[*]} ))
        do
            $CONFDCMD "${OSPFv3[$i]}" vrf $VRF
            i=`expr $i + 1`
        done

        ospfv3_vrf=`expr $ospfv3_vrf + 1`
        if [ $ospfv3_vrf -eq $max_ospfv3_vrf ]; then
            break
        fi    
    done

	/bin/echo "\"********************************************************\""
	# END OSPFV3 Related configuration CMDS to file. -n optin is must to give more command in 
	# single file
	/usr/confd/bin/confd_cli -C -n --user _support_save_ --groups admin /tmp/ospfv3_db_cmds.txt
	date
	/bin/echo "CONFDB OSPFV3 Debug Commands"
	/bin/rm -f $ospfv3_user_file
    /bin/rm -f /tmp/vrf.tmp1
    /bin/rm -f /tmp/vrf.tmp
    /bin/rm -f /tmp/vrf.lst
	
	/bin/rm -rf /tmp/vrf.tmp
	/bin/rm -rf /tmp/v4vrfname.lst
	
	#BGP4+ commands
	date
	/bin/echo "BGP4+ Debug Commands"
	bgp4_user_file=/tmp/bgp6_cmds.txt
	
	#Add new BGP4+ commands here
	/bin/echo "terminal length 0" >>  $bgp4_user_file

	BGP6[0]="show ipv6 bgp summary"
    BGP6[1]="show ipv6 bgp neighbors"
    BGP6[2]="show ipv6 bgp routes summary"
    BGP6[3]="show debug ipv6 bgp nexthop"
    BGP6[4]="show debug ipv6 bgp variables"


    $CONFDCMD show vrf > /tmp/vrf.tmp
    /bin/cat /tmp/vrf.tmp | /bin/grep  -vE "mgmt" | awk '{print $1 " " $3}' | /bin/grep "Enable" | awk '{print $1}' > /tmp/v4vrfname.lst
    for VRF in $(cat /tmp/v4vrfname.lst)
    do
        i=0
        while (( i < ${#BGP6[*]} ))
        do
            $CONFDCMD "${BGP6[$i]}" vrf $VRF
            i=`expr $i + 1`
        done

       # bgp_vrf=`expr $bgp_vrf + 1`
       # if [ $bgp_vrf -eq $max_bgp_vrf ]; then
       #     break
       # fi
    done

    /bin/rm -rf /tmp/vrf.tmp
	/bin/rm -rf /tmp/v4vrfname.lst
		
	#Execute the commands
	/usr/confd/bin/confd_cli -C -n --user _support_save_ --groups admin /tmp/bgp6_cmds.txt
	date
	/bin/echo "End of BGP4+ debug commands"
	/bin/rm -f $bgp4_user_file

}

start_sflow_user()
{
    /bin/echo "Sflow Show  Commands"
    $CONFDCMD show sflow 
    
    /bin/echo "Sflow Debug Commands for Manager"
    $CONFDCMD debug sflow dump mp 

 	for i in $LC_BLADES; do
    	/bin/echo "Sflow Debug Commands - slot $i"
    	$CONFDCMD debug sflow dump bp $i 
	done
}

# *******************************************
# Collect vlan User data
# *******************************************
start_vlan_user()
{
    $CONFDCMD show virtual-fabric status
    $CONFDCMD show system internal dcm vlan port-vlans
    $CONFDCMD show system internal dcm vlan provisioned-vlans
    $CONFDCMD show system internal dcm vlan vlans-with-ivid
    $CONFDCMD show system internal nsm gvlan
    $CONFDCMD show system internal nsm ivid
}

# *******************************************
# Collect CEE User data
# *******************************************
start_cee_user()
{   
    $CONFDCMD show ip interface brief
    $CONFDCMD show interface
    $CONFDCMD show interface stats detail rbridge-id `switchshow | grep -i rbridge | cut -d ":" -f2`
    $CONFDCMD show port-channel detail
    $CONFDCMD show lacp counter
    $CONFDCMD show lacp sys-id
    $CONFDCMD show port-channel load-balance
    $CONFDCMD show port-channel-redundancy-group
    $CONFDCMD show vlan brief
    $CONFDCMD show interface switchport
    $CONFDCMD show port-profile status
    $CONFDCMD show port-profile interface all
	$CONFDCMD show mac-address-table port-profile
    $CONFDCMD show overlapping-vlan-resource usage

    $CONFDCMD show ipv6 interface brief

    $CONFDCMD debug nsm dump bridge all 
    $CONFDCMD debug nsm dump chassis-status
    $CONFDCMD debug nsm dump counter-capture all
    $CONFDCMD debug nsm dump counter-generic all
    $CONFDCMD debug nsm dump error-capture all
    $CONFDCMD debug nsm dump error-counter all
    $CONFDCMD debug nsm dump fcoe
    $CONFDCMD debug nsm dump globals
    $CONFDCMD debug nsm dump ifg all detail
    $CONFDCMD debug nsm dump ifc all
    $CONFDCMD debug nsm dump intent-list
    $CONFDCMD debug nsm dump interface-counter all
    $CONFDCMD debug nsm dump message-capture all all
    $CONFDCMD debug nsm dump message-stats all all
    $CONFDCMD debug nsm dump port-profiles all
    $CONFDCMD debug nsm dump profile-macs
    $CONFDCMD debug nsm dump protected-vlag all
    $CONFDCMD debug nsm dump tunnel vrf
    $CONFDCMD debug nsm dump tunnel all
    $CONFDCMD debug nsm dump vlag all 
    $CONFDCMD debug nsm dump vlan all
    $CONFDCMD debug nsm dump vrf all
    $CONFDCMD debug nsm dump zif-counter all
    $CONFDCMD debug nsm dump zif-database all detail
    $CONFDCMD debug nsm dump vfab mac-group all
    $CONFDCMD debug nsm dump vfab classification all
    $CONFDCMD debug nsm dump dce-mmap vrf
    $CONFDCMD debug nsm dump dce-mmap vfab
    $CONFDCMD debug nsm dump profiling-stat detail
    $CONFDCMD debug bfd dump all
	for i in $LC_BLADES; do
		/bin/echo "BfdAgt Debug Commands - slot $i"
		$CONFDCMD debug bfd dump all linecard $i
	done
	$CONFDCMD debug bfd dump dest-ip all
	$CONFDCMD debug bfd dump mac-table all
	$CONFDCMD debug bfd dump nexthop-ip all
	$CONFDCMD debug bfd dump prb-vrb
	$CONFDCMD debug bfd dump source-ip all

    $CONFDCMD show rmon
#    $CONFDCMD show ipv6 mld groups
#    $CONFDCMD show ipv6 mld snooping mrouter
#    $CONFDCMD show mcastss vlans
#    $CONFDCMD show mcastss mrouter vlans
#    $CONFDCMD show mcastss vlanmac
#    $CONFDCMD show mcastss vlangrp
    $CONFDCMD show fabric ecmp load-balance

    $CONFDCMD show spanning-tree brief
    $CONFDCMD show spanning-tree
    $CONFDCMD show spanning-tree mst
    $CONFDCMD show spanning-tree mst brief
    $CONFDCMD show spanning-tree mst detail
    $CONFDCMD show spanning-tree mst-config
    $CONFDCMD show spanning-tree pvst vlans
    $CONFDCMD show bpdu-drop

    $CONFDCMD show lldp
    $CONFDCMD show lldp neighbors detail
    $CONFDCMD show lldp statistics
    $CONFDCMD show mac-address-table
	$CONFDCMD show port-security
	$CONFDCMD show mac-address-table learning-mode
	$CONFDCMD show mac-address-table aging-time
	$CONFDCMD show mac-address-table aging-time conversational

    $CONFDCMD show udld
    $CONFDCMD show udld interface
    $CONFDCMD show udld statistics
	$CONFDCMD show monitor
	$CONFDCMD show vlan rspan-vlan
	$CONFDCMD show bfd
	$CONFDCMD show bfd neighbors vrf all 
	$CONFDCMD show bfd neighbors vrf all details
	$CONFDCMD show track summary
}

l3_cmd_ss()
{
	/bin/echo "debug internal echo \"NOSCLI $@:\"" >> $l3_user_file
	/bin/echo "debug internal echo \"********************************************************\""  >> $l3_user_file
	/bin/echo "$@" >> $l3_user_file
	/bin/echo "debug internal echo \"** SS CMD END **\n\""  >> $l3_user_file
}
l3_cmd_ss_no_header()
{
	/bin/echo "$@" >> $l3_user_file
}

SSADDCMD="l3_cmd_ss"
SSADDCMD_NO_HEADER="l3_cmd_ss_no_header"
start_ospfdb_user()
{
	date
    /usr/confd/bin/confd_cli -C --user _support_save_ --groups admin /tmp/ospf_db_cmds.txt
	date
    /bin/rm -f /tmp/ospf_db_cmds.txt
}

start_bgpdb_user()
{
#   Add BGP routes output to a new file
	$CONFDCMD show vrf > /tmp/vrf.tmp
	/bin/cat /tmp/vrf.tmp | /bin/grep  -vE "mgmt" | awk '{print $1 " " $3}' | /bin/grep "Enable" | awk '{print $1}' > /tmp/v4vrfname.lst
	for VRF in $(cat /tmp/v4vrfname.lst)
	do
		/bin/echo "BGP Routes for VRF $VRF:"
		$CONFDCMD show ip bgp routes vrf $VRF
	done
	
	/bin/echo "\"********************************************************\""
	/bin/rm -rf /tmp/vrf.tmp
	/bin/rm -rf /tmp/v4vrfname.lst
}

# *******************************************
# Collect L3 User data - New approach
# *******************************************
start_bgp6db_user()
{
#    Add BGP4+ routes output to a new file
    /bin/echo "BGP4+ Routes:"
    $CONFDCMD show ipv6 bgp routes
	$CONFDCMD show vrf > /tmp/vrf.tmp
	/bin/cat /tmp/vrf.tmp | /bin/grep  -vE "mgmt" | awk '{print $1 " " $3}' | /bin/grep "Enable" | awk '{print $1}' > /tmp/v4vrfname.lst
	for VRF in $(cat /tmp/v4vrfname.lst)
	do
		/bin/echo "BGP4+ Routes for VRF $VRF:"
		$CONFDCMD show ipv6 bgp routes vrf $VRF
	done

	/bin/echo "\"********************************************************\""
	/bin/rm -rf /tmp/vrf.tmp
	/bin/rm -rf /tmp/v4vrfname.lst

}

start_l3_user()
{
    $CONFDCMD show ip route system-summary
    $CONFDCMD show ipv6 route system-summary

	l3_user_file=/tmp/ospf_cmds.txt
#	/bin/rm -f $file_name
#	date
#	 OSPF[0]="show ip ospf"
#	 OSPF[1]="show ip ospf area"
#    OSPF[2]="show ip ospf border-routers"
#     OSPF[3]="show ip ospf config"
#     OSPF[4]="show ip ospf interface"
#     OSPF[5]="show ip ospf neighbor"
#     OSPF[6]="show ip ospf summary"
#     OSPF[7]="show ip ospf virtual link"
#     OSPF[8]="show ip ospf virtual neighbor"
#     OSPF[9]="show ip ospf traffic"
#     OSPF[10]="show ip ospf database database-summary"
#     OSPF[11]="show ip ospf routes"
#     OSPF[12]="show ip ospf database link-state router"
#     OSPF[13]="show ip ospf database link-state network"
#     OSPF[14]="show ip ospf database"
#     OSPF[15]="show debug ip ospf all"
#     OSPF[16]="show debug ip ospf internal"

#     Single cmd to trigger ospf ss cmds internally from Dcmd code
      OSPF[0]="show debug ip ospf internal support-save"

#    Add ospf shorter version of LSDB output to a new file
	 /bin/echo "debug internal echo \"NOSCLI show debug ip ospf internal lsdb:\"" >>  /tmp/ospf_db_cmds.txt
	 /bin/echo "show debug ip ospf internal lsdb" >>  /tmp/ospf_db_cmds.txt
	 /bin/echo "debug internal echo \"********************************************************\""  >> /tmp/ospf_db_cmds.txt
	i=0
	/bin/echo "debug internal echo \"OSPF commands\n\""  >> $l3_user_file
		while (( i < ${#OSPF[*]} ))
		do
			$SSADDCMD_NO_HEADER ${OSPF[$i]}
			i=`expr $i + 1`
		done
		
	l3_user_file=/tmp/bgp_cmds.txt
	/bin/echo "debug internal echo \"\n**********************************************\""  >> $l3_user_file
	/bin/echo "debug internal echo \"BGP COMMANDS BEGIN\""  >> $l3_user_file
	/bin/echo "debug internal echo \"**********************************************\n\""  >> $l3_user_file


    BGP_Global[0]="show debug ip bgp config"
	BGP_Global[1]="show debug ip bgp tcpdump"
	
	i=0
		while (( i < ${#BGP_Global[*]} ))
		do
			$SSADDCMD ${BGP_Global[$i]}
			i=`expr $i + 1`
		done

	BGP[0]="show ip bgp summary"
    BGP[1]="show ip bgp neighbors"
    BGP[2]="show debug ip bgp nexthop"
    BGP[3]="show debug ip bgp variables"
	BGP[4]="show debug ip bgp"


	$CONFDCMD show vrf > /tmp/vrf.tmp
	/bin/cat /tmp/vrf.tmp | /bin/grep  -vE "mgmt" | awk '{print $1 " " $3}' | /bin/grep "Enable" | awk '{print $1}' > /tmp/v4vrfname.lst
	for VRF in $(cat /tmp/v4vrfname.lst)
	do
		/bin/echo "debug internal echo \"VRF Context - '$VRF':\n\""  >> $l3_user_file
         i=0
        while (( i < ${#BGP[*]} ))
        do  
            $SSADDCMD "${BGP[$i]}" vrf $VRF
            i=`expr $i + 1`
        done		

		#bgp_vrf=`expr $bgp_vrf + 1`
        #if [ $bgp_vrf -eq $max_bgp_vrf ]; then
        #    break
        #fi
	done

	/bin/rm -rf /tmp/vrf.tmp
	/bin/rm -rf /tmp/v4vrfname.lst

	/bin/echo "debug internal echo \"\n**********************************************\""  >> $l3_user_file
	/bin/echo "debug internal echo \"BGP COMMANDS END\""  >> $l3_user_file
	/bin/echo "debug internal echo \"**********************************************\n\""  >> $l3_user_file

	l3_user_file=/tmp/vrrp_cmds.txt
	VRRP[0]="show vrrp summary"
	VRRP[1]="show vrrp detail"
	VRRP[2]="show ipv6 vrrp summary"
	VRRP[3]="show ipv6 vrrp detail"
	VRRP[4]="show debug vrrp"
	VRRP[5]="show debug vrrp nsm-db"
	VRRP[6]="show debug vrrp nsm-pending-list"
	VRRP[7]="show ip fabric-virtual-gateway"
	VRRP[8]="show ip fabric-virtual-gateway detail"
	VRRP[9]="show ipv6 fabric-virtual-gateway"
	VRRP[10]="show ipv6 fabric-virtual-gateway detail"
	i=0
	/bin/echo "debug internal echo \"VRRP commands:\n\""  >> $l3_user_file
		while (( i < ${#VRRP[*]} ))
		do
			$SSADDCMD ${VRRP[$i]}
			i=`expr $i + 1`
		done

#	l3_user_file=/tmp/rtm_cmds.txt
#	/bin/echo "debug internal echo \"RTM commands\n\""  >> $l3_user_file
#	RTM[0]="show ip static route"
#	RTM[1]="show ip route summary"
#	RTM[2]="show ip route"
#	RTM[3]="show ip route nexthop"
#	RTM[3]="debug ip rtm counters show"
#	RTM[4]="debug ip rtm dump"
#	i=0
#		while (( i < ${#RTM[*]} ))
#		do
#			$SSADDCMD ${RTM[$i]}
#			i=`expr $i + 1`
#		done
	
#	l3_user_file=/tmp/pim_cmds.txt
#	/bin/echo "debug internal echo \"PIM commands:\n\"" >> $l3_user_file
#	PIM[0]="show ip pim-sparse"
#	PIM[1]="show ip pim neighbor"
#	PIM[2]="show ip pim rp-set"
#	PIM[3]="show ip pim rp-map"
#	PIM[4]="show ip pim rp-candidate"
#	PIM[4]="show ip pim bsr"
#	PIM[5]="show ip pim group"	
#	PIM[6]="show ip pim mcache"
#	PIM[7]="show ip pim traffic"	
#	PIM[8]="show pim port all"	
#	i=0
#		while (( i < ${#PIM[*]} ))
#		do
#			$SSADDCMD ${PIM[$i]}
#			i=`expr $i + 1`
#		done
#
#	l3_user_file=/tmp/mcast_cmds.txt
#	/bin/echo "debug internal echo \"Mcast_SS commands:\n\"" >> $l3_user_file
#	MCAST[0]="show mcastss vif"	
#	MCAST[1]="show mcastss mrt"	
#	MCAST[2]="show mcastss rp"	
#	MCAST[3]="show mcastss grange"
#	MCAST[4]="show mcastss rte brief"
#	MCAST[5]="show mcastss rte client"
#	i=0
#		while (( i < ${#MCAST[*]} ))
#		do
#			$SSADDCMD ${MCAST[$i]}
#			i=`expr $i + 1`
#		done
#
	/bin/rm -f /tmp/vrf.tmp1
    /bin/rm -f /tmp/vrf.tmp
    /bin/rm -f /tmp/vrf.lst
    /bin/rm -f /tmp/vrfid.lst
    $CONFDCMD show vrf detail > /tmp/vrf.tmp1
    /bin/cat /tmp/vrf.tmp1 | /bin/grep  -w VRF > /tmp/vrf.tmp
    /bin/cat /tmp/vrf.tmp | awk  '{print $2}' | cut -d, -f 1 > /tmp/vrf.lst

    /bin/rm -f /tmp/vrf.tmp1
    /bin/rm -f /tmp/vrf.tmp

	l3_user_file=/tmp/l3_vrf_cmds.txt
for VRF in $(cut -f2 < /tmp/vrf.lst)
    do
		/bin/echo "debug internal echo \"VRF CONTEXT : $VRF\"" >> $l3_user_file
		i=0
		while (( i < ${#OSPF[*]} ))
		do
			$SSADDCMD_NO_HEADER ${OSPF[$i]} vrf $VRF
			i=`expr $i + 1`
		done

#		for ((i = 0; i < 4; i++));
#		do
#			$SSADDCMD ${RTM[$i]} vrf $VRF
#		done

	    /bin/echo "debug internal echo \"NOSCLI show debug ip ospf internal lsdb vrf $VRF:\"" >>  /tmp/ospf_db_cmds.txt
		/bin/echo "show debug ip ospf internal lsdb vrf $VRF" >>  /tmp/ospf_db_cmds.txt
	    /bin/echo "debug internal echo \"********************************************************\""  >> /tmp/ospf_db_cmds.txt
	done

date
/usr/confd/bin/confd_cli -C --user _support_save_ --groups admin /tmp/ospf_cmds.txt
date
/usr/confd/bin/confd_cli -C --user _support_save_ --groups admin /tmp/bgp_cmds.txt
date
/usr/confd/bin/confd_cli -C --user _support_save_ --groups admin /tmp/vrrp_cmds.txt
#date
#/usr/confd/bin/confd_cli -C --user _support_save_ --groups admin /tmp/rtm_cmds.txt
date
#/usr/confd/bin/confd_cli -C --user _support_save_ --groups admin /tmp/pim_cmds.txt
#date
#/usr/confd/bin/confd_cli -C --user _support_save_ --groups admin /tmp/mcast_cmds.txt
#date
/usr/confd/bin/confd_cli -C --user _support_save_ --groups admin /tmp/l3_vrf_cmds.txt

    /bin/rm -f /tmp/vrf.lst
	/bin/rm -f /tmp/ospf_cmds.txt
	/bin/rm -f /tmp/bgp_cmds.txt
	/bin/rm -f /tmp/bgp6_cmds.txt
	/bin/rm -f /tmp/vrrp_cmds.txt
#	/bin/rm -f /tmp/rtm_cmds.txt
#	/bin/rm -f /tmp/pim_cmds.txt
#	/bin/rm -f /tmp/mcast_cmds.txt
	/bin/rm -f /tmp/l3_vrf_cmds.txt
}

start_stack_vrf_user()
{
    /bin/rm -f /tmp/vrfid.lst
    /bin/rm -f /tmp/vrf.tmp

    $CONFDCMD show vrf detail > /tmp/vrf.tmp
    /bin/cat /tmp/vrf.tmp | /bin/grep  -w VRF-Id | awk  '{print $4}' | /bin/sort -n > /tmp/vrfid.lst

	echo "echo =============== ifconfig ===============; ifconfig;" > /tmp/stackvrf.lst
	echo "echo =============== ip -s addr ===============; ip -s addr;" >> /tmp/stackvrf.lst
	echo "echo =============== ip -s link ===============; ip -s link;" >> /tmp/stackvrf.lst
	echo "echo =============== route ===============; route -n;" >> /tmp/stackvrf.lst
	echo "echo =============== ip -6 route ===============; ip -6 route;" >> /tmp/stackvrf.lst
	echo "echo =============== ip -s neigh ===============; ip -s neigh;" >> /tmp/stackvrf.lst
	echo "echo =============== ip -s maddr ===============; ip -s maddr;" >> /tmp/stackvrf.lst

	for VRFID in $(cat /tmp/vrfid.lst)
    do
		echo "*************** VRF $VRFID ***************"
        $CHASSISCMD /fabos/cliexec/vrfcmd $VRFID /bin/bash /tmp/stackvrf.lst
    done

    /bin/rm -f /tmp/stackvrf.lst
    /bin/rm -f /tmp/vrfid.lst
    /bin/rm -f /tmp/vrf.tmp
}

# *******************************************
# Collect L3 User data - Deprecated
# *******************************************
start_l3_user_old()
{
	/bin/echo "L3 commands:"
	/bin/echo "OSPF:"
     OSPF[0]="show ip ospf area"
     OSPF[1]="show ip ospf border-routers"
     OSPF[2]="show ip ospf config"
     OSPF[3]="show ip ospf interface"
     OSPF[4]="show ip ospf neighbor"
     OSPF[5]="show ip ospf summary"
     OSPF[6]="show ip ospf virtual link"
     OSPF[7]="show ip ospf virtual neighbor"
     OSPF[8]="show ip ospf traffic"
     OSPF[9]="show ip ospf database database-summary"
     OSPF[10]="show ip ospf routes"
     OSPF[11]="show ip ospf database link-state router"
     OSPF[12]="show ip ospf database link-state network"
     OSPF[13]="show ip ospf database"
#     OSPF[14]="show debug ip ospf all"
#     OSPF[15]="show debug ip ospf internal"


		i=0
		while (( i < ${#OSPF[*]} ))
		do
			$CONFDCMD "${OSPF[$i]}"
			i=`expr $i + 1`
		done

	/bin/echo "BGP:"
	$CONFDCMD show ip bgp summary
	$CONFDCMD show ip bgp neighbors
	$CONFDCMD show debug ip bgp
	$CONFDCMD show debug ip bgp config
	$CONFDCMD show debug ip bgp tcpdump
	$CONFDCMD show debug ip bgp nexthop
	$CONFDCMD show debug ip bgp variables
	$CONFDCMD show debug ipv6 bgp nexthop
	$CONFDCMD show debug ipv6 bgp variables
	$CONFDCMD show ip bgp routes

	/bin/echo "VRRP:"
	$CONFDCMD show vrrp summary
	$CONFDCMD show vrrp detail
	$CONFDCMD show ipv6 vrrp summary
	$CONFDCMD show ipv6 vrrp detail
	$CONFDCMD show debug vrrp
	$CONFDCMD show debug vrrp nsm-db
	$CONFDCMD show debug vrrp nsm-pending-list
	$CONFDCMD show ip anycast-gateway
	$CONFDCMD show ip anycast-gateway detail
	$CONFDCMD show ipv6 anycast-gateway
	$CONFDCMD show ipv6 anycast-gateway detail

#	/bin/echo "RTM commands:"
#	RTM[0]="show ip static route"
#	RTM[1]="show ip route summary"
#	RTM[2]="show ip route"
#	RTM[3]="show ip route nexthop"
#	RTM[3]="debug ip rtm counters show"
#	RTM[4]="debug ip rtm dump"
#
#		i=0
#		while (( i < ${#RTM[*]} ))
#		do
#			$CONFDCMD "${RTM[$i]}"
#			i=`expr $i + 1`
#		done

	 
	/bin/echo "PIM commands:"
	$CONFDCMD show ip pim-sparse	
	$CONFDCMD show ip pim neighbor
	$CONFDCMD show ip pim rp-set	
	$CONFDCMD show ip pim rp-map	
	$CONFDCMD show ip pim rp-candidate
	$CONFDCMD show ip pim bsr	
	$CONFDCMD show ip pim group	
	$CONFDCMD show ip pim mcache
	$CONFDCMD show ip pim traffic	
	$CONFDCMD show pim port all	

	/bin/echo "Mcast_SS commands:"
	$CONFDCMD show mcastss vif	
	$CONFDCMD show mcastss mrt	
	$CONFDCMD show mcastss rp	
	$CONFDCMD show mcastss grange
	$CONFDCMD show mcastss rte brief
	$CONFDCMD show mcastss rte client

    /bin/echo ""
    /bin/echo "VRF commands:"
    /bin/rm -f /tmp/vrf.tmp1
    /bin/rm -f /tmp/vrf.tmp
    /bin/rm -f /tmp/vrf.lst
    /bin/rm -f /tmp/vrfid.tmp
    /bin/rm -f /tmp/vrfid.lst
    $CONFDCMD show vrf detail > /tmp/vrf.tmp1
    /bin/cat /tmp/vrf.tmp1 | /bin/grep  -w VRF > /tmp/vrf.tmp
    /bin/cat /tmp/vrf.tmp | awk  '{print $2}' | cut -d, -f 1 > /tmp/vrf.lst
    for VRF in $(cut -f2 < /tmp/vrf.lst)
    do
        #Misc.
        $CONFDCMD debug show vrf $VRF > /tmp/vrfid.tmp
        /usr/bin/tail -2 /tmp/vrfid.tmp | /usr/bin/head -n 1 >> /tmp/vrfid.lst
    done
    /bin/rm -f /tmp/vrf.tmp1
    /bin/rm -f /tmp/vrf.tmp

    /bin/echo ""
    /bin/echo "$(cat /tmp/vrfid.lst)"
    for VRFID in $(cat /tmp/vrfid.lst)
    do
		/bin/echo "VRF CONTEXT : $VRFID"
        /bin/echo "vrfid $VRFID ifconfig"
        /fabos/cliexec/vrfcmd $VRFID ifconfig

        /bin/echo "vrfid $VRFID route"
        /fabos/cliexec/vrfcmd $VRFID route

        /bin/echo "vrfid $VRFID arp"
        /fabos/cliexec/vrfcmd $VRFID arp

        /bin/echo "vrfid $VRFID ip -s addr"
        /fabos/cliexec/vrfcmd $VRFID ip -s addr

        /bin/echo "vrfid $VRFID ip -6 route"
        /fabos/cliexec/vrfcmd $VRFID ip -6 route

        /bin/echo "vrfid $VRFID ip -s neigh"
        /fabos/cliexec/vrfcmd $VRFID ip -s neigh

        /bin/echo "vrfid $VRFID ip -s maddr"
        /fabos/cliexec/vrfcmd $VRFID ip -s maddr
    done

    for VRF in $(cut -f2 < /tmp/vrf.lst)
    do
		/bin/echo "VRF CONTEXT : $VRF"
        #RTM Commands
#        $CONFDCMD show ip route vrf $VRF
#		i=0
#		while (( i < ${#RTM[*]} ))
#		do
#			$CONFDCMD "${RTM[$i]} vrf $VRF"
#			i=`expr $i + 1`
#		done

        #ARP Commands
        $CONFDCMD show arp vrf $VRF

        #OSPF Commands
        $CONFDCMD show ip ospf vrf $VRF
		i=0
		while (( i < ${#OSPF[*]} ))
		do
			$CONFDCMD "${OSPF[$i]} vrf $VRF"
			i=`expr $i + 1`
		done
	done

    /bin/rm -f /tmp/vrfid.lst
    /bin/rm -f /tmp/vrf.lst
    /bin/rm -f /tmp/vrfid.tmp

}

# *******************************************
# Collect SSM User data
# *******************************************
ssm_dbg_exec()
{
    echo -e "*****************************************************************"
    echo -e "ssmdbg $@ :"
    echo -e "*****************************************************************"
    time /fabos/bin/ssmdbg $@
    echo -e "\n\n\n\n"
}

SSMDBGCMD=ssm_dbg_exec

# *******************************************
# Collect cmsh data
# *******************************************
cmsh_cmd_exec()
{
    echo -e "*****************************************************************"
    echo -e "cmsh -e $@ :"
    echo -e "*****************************************************************"
    time /fabos/bin/cmsh -e "$@"
    echo -e "\n\n\n\n"
}

CMSHCMD=cmsh_cmd_exec
# *******************************************
# Collect foscmd data
# *******************************************
foscmd_cmd_exec()
{
    echo -e "*****************************************************************"
    echo -e "foscmd  $@ :"
    echo -e "*****************************************************************"
    time /fabos/bin/foscmd  "$@"
    echo -e "\n\n\n\n"
}

FOSCMD=foscmd_cmd_exec


start_ssm_user()
{
	/bin/echo "SSM commands begin:"
    /bin/date

# User exposed commands
    $CONFDCMD show access-list mac
    $CONFDCMD show access-list ip
    $CONFDCMD show access-list ipv6
    $CONFDCMD show bpdu-drop
    $CONFDCMD show tunnel tagged-ieee-bpdu

# SSM Internal Debug commands
    $SSMDBGCMD show ssm
    $SSMDBGCMD show running-config
    $SSMDBGCMD show running-config mac access-list
    $SSMDBGCMD show running-config ip access-list
    $SSMDBGCMD show running-config ipv6 access-list
    $SSMDBGCMD show running-config l2ctrl access-list
    $SSMDBGCMD show running-config l3ctrl access-list
    $SSMDBGCMD show running-config vlancls access-list
    $SSMDBGCMD show access-list mac
    $SSMDBGCMD show access-list ip
    $SSMDBGCMD show access-list ipv6
    $SSMDBGCMD show ssm internal fss
    $SSMDBGCMD show ssm internal fss stats send
    $SSMDBGCMD show ssm internal fss stats receive
    $SSMDBGCMD show ssm internal msgq
    $SSMDBGCMD show ssm internal chip
    $SSMDBGCMD show ssm internal chip all
    $SSMDBGCMD show ssm internal dnld
    $SSMDBGCMD show ssm internal dnld asic all
    $SSMDBGCMD show ssm internal dnld stats asic all
    $SSMDBGCMD show ssm internal memory
    $SSMDBGCMD show ssm internal interface
    $SSMDBGCMD show ssm internal interface detail all
    $SSMDBGCMD show ssm internal interface nametable
    $SSMDBGCMD show ssm internal interface chips
    $SSMDBGCMD show ssm internal interface slots
    $SSMDBGCMD show ssm internal interface preprovision
    $SSMDBGCMD show ssm internal tcam
    $SSMDBGCMD show ssm internal tcam region config
    $SSMDBGCMD show ssm internal tcam asic all
    $SSMDBGCMD show ssm internal tcam region details asic all
    $SSMDBGCMD show ssm internal tcam region summary asic all
    $SSMDBGCMD show ssm internal tcam entries asic all
    $SSMDBGCMD show ssm internal acl module
    $SSMDBGCMD show ssm internal acl access-list
    $SSMDBGCMD show ssm internal acl bindings
    $SSMDBGCMD show ssm internal mam
    $SSMDBGCMD show ssm internal l3ctrl
    $SSMDBGCMD show ssm internal l3ctrl region summary
    $SSMDBGCMD show ssm internal l3ctrl asic all
    $SSMDBGCMD show ssm internal l3ctrl entries asic all
    $SSMDBGCMD show ssm internal l3ctrl entries detail asic all
    $SSMDBGCMD show ssm internal l2ctrl
    $SSMDBGCMD show ssm internal l2ctrl region summary
    $SSMDBGCMD show ssm internal l2ctrl entries asic all
    $SSMDBGCMD show ssm internal l2ctrl entry mapping
    $SSMDBGCMD show ssm internal apptype chip
    $SSMDBGCMD show ssm internal apptype region summary
    $SSMDBGCMD show ssm internal apptype entries asic all
    $SSMDBGCMD show ssm internal ampp profile
    $SSMDBGCMD show ssm internal ampp bindings
    $SSMDBGCMD show ssm internal ampp profiled-ports
    $SSMDBGCMD show ssm internal ampp security profile
    $SSMDBGCMD show ssm internal ampp interface
    $SSMDBGCMD show ssm internal bpratelimit
    $SSMDBGCMD show ssm internal mvc
    $SSMDBGCMD show ssm internal mvc region summary
    $SSMDBGCMD show ssm internal mvc entries asic all
    $SSMDBGCMD show ssm internal lib msg-stats 5
    $SSMDBGCMD show ssm internal lib msg-stats 7
    $SSMDBGCMD show ssm internal lib msg-stats 8
    $SSMDBGCMD show ssm internal lib msg-stats 13
    $SSMDBGCMD show ssm internal lib msg-stats 22
    $SSMDBGCMD show ssm internal lib msg-stats 29
    $SSMDBGCMD show ssm internal lib msg-stats 37
    $SSMDBGCMD show ssm internal lib msg-stats 41
    $SSMDBGCMD show ssm internal lib msg-stats 47
    $SSMDBGCMD show ssm internal lib msg-stats 50
    $SSMDBGCMD show ssm internal lib msg-stats 56
    $SSMDBGCMD show ssm internal lib msg-stats 58
    $SSMDBGCMD show ssm internal lib msg-stats 59
   
    /bin/date
	/bin/echo "SSM commands end:"
}

# *******************************************
# Collect SSAGT User data
# *******************************************
start_ssagt_user()
{
	/bin/echo "SSAGT commands begin:"
    /bin/date

    $SSMDBGCMD show ssm
    $SSMDBGCMD show running-config
    $SSMDBGCMD show running-config mac access-list
    $SSMDBGCMD show running-config ip access-list
    $SSMDBGCMD show running-config ipv6 access-list
    $SSMDBGCMD show running-config l2ctrl access-list
    $SSMDBGCMD show running-config l3ctrl access-list
    $SSMDBGCMD show running-config apptype access-list
    $SSMDBGCMD show access-list mac
    $SSMDBGCMD show access-list ip
    $SSMDBGCMD show access-list ipv6
    $SSMDBGCMD show ssm internal fss
    $SSMDBGCMD show ssm internal fss stats send
    $SSMDBGCMD show ssm internal fss stats receive
    $SSMDBGCMD show ssm internal msgq
    $SSMDBGCMD show ssm internal chip
    $SSMDBGCMD show ssm internal chip all
    $SSMDBGCMD show ssm internal dnld
    $SSMDBGCMD show ssm internal dnld asic all
    $SSMDBGCMD show ssm internal dnld stats asic all
    $SSMDBGCMD show ssm internal memory
    $SSMDBGCMD show ssm internal interface
    $SSMDBGCMD show ssm internal interface detail all
    $SSMDBGCMD show ssm internal interface nametable
    $SSMDBGCMD show ssm internal interface chips
    $SSMDBGCMD show ssm internal interface slots
    $SSMDBGCMD show ssm internal interface preprovision
    $SSMDBGCMD show ssm internal tcam
    $SSMDBGCMD show ssm internal tcam region config
    $SSMDBGCMD show ssm internal tcam asic all
    $SSMDBGCMD show ssm internal tcam region details asic all
    $SSMDBGCMD show ssm internal tcam region summary asic all
    $SSMDBGCMD show ssm internal tcam entries asic all
    $SSMDBGCMD show ssm internal acl module
    $SSMDBGCMD show ssm internal acl access-list
    $SSMDBGCMD show ssm internal acl bindings
    $SSMDBGCMD show ssm internal l3ctrl
    $SSMDBGCMD show ssm internal l3ctrl region summary
    $SSMDBGCMD show ssm internal l3ctrl asic all
    $SSMDBGCMD show ssm internal l3ctrl entries asic all
    $SSMDBGCMD show ssm internal l3ctrl entries detail asic all
    $SSMDBGCMD show ssm internal l2ctrl
    $SSMDBGCMD show ssm internal l2ctrl region summary
    $SSMDBGCMD show ssm internal l2ctrl entries asic all
    $SSMDBGCMD show ssm internal l2ctrl entry mapping
    $SSMDBGCMD show ssm internal ampp profile
    $SSMDBGCMD show ssm internal bpratelimit
    $SSMDBGCMD show ssm internal apptype chip
    $SSMDBGCMD show ssm internal apptype region summary
    $SSMDBGCMD show ssm internal apptype entries asic all
    $SSMDBGCMD show ssm internal ampp profile
    $SSMDBGCMD show ssm internal bpratelimit
    $SSMDBGCMD show ssm internal mam
    $SSMDBGCMD show ssm internal mvc
    $SSMDBGCMD show ssm internal mvc region summary
    $SSMDBGCMD show ssm internal mvc entries asic all

    /bin/date
	/bin/echo "SSAGT commands end:"
}

# *******************************************
# Collect QoS User data
# *******************************************
start_qos_user()
{
	/bin/echo "QoS commands:"
	$CONFDCMD show qos interface all
	$CONFDCMD show qos flowcontrol interface all
	$CONFDCMD show qos maps
	$CONFDCMD show qos queue interface all
	$CONFDCMD show qos rcv-queue interface all
	$CONFDCMD show qos tx-queue interface all
	$CONFDCMD show qos rcv-queue multicast all
	$CONFDCMD show qos red profiles
	$CONFDCMD show qos red statistics interface all
	$CONFDCMD debug show qos drop-reason interface all
	$CONFDCMD show cee maps
	$CONFDCMD show system internal nas
}

# *******************************************
# Collect Tunnel User data
# *******************************************
start_tnl_user()
{
	/bin/echo "TNL commands:"
	$CONFDCMD show tunnel brief
	$CONFDCMD show overlay-gateway
	$CONFDCMD show tunnel statistics
    $CONFDCMD show tunnel nsx service-node

    /bin/echo "NSX controller commands:"
    $CONFDCMD show nsx-controller
    $CONFDCMD show system internal ovsdb table Tunnel
	$CONFDCMD show system internal tnlmgr tunnel all
	$CONFDCMD show system internal tnlmgr vrb-prb-map
	$CONFDCMD show system internal tnlagt 0 p0 tunnel all
	$CONFDCMD show system internal tnlagt 0 p1 tunnel all
	$CONFDCMD show system internal tnlmgr mem-stats
	$CONFDCMD show system internal tnlmgr mi-stats
	$CONFDCMD show system internal tnlmgr l2clnt-db 
}


# *******************************************
# Collect ELD User data
# *******************************************
start_eld_user()
{
    /bin/echo "ELD commands:"
    $CONFDCMD show edge-loop-detection globals
    $CONFDCMD show edge-loop-detection detail rbridge-id all
}

# *******************************************
# Collect ARP User data
# *******************************************
start_arp_user()
{
    /bin/echo "ARP Commands:"
	$CONFDCMD debug internal arp show ipv4 vrf all
	$CONFDCMD debug internal arp show ipv6 vrf all
	$CONFDCMD debug internal arp show vrf
	$CONFDCMD debug internal arp show memstats
	$CONFDCMD debug internal arp show interface
	$CONFDCMD debug internal arp show clientlist structures
	$CMSHCMD show dai-list
	$CMSHCMD show dai-trust
	$CMSHCMD show dai-filter
}

# *******************************************
# Collect RIBM User data
# *******************************************
start_ribm_user()
{
    /bin/echo "RIBM Commands:"
	$CONFDCMD debug internal ribm show ip route vrf all
	$CONFDCMD debug internal ribm show ipv6 route vrf all
	$CONFDCMD debug internal ribm show ip adj vrf all
	$CONFDCMD debug internal ribm show ipv6 adj vrf all
	$CONFDCMD debug internal ribm show clients
	$CONFDCMD debug internal ribm show memory-stats
        $CONFDCMD debug internal ribm show  vrf
}

# *******************************************
# Collect IPHELP User data
# *******************************************
start_iphelp_user()
{
    /bin/echo "IPHELP Commands:"
	$CONFDCMD show ip dhcp relay address
	$CONFDCMD show ip dhcp relay statistics
	$CONFDCMD show ipv6 dhcp relay address
    $CONFDCMD show ipv6 dhcp relay statistics 

    $CHASSISCMD touch /tmp/iphelpsupport.tar

    if [ -f /tmp/iphelpclientinfo.1 ] ; then
        $CHASSISCMD `/fabos/libexec/iphelpLogParser /tmp/iphelpclientinfo.1 > /tmp/iphelpclients.1`;
    fi

    if [ -f /tmp/iphelpclientinfo.2 ] ; then
        $CHASSISCMD `/fabos/libexec/iphelpLogParser /tmp/iphelpclientinfo.2 > /tmp/iphelpclients.2`;
    fi

    $CHASSISCMD tar -cvf /tmp/iphelpsupport.tar /tmp/iphelpclientinfo.* /tmp/iphelpclients.*
    $CHASSISCMD /bin/rm -f /tmp/iphelpclients*
}

start_openflow_user()
{
    /bin/echo "OPENFLOW LOGS:"

    
	$CHASSISCMD touch /tmp/openflowsupport.tar
	$CHASSISCMD touch /var/tmp/ofmstdout.bak
	$CHASSISCMD touch /var/tmp/ofastdout.bak
	$CHASSISCMD touch /var/tmp/ofmstdout
	$CHASSISCMD touch /var/tmp/ofastdout

	$CHASSISCMD tar -cvf /tmp/openflowsupport.tar /var/tmp/ofmstdout* /var/tmp/ofastdout* 
    
    if [ "$LC_PLATFORM" = "TRUE" ]
    then
        return
    fi
    
    ### check openflow enable/disable
    $CONFDCMD show running openflow > /tmp/offile
    /bin/cat /tmp/offile | grep "openflow-controller" > /dev/null 2>&1
    if [ $? -eq 1 ];
    then
        echo "OPENFLOW is not enabled!!"
        return
    fi
	
    $CONFDCMD show running-config openflow-controller
    $CONFDCMD show running-config rbridge-id openflow
    $CONFDCMD show openflow controller
    $CONFDCMD show openflow interface
    $CONFDCMD show openflow resources
    $CONFDCMD show openflow flow
    $CONFDCMD show openflow group
    $CONFDCMD show openflow meter
    $CONFDCMD show openflow queues
    
    $CONFDCMD debug internal openflow stats
	
    for i in $LC_BLADES; do
		/bin/echo "OPENFLOW AGENT Commands for Slot $i:"
        $CONFDCMD show system internal ofagt $i p0 chip all
        $CONFDCMD show system internal ofagt $i p0 port all
        $CONFDCMD show system internal ofagt $i p0 vlan all
        $CONFDCMD show system internal ofagt $i p0 flow all
        $CONFDCMD show system internal ofagt $i p0 group all
        $CONFDCMD show system internal ofagt $i p0 l2fwd_info
        $CONFDCMD show system internal ofagt $i p0 meter all
        $CONFDCMD show system internal ofagt $i p0 flow_tree
   #Partition 1     
        $CONFDCMD show system internal ofagt $i p1 chip all
        $CONFDCMD show system internal ofagt $i p1 port all
        $CONFDCMD show system internal ofagt $i p1 vlan all
        $CONFDCMD show system internal ofagt $i p1 flow all
        $CONFDCMD show system internal ofagt $i p1 group all
        $CONFDCMD show system internal ofagt $i p1 l2fwd_info
        $CONFDCMD show system internal ofagt $i p1 meter all
        $CONFDCMD show system internal ofagt $i p1 flow_tree
	done

    $CHASSISCMD /bin/rm -f /tmp/offile
}

# *******************************************
# Collect RPS User data
# *******************************************
rps_dbg_exec()
{
    echo -e "*****************************************************************"
    echo -e "rpsdbg $@ :"
    echo -e "*****************************************************************"
    time rpsdbg $@
    echo -e "\n\n\n\n"
}

RPSDBGCMD=rps_dbg_exec

start_rps_user()
{
    /bin/echo "RPS Commands:"
    /bin/date

    $CHASSISCMD $RPSDBGCMD show rps internal pbr all-list
    $CHASSISCMD $RPSDBGCMD show rps internal rp all-list
}

# *******************************************
# Collect L3SS User data
# *******************************************
start_l3ss_user()
{
	for i in $LC_BLADES; do
		/bin/echo "FIBA ARP and Route Commands Slot $i:"
		$CONFDCMD debug internal fib $i show arp vrf
		$CONFDCMD debug internal fib $i show arp interface 
		$CONFDCMD debug internal fib $i show arp memstats
		$CONFDCMD debug internal fib $i show arp ipv4
		$CONFDCMD debug internal fib $i show arp ipv6
		$CONFDCMD debug internal fib $i show arp counters
		$CONFDCMD debug internal fib $i show arp dai-list
		$CONFDCMD debug internal fib $i show arp dai-trust
		$CONFDCMD debug internal fib $i show arp dai-filter
		$CONFDCMD debug internal fib $i show arp dai-stats
	done
}

# *******************************************
# Collect FIBAGT data
# *******************************************
start_fibagt_user()
{
	case $sw_platform in
		1000|1001|1002|1003)
		$CHASSISCMD touch /tmp/fibagtsupport.tar
		;;

	*)
		if [ -f /tmp/fib_wlv_ioctl.1 ] ; then
			$CHASSISCMD `/fabos/libexec/fibLogParser /tmp/fib_wlv_ioctl.1 > /tmp/fib_ioctl.1`;
		fi

		if [ -f /tmp/fib_wlv_ioctl.2 ] ; then
			$CHASSISCMD `/fabos/libexec/fibLogParser /tmp/fib_wlv_ioctl.2 > /tmp/fib_ioctl.2`;
		fi

		$CHASSISCMD tar -cvf /tmp/fibagtsupport.tar /tmp/fib_wlv_ioctl.* /tmp/fib_ioctl.*
		$CHASSISCMD /bin/rm -f /tmp/fib_ioctl.*
		;;
	esac
}
# *******************************************
# Collect MCASTSS DB RELATED data
# *******************************************
start_mcast_db()
{
	/bin/echo $sw_platform
	case $sw_platform in
		131|137|138|151)
		$FOSCMD  "db rte show exm l2 used"
		$FOSCMD  "db rte show exm ipv4mc used"
		#$FOSCMD  "db rte show lpm nhop all"
		$FOSCMD  "db mcast show mgid all"
		$FOSCMD  "db mcast show pet all ipv4"
        $CHASSISCMD "/fabos/cliexec/vrfcmd 1 cat /proc/net/ip_mr_cache" 
		/bin/echo "Common no flood entries for IGMP and MLD"
		#To see how to print values for no flood region
		$FOSCMD  "db rte show tcam psel region entries 9 20 0 100"

		featureid=12
		regionid=1
		maxregion=8
		while ((regionid <= $maxregion))
		do
			$FOSCMD "db rte show tcam psel region entries $featureid $regionid 0 0"
			regionid=`expr $regionid + 1`
		done
	esac
	case $sw_platform in
		1000|1004|1005|1006|1007|1008|1009|1010|1011)
		lcslot=0
		featureid=12
		maxregion=8
		for i in $LC_BLADES; do
			/bin/echo "MCASTSS DB Commands - slot $i"
			lcslot=`expr $i + 6`
			$FOSCMD "rcli -s lc$i \"db $lcslot/0/1 rte show exm l2 used\""
			$FOSCMD "rcli -s lc$i \"db $lcslot/0/1 rte show exm ipv4mc used\""
			$FOSCMD "rcli -s lc$i \"db $lcslot/0/1 rte show lpm nhop all\""
			$FOSCMD "rcli -s lc$i \"db $lcslot/0/1 rte show myrp all\""
			$FOSCMD "rcli -s lc$i \"db $lcslot/0/1 mcast show pim v4 all\""
			$FOSCMD "rcli -s lc$i \"db $lcslot/0/1 rte show tcam psel region entries 9 20 0 100\""
			regionid=1
			while ((regionid <= $maxregion))
			do
				$FOSCMD "rcli -s lc$i \"db $lcslot/0/1 rte show tcam psel region entries $featureid $regionid 0 0\""
				regionid=`expr $regionid + 1`
			done
		done
        $CHASSISCMD "/fabos/cliexec/vrfcmd 1 cat /proc/net/ip_mr_cache" 
	esac
}

# *******************************************
# Collect IGMP data
# ******************************************
start_igmp()
{
	/bin/echo "IGMP Commands:"
	/bin/date
	$CONFDCMD show ip igmp groups detail
	$CONFDCMD show ip igmp interface
	$CONFDCMD show ip igmp snooping
	$CONFDCMD show ip igmp snooping mrouter
	$CMSHCMD  "show ip igmp mcastss groups"
	$CMSHCMD  "show ip igmp remote info"
	$CMSHCMD  "sho ip igmp statistics"
	$CMSHCMD  "show debug igmp global"
	$CMSHCMD  "show debug igmp if"
	$CMSHCMD  "show debug igmp lag"
	$CMSHCMD  "show debug igmp pvlan"
	$CMSHCMD  "show debug igmp rbridge"
}

# *******************************************
# Collect PIM data
# ******************************************
start_pim()
{
	/bin/echo "PIM Commands:"
	/bin/date
	$CONFDCMD show ip pim-sparse
	$CONFDCMD show ip pim neighbor
	$CONFDCMD show ip pim rp-set
	$CONFDCMD show ip pim rp-map
#	$CONFDCMD show ip pim rp-candidate
	$CONFDCMD show ip pim bsr
	$CONFDCMD show ip pim group
	$CONFDCMD show ip pim mcache
	$CONFDCMD show ip pim traffic	
	$CONFDCMD show pim port all	
	$CMSHCMD  "show ip pim rpf-tree all"
	$CMSHCMD  "show ip pim portdb"
	$CMSHCMD  "show ip pim-sparse"
	$CMSHCMD  "show ip pim vif all"
	$CMSHCMD  "show ip pim timers"
	$CMSHCMD  "show ip pim rte-precedence-type"
	$CMSHCMD  "show ip pim prefix-list filters"

    /bin/echo "VRF CONTEXT : 1"
    /bin/echo "/fabos/cliexec/vrfcmd 1 cat /proc/net/ip_mr_rp"
    /fabos/cliexec/vrfcmd 1 cat /proc/net/ip_mr_rp
	/bin/echo "\n\n"
	/bin/echo "/fabos/cliexec/vrfcmd 1 cat /proc/net/ip_mr_vif"
	/fabos/cliexec/vrfcmd 1 cat /proc/net/ip_mr_vif
	/bin/echo "\n\n"
	/bin/echo "/fabos/cliexec/vrfcmd 1 cat /proc/net/ip_mr_cache"
	/fabos/cliexec/vrfcmd 1 cat /proc/net/ip_mr_cache
	/bin/echo "\n\n"

}
# *******************************************
# Collect mcastss data
# ******************************************
start_mcastss()
{
	/bin/echo "MCASTSS Commands:"
	/bin/date
    $CONFDCMD show mcastss vlans
    $CONFDCMD show mcastss mrouter vlans
    $CONFDCMD show mcastss vlanmac
    $CONFDCMD show mcastss vlangrp
	$CONFDCMD show mcastss vif
	$CONFDCMD show mcastss mrt
	$CONFDCMD show mcastss rp
	$CONFDCMD show mcastss grange
	$CONFDCMD show mcastss rte brief
	$CONFDCMD show mcastss rte client
}
# *******************************************
# Collect mld data
# ******************************************
start_mld()
{
	/bin/echo "MLD Commands:"
	/bin/date
    $CONFDCMD show ipv6 mld groups
    $CONFDCMD show ipv6 mld snooping mrouter
}
# *******************************************
# Collect mcagt data
# ******************************************
start_mcagt()
{
	/bin/echo "MCAGT Commands:"
	/bin/date
 	for i in $LC_BLADES; do
    	/bin/echo "MCAGT Debug Commands - slot $i"
    	$CONFDCMD show mcagt group routes slot $i
    	$CONFDCMD show mcagt source routes slot $i
    	$CONFDCMD show mcagt rp list slot $i
    	$CONFDCMD show mcagt vif slot $i
    	$CONFDCMD show mcagt route summary slot $i
	done
}
# To handle multiple params
# for param in $@
#  do
#    if [ "$param" = "--of" ]
#    then
#      outf_enable=1     
#    fi
#  done
    
 for param in $@
  do
    if [ "$param" = "--l2sysuser" ]
    then
      $EXEC_GROUP start_l2sys_user
    fi
    
    if [ "$param" = "--l3user" ]
    then
        $EXEC_GROUP start_l3_user
    fi
    
    if [ "$param" = "--stackvrfuser" ]
    then
        $EXEC_GROUP start_stack_vrf_user
    fi
    
    if [ "$param" = "--l3v6protouser" ]
    then
        $EXEC_GROUP start_v6_proto_user 
	fi	

    if [ "$param" = "--ospfdbuser" ]
    then
        $EXEC_GROUP start_ospfdb_user
    fi
    
    if [ "$param" = "--bgpdbuser" ]
    then
        $EXEC_GROUP start_bgpdb_user
    fi
    
    if [ "$param" = "--bgp6dbuser" ]
    then
        $EXEC_GROUP start_bgp6db_user
    fi
    
    if [ "$param" = "--l3userold" ]
    then
        $EXEC_GROUP start_l3_user_old
    fi
    
    if [ "$param" = "--ssmuser" ]
    then
        $EXEC_GROUP start_ssm_user 
    fi
    
    if [ "$param" = "--ssagtuser" ]
    then
        $EXEC_GROUP start_ssagt_user
    fi

    if [ "$param" = "--qosuser" ]
    then
        $EXEC_GROUP start_qos_user 
    fi

    if [ "$param" = "--tnluser" ]
    then
        $EXEC_GROUP start_tnl_user 
    fi

    if [ "$param" = "--sflowuser" ]
    then
      $EXEC_GROUP start_sflow_user
    fi
    
    if [ "$param" = "--arpuser" ]
    then
        $EXEC_GROUP start_arp_user 
    fi

    if [ "$param" = "--ribmuser" ]
    then
        $EXEC_GROUP start_ribm_user 
    fi
    
    if [ "$param" = "--l3ssuser" ]
    then
        $EXEC_GROUP start_l3ss_user 
    fi
    
    if [ "$param" = "--fibagtuser" ]
    then
        $EXEC_GROUP start_fibagt_user 
    fi
    
    if [ "$param" = "--vlanuser" ]
    then
        $EXEC_GROUP start_vlan_user
    fi
    
    if [ "$param" = "--ceeuser" ]
    then
        $EXEC_GROUP start_cee_user
    fi
    
	if [ "$param" = "--elduser" ]
    then
        $EXEC_GROUP start_eld_user
    fi

    if [ "$param" = "--rpsuser" ]
    then
        $EXEC_GROUP start_rps_user 
    fi

    if [ "$param" = "--mcastall" ]
    then
        $EXEC_GROUP start_igmp
        $EXEC_GROUP start_pim
        $EXEC_GROUP start_mld 
        $EXEC_GROUP start_mcastss
        $EXEC_GROUP start_mcagt 
        #$EXEC_GROUP start_mcast_db 
    fi

    if [ "$param" = "--mcast" ]
    then
        $EXEC_GROUP start_igmp
        $EXEC_GROUP start_pim
        $EXEC_GROUP start_mld 
        $EXEC_GROUP start_mcastss
        $EXEC_GROUP start_mcagt 
        $EXEC_GROUP start_mcast_db 
    fi
    if [ "$param" = "--iphelpuser" ]
    then
        $EXEC_GROUP start_iphelp_user 
    fi
    if [ "$param" = "--openflowuser" ]
    then
        $EXEC_GROUP start_openflow_user
    fi
    
	exit $RETVAL
  done

