#!/bin/sh
#
#    Copyright (c) 1996-2010 Brocade Communications Systems, Inc.
#    All rights reserved.
#
#    File name:   ssave_diag.sh.in
#    Module name: utils/support
#
#    This file expected to be invoked by supportsave infrastructure to 
#    collect FOS/NOS infrastructure
#    related data for switch post fiaure analysis
#
#
PATH=/bin:/usr/bin:/usr/sbin:/fabos/bin:/fabos/link_bin:

ssaveutil="/fabos/cliexec/ssave_util.sh"

#
#include ssave utility
#
if [ -e "$ssaveutil" ]
then
    . $ssaveutil
    rc=$?
    if [ $rc -ne 0 ]
    then
      echo "Error -- $ssaveutil err=$rc"
      exit 3
    fi
else
    echo "Error -- could not locate ssave common library $ssaveutil"
    exit 3
fi

# *******************************************
# Collect DIAG supportsave data
# *******************************************
start_diag()
{
     /bin/echo "Date:"
     date
     /bin/echo""
     /bin/echo "Time Zone:"
     tstimezone
     /bin/echo""
     /bin/echo""
     /bin/echo "Version:"
     version
     /bin/echo""
 
    #Start collecting FAILED POST Logs (stored persistently)
    /bin/echo "POST Failed Logs"
    LOGFILES="`find /var/log -name post*`"
    for f in $LOGFILES ; do
        $CATFILE $f
    done
    /bin/echo ""

    #Start collecting all POST Logs (stored temporarily)
    /bin/echo "POST1 Logs"
    LOGFILES="`find /tmp -name post1*`"
    for f in $LOGFILES ; do
        $CATFILE $f
    done
    /bin/echo ""
    /bin/echo "POST2 Logs"
    LOGFILES="`find /tmp -name post2*`"
    for f in $LOGFILES ; do
        $CATFILE $f
    done
    /bin/echo ""

    #Start collecting Systemverification logs
    /bin/echo "SystemVerification Logs"
    LOGFILES="`find /var/log -name verify*`"
    for f in $LOGFILES ; do
        $CATFILE $f
    done
    /bin/echo ""

    /bin/echo "Burnin status"
    $CHASSISCMD /fabos/sbin/burninstatus
    /bin/echo ""
    
    /bin/echo "Burninerrshow logs"
    case $SW_PLATFORM in
        1000 | 1001 | 1002 | 1003)
            # Standby MM burninerrshow is having some issue.
            # Hence, below logic is required to skip MMs.
            $CHASSISCMD /fabos/cliexec/exec_diag slotshow
            _slot_list=`/fabos/cliexec/exec_diag slotshow | \
                    /usr/bin/tr -s " " " " | \
                    /bin/grep -v "VACANT" | \
                    /bin/grep "BLADE" | \
                    /usr/bin/cut -d" " -f2 | \
                    /usr/bin/xargs /bin/echo`
            for s in $_slot_list ; do
                $CHASSISCMD /fabos/bin/burninerrshow $s
            done
            $CHASSISCMD /fabos/cliexec/exec_diag diagstatus -dbg
        ;;

        *)
            # Pizzabox platforms
            $CHASSISCMD /fabos/bin/burninerrshow
            $CHASSISCMD /fabos/cliexec/exec_diag diagstatus
        ;;
    esac

    /bin/echo ""
}

# To handle multiple params
# for param in $@
#  do
#    if [ "$param" = "--of" ]
#    then
#      outf_enable=1     
#    fi
#  done

#********************Main*****************#
 $RETVAL=0
 for param in $@
  do
    if [ "$param" = "--all" ]
    then
      $EXEC_GROUP start_diag
    fi

    exit $RETVAL
  done

