#!/bin/sh
#
#    Copyright (c) 1996-2012 Brocade Communications Systems, Inc.
#    All rights reserved.
#
#    File name:   ssave_fcoe.sh.in
#
#
#	Description:
#	To collect the fcoe user/sys data in supportsave
#
#

PATH=/bin:/usr/bin:/usr/sbin:/fabos/bin:/fabos/link_bin:

ssaveutil="/fabos/cliexec/ssave_util.sh"

#
#include ssave utility
#
if [ -e "$ssaveutil" ]
then
    . $ssaveutil
    rc=$?
    if [ $rc -ne 0 ]
    then
      echo "Error -- $ssaveutil err=$rc"
      exit 3
    fi
else
    echo "Error -- could not locate ssave common library $ssaveutil"
    exit 3
fi

# *******************************************
# Collect fcoe user supportsave data
# *******************************************
start_fcoe_user()
{
    /bin/echo "FCoE Show Commands"
    $CONFDCMD show fcoe login
    $CONFDCMD show fcoe fabric-map 
    $CONFDCMD show fcoe interface brief
    $CONFDCMD show fcoe internal fcf-mac-address
    $CONFDCMD show fcoe fcoe-map 
    $CONFDCMD show fcoe internal eth-port-table brief
    $CONFDCMD show fcoe internal isl-port-table brief
    $CONFDCMD show fcoe internal vx-port-table brief
    $CONFDCMD show fcoe internal binding-table
    $CONFDCMD show fcoe internal sw-info
    $CONFDCMD show fcoe internal global-info
    $CONFDCMD show fcoe internal dcmd isl-port-table
    $CONFDCMD show fcoe internal dcmd vx-port-table
    $CONFDCMD show fcoe interface ethernet
    $CONFDCMD show interface fcoe
    $CONFDCMD debug lldp dump all
	$CONFDCMD show fcoe internal binding-table 
	$CONFDCMD show fcoe internal cee-state
	$CONFDCMD show fcoe internal dcmd vx-port-table
	$CONFDCMD show fcoe internal ha global-info
	$CONFDCMD show fcoe internal ha stats
	$CONFDCMD show fcoe internal sw-info
    $CONFDCMD show fcoe fcoe-enodes
	$CONFDCMD show fcoe internal cee-event
	$CONFDCMD show fcoe fcf-group 
	$CONFDCMD show fcoe devices
    $CHASSISCMD /bin/ls -l /etc/fabos/fcoed
}

# *******************************************
# Collect fcoe system supportsave data
# *******************************************
start_fcoe_sys()
{
    /bin/echo "FCoE Debug Commands"
    $CONFDCMD debug fcoe show allowed
    $CONFDCMD debug fcoe show allports
    $CONFDCMD debug fcoe show devices
    $CONFDCMD debug fcoe show direct
    $CONFDCMD debug fcoe show ha
    $CONFDCMD debug fcoe show ha_recov_dead_np
    $CONFDCMD debug fcoe show pending
    $CONFDCMD debug fcoe show ptcfg
    $CONFDCMD debug fcoe show servicestats
    $CONFDCMD debug fcoe show swcfg
    $CONFDCMD debug fcoe show all_et_ports
    $CONFDCMD debug fcoe show vpm_dce_ports
    $CONFDCMD debug fcoe show kap
    $CONFDCMD debug fcoe mi show_agents
    $CONFDCMD debug fcoe show eth-ports
    $CONFDCMD debug fcoe show eth-ports-binding
    $CONFDCMD debug fcoe show eth-ports-stats
    $CONFDCMD debug fcoe show enode-binding
    $CONFDCMD debug fcoe show lag-details
	$CONFDCMD debug fcoe show mactbl
	$CONFDCMD debug fcoe show switch_mode
	$CONFDCMD debug fcoe show fcf-mode
	$CONFDCMD debug fcoe show fif_nport_db
	$CONFDCMD debug fcoe show fc_vlan 

    /bin/echo "fcoe_dbg fcoe show mem-stats"
    $CHASSISCMD fcoe_dbg fcoe show mem-stats

}

# To handle multiple params
# for param in $@
#  do
#    if [ "$param" = "--of" ]
#    then
#      outf_enable=1     
#    fi
#  done

for param in $@
	do
	  if [ "$param" = "--fcoeuser" ]
	  then
		  $EXEC_GROUP start_fcoe_user
	  fi

	  if [ "$param" = "--fcoesys" ]
	  then
		  $EXEC_GROUP start_fcoe_sys
	  fi

	done

