#!/bin/bash +x
#
#   Copyright (c) 1996-2012 Brocade Communications Systems, Inc.
#   All rights reserved.
#
#   File name:   ssave_fcping.sh.in
#
#
#   Description:
#   To collect the status of fcping to the remote rbridges and ping on IPoT
#
#

PATH=/bin:/usr/bin:/usr/sbin:/fabos/bin:/fabos/link_bin:/fabos/link_sbin:

ECHO=echo
ssaveutil="/fabos/cliexec/ssave_util.sh"

#
#include ssave utility
#
if [ -e "$ssaveutil" ]
then
	. $ssaveutil
	rc=$?
	if [ $rc -ne 0 ]
	then
		echo "Error -- $ssaveutil err=$rc"
		exit 3
	fi
else
	echo "Error -- could not locate ssave common library $ssaveutil"
	exit 3
fi

date
echo "-----------------------------------------------------------------------------------------"
echo "Statistics of the FC Ping and IPoT Ping for all Rbridges in the fabric"
echo "-----------------------------------------------------------------------------------------"
echo
all_rbridges=(`fabricshow | grep "fffc" |  awk -F ":" '{print $1}'`)
my_rbridge=`switchshow | grep -i rbridge | cut -d ":" -f2`
fc_switches=(`fabricshow | grep "fffc" |  grep -E 'fcr_fd|fcr_xd' | awk -F ":" '{print $1}'`)



#ras_list=(`ls *.RAS`)
i=0
j=0
list_count=${#all_rbridges[*]}
fc_list_count=${#fc_switches[*]}

# Set for outside the while loop for fc_list_count 0 case.
fc_rb=0

while [ $i -lt $list_count ]
do

	c_rb=${all_rbridges[$i]}
	if [ $j -lt $fc_list_count ]
	then
		fc_rb=${fc_switches[$j]}
	fi

	if [ $c_rb -ne $my_rbridge ]
	then

		date
		echo "FCPING ${c_rb}"
		fcping $c_rb --number 1
		let 'j+=1'

		if [ $c_rb -ne $fc_rb ]
		then
			echo
			echo "IPoT PING 127.1.0.${c_rb}"
			ping 127.1.0.$c_rb -c 1 -w 3
		else
			echo
			echo "SKIP IPoT PING FOR FC DOMAIN ${c_rb}"
		fi

		echo "--------------------------------------------------------------------------------------"
		echo
	fi

	let 'i+=1'

done
date
