#!/bin/sh
#
#    Copyright (c) 1996-2012 Brocade Communications Systems, Inc.
#    All rights reserved.
#
#    File name:   ssave_pem.sh.in
#    Module name: utils/support
#
#    This file expected to be invoked by supportsave infrastructure to 
#    collect logs generated by PEM module
#
#
PATH=/bin:/usr/bin:/usr/sbin:/fabos/bin:/fabos/link_bin:

ssaveutil="/fabos/cliexec/ssave_util.sh"

#
#include ssave utility
#
if [ -e "$ssaveutil" ]
then
    . $ssaveutil
    rc=$?
    if [ $rc -ne 0 ]
    then
      echo "Error -- $ssaveutil err=$rc"
      exit 3
    fi
else
    echo "Error -- could not locate ssave common library $ssaveutil"
    exit 3
fi

# *******************************************
# Collect PEM supportsave data
# *******************************************
start_pem()
{
	\rm -fr /tmp/pemlogs/
	/bin/mkdir /tmp/pemlogs/
	/bin/cp -R /var/pem/* /tmp/pemlogs/ 2> /dev/null
    /bin/cp /var/config/vcs/scripts/* /var/pem/action/ 2> /dev/null

    $CONFDCMD show running event-handler >> /tmp/pemlogs/show_cli.logs
    $CONFDCMD show running rbridge event-handler >> /tmp/pemlogs/show_cli.logs
    $CONFDCMD show event-handler activations >> /tmp/pemlogs/show_cli.logs

	cd /tmp/
	/bin/tar cvf /tmp/pemlogs.tar pemlogs 2> /dev/null
}

# To handle multiple params
# for param in $@
#  do
#    if [ "$param" = "--of" ]
#    then
#      outf_enable=1     
#    fi
#  done

#********************Main*****************#
$RETVAL=0
for param in $@
	do
		if [ "$param" = "--all" ]
		then
		  $EXEC_GROUP start_pem
		fi

	exit $RETVAL
done


