#!/bin/sh
#
#	Copyright (c) 1996-2012 Brocade Communications Systems, Inc.
#	All rights reserved.
#
#	File name:   ssave_fcoe.sh.in
#
#
#	Description:
#	To collect the port related data in supportsave
#
#

PATH=/bin:/usr/bin:/usr/sbin:/fabos/bin:/fabos/link_bin:/fabos/link_sbin:

ECHO=echo
ssaveutil="/fabos/cliexec/ssave_util.sh"

#
#include ssave utility
#
if [ -e "$ssaveutil" ]
then
    . $ssaveutil
    rc=$?
    if [ $rc -ne 0 ]
    then
      echo "Error -- $ssaveutil err=$rc"
      exit 3
    fi
else
    echo "Error -- could not locate ssave common library $ssaveutil"
    exit 3
fi

case $SW_PLATFORM in

	96 | 97 | 107)
		slot=0;;

	1000 | 1001 | 1002 | 1003)
		#Add commands specific to Mercury
		;;

	*)
		echo "unknown platform"
		;;
esac

start_fe_port_stats()
{
	# don't dump this information on standby cp
	if [ "$STANDBY" = "TRUE" ]
	then
		return
	fi
	fcexternal_pt=`switchshow | grep "FC " | grep -v Router | tr -s " " | sed -e 's/^ *//' | cut -d " " -f1`

	for i in $fcexternal_pt
	do
		echo Port Statistics for FE port $i
		$SWITCHCMD /fabos/cliexec/portstatsshow $slot/$i
		echo "########################################"
	done
}

start_bi_port_stats()
{
	if [ "$STANDBY" = "TRUE" ]
	then
		return
	fi

	echo Statistics collection for the Internal ports

	internal_pt=`/fabos/link_bin/bladeportmap | grep CONDOR2 | grep :$ | grep -v NULL | tr -s " " | cut -d " " -f2`

	for i in $internal_pt
	do
		$SWITCHCMD /fabos/link_bin/ptstatsshow 0/$i
		echo "########################################"
	done
}

port_stats()
{
	$SWITCHCMD /fabos/cliexec/portlogdump
	# Persistent portlogdump
	$SWITCHCMD /fabos/cliexec/portlogdump 0,1
	#portshow 
	switchshow | grep -E 'TRILL|FCOE|FCoE| FC' | awk '{print $1}' | while read line
	do
	port=$(echo $line)
	$ECHO "portshow"
	$CHASSISCMD /bin/cat /proc/fabos/switch/0/$port/info
	done
	$CHASSISCMD /bin/cat /proc/fabos/switch/0/port2area_info
	$CHASSISCMD /bin/cat /proc/fabos/switch/0/area2port_info

}

$EXEC_GROUP port_stats

case $SW_PLATFORM in

	96 | 97 | 107)
		$EXEC_GROUP start_fe_port_stats
		$EXEC_GROUP start_bi_port_stats
		;;

	1000 | 1001 | 1002 | 1003)
		#Add commands specific to Mercury
		;;

	*)
		echo "Not a Fibre Channel NOS Platform"
		;;
esac
