#!/bin/sh
#
#    Copyright (c) 2010 Brocade Communications Systems, Inc.
#    All rights reserved.
#
#    File name:   ssave_sfi.sh
#    Module name: utils/support
#
#    This file expected to be invoked by supportsave infrastructure to collect FOS/NOS security
#    related data for switch post failure analysis
#
#
PATH=/bin:/usr/bin:/usr/sbin:/fabos/bin:/fabos/link_bin:

ssaveutil="/fabos/cliexec/ssave_util.sh"

#
#include ssave utility
#
if [ -e "$ssaveutil" ]
then
    . $ssaveutil
#    echo "exe $ssaveutil"
    rc=$?
    if [ $rc -ne 0 ]
    then
      echo "exe:$ssaveutil err=$rc"
      exit 3
    fi

else
    echo "Error -- could not locate ssave common library $ssaveutil"
    exit 3
fi

# *******************************************
# Collect pre supportsave data
# *******************************************
start_dump()
{
  $CHASSISCMD /fabos/link_abin/aaaConfig --show

  /bin/echo "Current User: $LOGIN_ID"
  # /bin/echo "userconfig --show -a:"
  # This command displays results page-wise using a character input.
  # So, /usr/bin/yes is used to supply the character.
  if [ $standby = no ]
  then
    /usr/bin/yes | $SWITCHCMD /fabos/link_bin/userconfig --show -a
  fi
  /bin/echo ""

  $CHASSISCMD /fabos/link_abin/passwdcfg --showall
  $CHASSISCMD /fabos/link_abin/rolecfgshow
  $CHASSISCMD /fabos/link_sbin/bannershow
  $CHASSISCMD /fabos/link_bin/date
  $CHASSISCMD /fabos/link_bin/tsStat
  $CHASSISCMD /fabos/link_bin/tsTimeZone
  $CHASSISCMD authutil --dump -a
}


# *******************************************
# Collect pre supportsave data
# *******************************************
start_confd_ras()
{
    $CONFDCMD show cli
    $CONFDCMD show clock rbridge-id all
    $CONFDCMD show ntp status rbridge-id all
    $CONFDCMD show fcsp authsecret dhchap
    $CONFDCMD show cert-util ldapcacert
    $CONFDCMD show cert-util syslogcacert
}

############## main

for param in $@
do
	if [ "$param" = "--internal" ]
	then
		$EXEC_GROUP start_dump
	fi

	if [ "$param" = "--user" ]
	then
		$EXEC_GROUP start_confd_ras
	fi

	exit $RETVAL
done
