#!/bin/sh
#
#    Copyright (c) 1996-2012 Brocade Communications Systems, Inc.
#    All rights reserved.
#
#    File name:   ssave_tha.sh.in
#    Module name: utils/support
#
#    This file expected to be invoked by supportsave infrastructure to 
#    collect FOS/NOS infrastructure
#    related data for switch post fiaure analysis
#
#
PATH=/bin:/usr/bin:/usr/sbin:/fabos/bin:/fabos/link_bin:

ssaveutil="/fabos/cliexec/ssave_util.sh"

#
#include ssave utility
#
if [ -e "$ssaveutil" ]
then
    . $ssaveutil
    rc=$?
    if [ $rc -ne 0 ]
    then
      echo "Error -- $ssaveutil err=$rc"
      exit 3
    fi
else
    echo "Error -- could not locate ssave common library $ssaveutil"
    exit 3
fi

# *******************************************
# Collect THA supportsave data
# *******************************************
start_tha()
{
	/fabos/bin/thainfo > /tmp/tha/halog_thainfo
	cat /proc/ctm/dump > /tmp/tha/halog_ctm
	/bin/tar cvf /tmp/thalogs.tar /tmp/tha/halog* 2> /dev/null
}

# To handle multiple params
# for param in $@
#  do
#    if [ "$param" = "--of" ]
#    then
#      outf_enable=1     
#    fi
#  done

#********************Main*****************#
$RETVAL=0
for param in $@
	do
		if [ "$param" = "--all" ]
		then
		  $EXEC_GROUP start_tha
		fi

	exit $RETVAL
done


